/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1073MP7JRSINKMEDIAINFORMATIONTYPE_PARAM_LOCALTYPE_H
#define _1073MP7JRSINKMEDIAINFORMATIONTYPE_PARAM_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInkMediaInformationType_Param_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Param_LocalType_ExtInclude.h


class IMp7JrsInkMediaInformationType_Param_LocalType;
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Param_LocalType> Mp7JrsInkMediaInformationType_Param_LocalPtr;

/** 
 * Generated interface IMp7JrsInkMediaInformationType_Param_LocalType for class Mp7JrsInkMediaInformationType_Param_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 6362<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsInkMediaInformationType_Param_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsInkMediaInformationType_Param_LocalType();
    virtual ~IMp7JrsInkMediaInformationType_Param_LocalType();
    /**
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const = 0;

    /**
     * Get name attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existname() const = 0;

    /**
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate name attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatename() = 0;

    /**
     * Get value attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getvalue() const = 0;

    /**
     * Get value attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existvalue() const = 0;

    /**
     * Set value attribute.
     * @param item XMLCh *
     */
    virtual void Setvalue(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate value attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatevalue() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of InkMediaInformationType_Param_LocalType.
     * Currently just supports rudimentary XPath expressions as InkMediaInformationType_Param_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Param_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Param_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInkMediaInformationType_Param_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 6362<br>
 * Classified: Class<br>
 * Defined in mpeg7-2004.xsd, line 6362.<br>
 */
class MP7JRS_EXPORT Mp7JrsInkMediaInformationType_Param_LocalType :
        public IMp7JrsInkMediaInformationType_Param_LocalType
{
    friend class Mp7JrsInkMediaInformationType_Param_LocalTypeFactory; // constructs objects

public:
    /*
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const;

    /*
     * Get name attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existname() const;

    /*
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate name attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatename();

    /*
     * Get value attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getvalue() const;

    /*
     * Get value attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existvalue() const;

    /*
     * Set value attribute.
     * @param item XMLCh *
     */
    virtual void Setvalue(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate value attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatevalue();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of InkMediaInformationType_Param_LocalType.
     * Currently just supports rudimentary XPath expressions as InkMediaInformationType_Param_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Param_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInkMediaInformationType_Param_LocalType();

protected:
    Mp7JrsInkMediaInformationType_Param_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_name;
    bool m_name_Exist;
    XMLCh * m_value;
    bool m_value_Exist;



// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Param_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1073MP7JRSINKMEDIAINFORMATIONTYPE_PARAM_LOCALTYPE_H

