 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtImplInclude.h



#include "Mp7JrsminusOneToOneType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsAffectiveType_Score_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsAffectiveType_Score_LocalType::IMp7JrsAffectiveType_Score_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtPropInit.h

}

IMp7JrsAffectiveType_Score_LocalType::~IMp7JrsAffectiveType_Score_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtPropCleanup.h

}

Mp7JrsAffectiveType_Score_LocalType::Mp7JrsAffectiveType_Score_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAffectiveType_Score_LocalType::~Mp7JrsAffectiveType_Score_LocalType()
{
	Cleanup();
}

void Mp7JrsAffectiveType_Score_LocalType::Init()
{
	// Init base
	m_Base = CreateminusOneToOneType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_idref = NULL; // String
	m_idref_Exist = false;
	m_xpath = Mp7JrsxPathRefPtr(); // Pattern
	m_xpath_Exist = false;
	m_href = NULL; // String
	m_href_Exist = false;



// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtMyPropInit.h

}

void Mp7JrsAffectiveType_Score_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	XMLString::release(&m_idref);
	// Mp7JrsFactory::DeleteObject(m_xpath); 
	XMLString::release(&m_href);
}

void Mp7JrsAffectiveType_Score_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AffectiveType_Score_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IAffectiveType_Score_LocalType
    const Mp7JrsPtr< Mp7JrsAffectiveType_Score_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsminusOneToOnePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsAffectiveType_Score_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	XMLString::release(&m_idref);
	if (tmp->Existidref())
	{
		this->Setidref(XMLString::replicate(tmp->Getidref()));
	}
	else
	{
		Invalidateidref();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_xpath); 
	if (tmp->Existxpath())
	{
		this->Setxpath(Mp7JrsFactory::CloneObject(tmp->Getxpath()));
	}
	else
	{
		Invalidatexpath();
	}
	}
	{
	XMLString::release(&m_href);
	if (tmp->Existhref())
	{
		this->Sethref(XMLString::replicate(tmp->Gethref()));
	}
	else
	{
		Invalidatehref();
	}
	}
}

Mp7JrsNodePtr Mp7JrsAffectiveType_Score_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsAffectiveType_Score_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsminusOneToOneType > Mp7JrsAffectiveType_Score_LocalType::GetBase() const
{
	return m_Base;
}

void Mp7JrsAffectiveType_Score_LocalType::SetContent(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAffectiveType_Score_LocalType::SetContent().");
	}
	GetBase()->SetContent(item);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsAffectiveType_Score_LocalType::GetContent() const
{
	return GetBase()->GetContent();
}
XMLCh * Mp7JrsAffectiveType_Score_LocalType::Getidref() const
{
	return m_idref;
}

bool Mp7JrsAffectiveType_Score_LocalType::Existidref() const
{
	return m_idref_Exist;
}
void Mp7JrsAffectiveType_Score_LocalType::Setidref(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAffectiveType_Score_LocalType::Setidref().");
	}
    m_idref = item;
	m_idref_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAffectiveType_Score_LocalType::Invalidateidref()
{
	m_idref_Exist = false;
}
Mp7JrsxPathRefPtr Mp7JrsAffectiveType_Score_LocalType::Getxpath() const
{
	return m_xpath;
}

bool Mp7JrsAffectiveType_Score_LocalType::Existxpath() const
{
	return m_xpath_Exist;
}
void Mp7JrsAffectiveType_Score_LocalType::Setxpath(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAffectiveType_Score_LocalType::Setxpath().");
	}
    m_xpath = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_xpath) m_xpath->SetParent(m_myself.getPointer());
	m_xpath_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAffectiveType_Score_LocalType::Invalidatexpath()
{
	m_xpath_Exist = false;
}
XMLCh * Mp7JrsAffectiveType_Score_LocalType::Gethref() const
{
	return m_href;
}

bool Mp7JrsAffectiveType_Score_LocalType::Existhref() const
{
	return m_href_Exist;
}
void Mp7JrsAffectiveType_Score_LocalType::Sethref(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAffectiveType_Score_LocalType::Sethref().");
	}
    m_href = item;
	m_href_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAffectiveType_Score_LocalType::Invalidatehref()
{
	m_href_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsAffectiveType_Score_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for AffectiveType_Score_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "AffectiveType_Score_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsAffectiveType_Score_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsAffectiveType_Score_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsAffectiveType_Score_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsAffectiveType_Score_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsAffectiveType_Score_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("AffectiveType_Score_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_idref_Exist)
	{
	// String
	if(m_idref != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("idref"), m_idref);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_xpath_Exist)
	{
	// Pattern
	if (m_xpath != Mp7JrsxPathRefPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_xpath->ToText();
		element->setAttributeNS(X(""), X("xpath"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_href_Exist)
	{
	// String
	if(m_href != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("href"), m_href);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsAffectiveType_Score_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("idref")))
	{
        // Deserialize string type
        this->Setidref(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("idref"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("idref")))
	{
        // Deserialize string type
        this->Setidref(Mp7JrsConvert::TextToString(parent->getAttribute(X("idref"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("xpath")))
	{
        Mp7JrsxPathRefPtr tmp = CreatexPathRefType;
        tmp->Parse(parent->getAttributeNS(X(""), X("xpath")));
        this->Setxpath(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("xpath")))
	{
        Mp7JrsxPathRefPtr tmp = CreatexPathRefType;
        tmp->Parse(parent->getAttribute(X("xpath")));
        this->Setxpath(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("href")))
	{
        // Deserialize string type
        this->Sethref(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("href"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("href")))
	{
        // Deserialize string type
        this->Sethref(Mp7JrsConvert::TextToString(parent->getAttribute(X("href"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsminusOneToOneType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAffectiveType_Score_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAffectiveType_Score_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAffectiveType_Score_LocalType_ExtMethodImpl.h


