 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtImplInclude.h



#include "Mp7JrsSeriesOfScalarType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsfloatVector.h"
#include "Mp7JrsScalableSeriesType_Scaling_CollectionType.h"
#include "Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsScalableSeriesType_Scaling_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Scaling

#include <assert.h>
IMp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IMp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtPropInit.h

}

IMp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::~IMp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtPropCleanup.h

}

Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::~Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType()
{
	Cleanup();
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::Init()
{
	// Init base
	m_Base = CreateSeriesOfScalarType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_hopSize = Mp7JrsmediaDurationPtr(); // Pattern
	m_hopSize_Default = CreatemediaDurationType;
	m_hopSize_Default->Parse(X("PT10N1000F"));
	m_hopSize_Exist = false;



// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtMyPropInit.h

}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_hopSize); 
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AudioLLDScalarType_SeriesOfScalar_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IAudioLLDScalarType_SeriesOfScalar_LocalType
    const Mp7JrsPtr< Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsSeriesOfScalarPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_hopSize); 
	if (tmp->ExisthopSize())
	{
		this->SethopSize(Mp7JrsFactory::CloneObject(tmp->GethopSize()));
	}
	else
	{
		InvalidatehopSize();
	}
	}
}

Mp7JrsNodePtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsSeriesOfScalarType > Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsmediaDurationPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GethopSize() const
{
	if (this->ExisthopSize()) {
		return m_hopSize;
	} else {
		return m_hopSize_Default;
	}
}

bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::ExisthopSize() const
{
	return m_hopSize_Exist;
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SethopSize(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SethopSize().");
	}
    m_hopSize = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_hopSize) m_hopSize->SetParent(m_myself.getPointer());
	m_hopSize_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidatehopSize()
{
	m_hopSize_Exist = false;
}
Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetRaw() const
{
	return GetBase()->GetRaw();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidRaw() const
{
	return GetBase()->IsValidRaw();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetMin() const
{
	return GetBase()->GetMin();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidMin() const
{
	return GetBase()->IsValidMin();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetMax() const
{
	return GetBase()->GetMax();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidMax() const
{
	return GetBase()->IsValidMax();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetMean() const
{
	return GetBase()->GetMean();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidMean() const
{
	return GetBase()->IsValidMean();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetRandom() const
{
	return GetBase()->GetRandom();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidRandom() const
{
	return GetBase()->IsValidRandom();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetFirst() const
{
	return GetBase()->GetFirst();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidFirst() const
{
	return GetBase()->IsValidFirst();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetLast() const
{
	return GetBase()->GetLast();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidLast() const
{
	return GetBase()->IsValidLast();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetVariance() const
{
	return GetBase()->GetVariance();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidVariance() const
{
	return GetBase()->IsValidVariance();
}

Mp7JrsfloatVectorPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetWeight() const
{
	return GetBase()->GetWeight();
}

// Element is optional
bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::IsValidWeight() const
{
	return GetBase()->IsValidWeight();
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetRaw(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetRaw().");
	}
	GetBase()->SetRaw(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateRaw()
{
	GetBase()->InvalidateRaw();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetMin(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetMin().");
	}
	GetBase()->SetMin(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateMin()
{
	GetBase()->InvalidateMin();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetMax(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetMax().");
	}
	GetBase()->SetMax(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateMax()
{
	GetBase()->InvalidateMax();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetMean(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetMean().");
	}
	GetBase()->SetMean(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateMean()
{
	GetBase()->InvalidateMean();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetRandom(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetRandom().");
	}
	GetBase()->SetRandom(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateRandom()
{
	GetBase()->InvalidateRandom();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetFirst(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetFirst().");
	}
	GetBase()->SetFirst(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateFirst()
{
	GetBase()->InvalidateFirst();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetLast(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetLast().");
	}
	GetBase()->SetLast(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateLast()
{
	GetBase()->InvalidateLast();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetVariance(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetVariance().");
	}
	GetBase()->SetVariance(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateVariance()
{
	GetBase()->InvalidateVariance();
}
void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetWeight(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetWeight().");
	}
	GetBase()->SetWeight(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::InvalidateWeight()
{
	GetBase()->InvalidateWeight();
}
unsigned Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GettotalNumOfSamples() const
{
	return GetBase()->GetBase()->GettotalNumOfSamples();
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SettotalNumOfSamples(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SettotalNumOfSamples().");
	}
	GetBase()->GetBase()->SettotalNumOfSamples(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsScalableSeriesType_Scaling_CollectionPtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetScaling() const
{
	return GetBase()->GetBase()->GetScaling();
}

void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetScaling(const Mp7JrsScalableSeriesType_Scaling_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::SetScaling().");
	}
	GetBase()->GetBase()->SetScaling(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for AudioLLDScalarType_SeriesOfScalar_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "AudioLLDScalarType_SeriesOfScalar_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("AudioLLDScalarType_SeriesOfScalar_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_hopSize_Exist)
	{
	// Pattern
	if (m_hopSize != Mp7JrsmediaDurationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_hopSize->ToText();
		element->setAttributeNS(X(""), X("hopSize"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("hopSize")))
	{
        Mp7JrsmediaDurationPtr tmp = CreatemediaDurationType;
        tmp->Parse(parent->getAttributeNS(X(""), X("hopSize")));
        this->SethopSize(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("hopSize")))
	{
        Mp7JrsmediaDurationPtr tmp = CreatemediaDurationType;
        tmp->Parse(parent->getAttribute(X("hopSize")));
        this->SethopSize(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsSeriesOfScalarType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetRaw() != Mp7JrsNodePtr())
		result.Insert(GetRaw());
	if (GetMin() != Mp7JrsNodePtr())
		result.Insert(GetMin());
	if (GetMax() != Mp7JrsNodePtr())
		result.Insert(GetMax());
	if (GetMean() != Mp7JrsNodePtr())
		result.Insert(GetMean());
	if (GetRandom() != Mp7JrsNodePtr())
		result.Insert(GetRandom());
	if (GetFirst() != Mp7JrsNodePtr())
		result.Insert(GetFirst());
	if (GetLast() != Mp7JrsNodePtr())
		result.Insert(GetLast());
	if (GetVariance() != Mp7JrsNodePtr())
		result.Insert(GetVariance());
	if (GetWeight() != Mp7JrsNodePtr())
		result.Insert(GetWeight());
	if (GetScaling() != Mp7JrsNodePtr())
		result.Insert(GetScaling());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType_ExtMethodImpl.h


