 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtImplInclude.h



#include "Mp7JrsAudioVisualRegionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsVideoSegmentType.h"
#include "Mp7JrsMovingRegionType.h"
#include "Mp7JrsStillRegionType.h"
#include "Mp7JrsAudioSegmentType.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtPropInit.h

}

IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::~IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtPropCleanup.h

}

Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::~Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType()
{
	Cleanup();
}

void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr(); // Class
	m_AudioVisualRegionRef = Mp7JrsReferencePtr(); // Class
	m_VideoSegment = Mp7JrsVideoSegmentPtr(); // Class
	m_VideoSegmentRef = Mp7JrsReferencePtr(); // Class
	m_MovingRegion = Mp7JrsMovingRegionPtr(); // Class
	m_MovingRegionRef = Mp7JrsReferencePtr(); // Class
	m_StillRegion = Mp7JrsStillRegionPtr(); // Class
	m_StillRegionRef = Mp7JrsReferencePtr(); // Class
	m_AudioSegment = Mp7JrsAudioSegmentPtr(); // Class
	m_AudioSegmentRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
}

void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AudioVisualRegionMediaSourceDecompositionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IAudioVisualRegionMediaSourceDecompositionType_LocalType
    const Mp7JrsPtr< Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
		this->SetAudioVisualRegion(Mp7JrsFactory::CloneObject(tmp->GetAudioVisualRegion()));
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
		this->SetAudioVisualRegionRef(Mp7JrsFactory::CloneObject(tmp->GetAudioVisualRegionRef()));
		// Mp7JrsFactory::DeleteObject(m_VideoSegment);
		this->SetVideoSegment(Mp7JrsFactory::CloneObject(tmp->GetVideoSegment()));
		// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
		this->SetVideoSegmentRef(Mp7JrsFactory::CloneObject(tmp->GetVideoSegmentRef()));
		// Mp7JrsFactory::DeleteObject(m_MovingRegion);
		this->SetMovingRegion(Mp7JrsFactory::CloneObject(tmp->GetMovingRegion()));
		// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
		this->SetMovingRegionRef(Mp7JrsFactory::CloneObject(tmp->GetMovingRegionRef()));
		// Mp7JrsFactory::DeleteObject(m_StillRegion);
		this->SetStillRegion(Mp7JrsFactory::CloneObject(tmp->GetStillRegion()));
		// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
		this->SetStillRegionRef(Mp7JrsFactory::CloneObject(tmp->GetStillRegionRef()));
		// Mp7JrsFactory::DeleteObject(m_AudioSegment);
		this->SetAudioSegment(Mp7JrsFactory::CloneObject(tmp->GetAudioSegment()));
		// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
		this->SetAudioSegmentRef(Mp7JrsFactory::CloneObject(tmp->GetAudioSegmentRef()));
}

Mp7JrsNodePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsAudioVisualRegionPtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetAudioVisualRegion() const
{
	return m_AudioVisualRegion;
}

Mp7JrsReferencePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetAudioVisualRegionRef() const
{
	return m_AudioVisualRegionRef;
}

Mp7JrsVideoSegmentPtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetVideoSegment() const
{
	return m_VideoSegment;
}

Mp7JrsReferencePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetVideoSegmentRef() const
{
	return m_VideoSegmentRef;
}

Mp7JrsMovingRegionPtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetMovingRegion() const
{
	return m_MovingRegion;
}

Mp7JrsReferencePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetMovingRegionRef() const
{
	return m_MovingRegionRef;
}

Mp7JrsStillRegionPtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetStillRegion() const
{
	return m_StillRegion;
}

Mp7JrsReferencePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetStillRegionRef() const
{
	return m_StillRegionRef;
}

Mp7JrsAudioSegmentPtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetAudioSegment() const
{
	return m_AudioSegment;
}

Mp7JrsReferencePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetAudioSegmentRef() const
{
	return m_AudioSegmentRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioVisualRegion(const Mp7JrsAudioVisualRegionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioVisualRegion().");
	}
	if (m_AudioVisualRegion != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
		m_AudioVisualRegion = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioVisualRegion) m_AudioVisualRegion->SetParent(m_myself.getPointer());
		if (m_AudioVisualRegion && m_AudioVisualRegion->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AudioVisualRegionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioVisualRegion->UseTypeAttribute = true;
		}
		if(m_AudioVisualRegion != Mp7JrsAudioVisualRegionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioVisualRegion->SetContentName(XMLString::transcode("AudioVisualRegion"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioVisualRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioVisualRegionRef().");
	}
	if (m_AudioVisualRegionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
		m_AudioVisualRegionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioVisualRegionRef) m_AudioVisualRegionRef->SetParent(m_myself.getPointer());
		if (m_AudioVisualRegionRef && m_AudioVisualRegionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioVisualRegionRef->UseTypeAttribute = true;
		}
		if(m_AudioVisualRegionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioVisualRegionRef->SetContentName(XMLString::transcode("AudioVisualRegionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetVideoSegment(const Mp7JrsVideoSegmentPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetVideoSegment().");
	}
	if (m_VideoSegment != item)
	{
		// Mp7JrsFactory::DeleteObject(m_VideoSegment);
		m_VideoSegment = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_VideoSegment) m_VideoSegment->SetParent(m_myself.getPointer());
		if (m_VideoSegment && m_VideoSegment->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:VideoSegmentType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_VideoSegment->UseTypeAttribute = true;
		}
		if(m_VideoSegment != Mp7JrsVideoSegmentPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_VideoSegment->SetContentName(XMLString::transcode("VideoSegment"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetVideoSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetVideoSegmentRef().");
	}
	if (m_VideoSegmentRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
		m_VideoSegmentRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_VideoSegmentRef) m_VideoSegmentRef->SetParent(m_myself.getPointer());
		if (m_VideoSegmentRef && m_VideoSegmentRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_VideoSegmentRef->UseTypeAttribute = true;
		}
		if(m_VideoSegmentRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_VideoSegmentRef->SetContentName(XMLString::transcode("VideoSegmentRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetMovingRegion(const Mp7JrsMovingRegionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetMovingRegion().");
	}
	if (m_MovingRegion != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MovingRegion);
		m_MovingRegion = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MovingRegion) m_MovingRegion->SetParent(m_myself.getPointer());
		if (m_MovingRegion && m_MovingRegion->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MovingRegionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MovingRegion->UseTypeAttribute = true;
		}
		if(m_MovingRegion != Mp7JrsMovingRegionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MovingRegion->SetContentName(XMLString::transcode("MovingRegion"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetMovingRegionRef().");
	}
	if (m_MovingRegionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
		m_MovingRegionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MovingRegionRef) m_MovingRegionRef->SetParent(m_myself.getPointer());
		if (m_MovingRegionRef && m_MovingRegionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MovingRegionRef->UseTypeAttribute = true;
		}
		if(m_MovingRegionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MovingRegionRef->SetContentName(XMLString::transcode("MovingRegionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetStillRegion(const Mp7JrsStillRegionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetStillRegion().");
	}
	if (m_StillRegion != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StillRegion);
		m_StillRegion = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StillRegion) m_StillRegion->SetParent(m_myself.getPointer());
		if (m_StillRegion && m_StillRegion->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:StillRegionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_StillRegion->UseTypeAttribute = true;
		}
		if(m_StillRegion != Mp7JrsStillRegionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_StillRegion->SetContentName(XMLString::transcode("StillRegion"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetStillRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetStillRegionRef().");
	}
	if (m_StillRegionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
		m_StillRegionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StillRegionRef) m_StillRegionRef->SetParent(m_myself.getPointer());
		if (m_StillRegionRef && m_StillRegionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_StillRegionRef->UseTypeAttribute = true;
		}
		if(m_StillRegionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_StillRegionRef->SetContentName(XMLString::transcode("StillRegionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioSegment(const Mp7JrsAudioSegmentPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioSegment().");
	}
	if (m_AudioSegment != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioSegment);
		m_AudioSegment = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioSegment) m_AudioSegment->SetParent(m_myself.getPointer());
		if (m_AudioSegment && m_AudioSegment->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AudioSegmentType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioSegment->UseTypeAttribute = true;
		}
		if(m_AudioSegment != Mp7JrsAudioSegmentPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioSegment->SetContentName(XMLString::transcode("AudioSegment"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
	m_AudioSegmentRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::SetAudioSegmentRef().");
	}
	if (m_AudioSegmentRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioSegmentRef);
		m_AudioSegmentRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioSegmentRef) m_AudioSegmentRef->SetParent(m_myself.getPointer());
		if (m_AudioSegmentRef && m_AudioSegmentRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioSegmentRef->UseTypeAttribute = true;
		}
		if(m_AudioSegmentRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioSegmentRef->SetContentName(XMLString::transcode("AudioSegmentRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegment);
	m_VideoSegment = Mp7JrsVideoSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_VideoSegmentRef);
	m_VideoSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegion);
	m_StillRegion = Mp7JrsStillRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_StillRegionRef);
	m_StillRegionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioSegment);
	m_AudioSegment = Mp7JrsAudioSegmentPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: AudioVisualRegionMediaSourceDecompositionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_AudioVisualRegion != Mp7JrsAudioVisualRegionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioVisualRegion->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioVisualRegion"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioVisualRegion->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_AudioVisualRegionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioVisualRegionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioVisualRegionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioVisualRegionRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_VideoSegment != Mp7JrsVideoSegmentPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_VideoSegment->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("VideoSegment"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_VideoSegment->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_VideoSegmentRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_VideoSegmentRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("VideoSegmentRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_VideoSegmentRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MovingRegion != Mp7JrsMovingRegionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MovingRegion->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MovingRegion"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MovingRegion->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MovingRegionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MovingRegionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MovingRegionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MovingRegionRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_StillRegion != Mp7JrsStillRegionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_StillRegion->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("StillRegion"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_StillRegion->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_StillRegionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_StillRegionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("StillRegionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_StillRegionRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_AudioSegment != Mp7JrsAudioSegmentPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioSegment->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioSegment"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioSegment->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_AudioSegmentRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioSegmentRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioSegmentRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioSegmentRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioVisualRegion"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioVisualRegion")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAudioVisualRegionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioVisualRegion(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioVisualRegionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioVisualRegionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioVisualRegionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("VideoSegment"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("VideoSegment")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateVideoSegmentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVideoSegment(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("VideoSegmentRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("VideoSegmentRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVideoSegmentRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MovingRegion"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MovingRegion")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMovingRegionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMovingRegion(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MovingRegionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MovingRegionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMovingRegionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("StillRegion"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("StillRegion")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateStillRegionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetStillRegion(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("StillRegionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("StillRegionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetStillRegionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioSegment"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioSegment")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAudioSegmentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioSegment(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioSegmentRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioSegmentRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioSegmentRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("AudioVisualRegion")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAudioVisualRegionType;
    }
    this->SetAudioVisualRegion(child);
  }
  if (XMLString::compareString(elementname, X("AudioVisualRegionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetAudioVisualRegionRef(child);
  }
  if (XMLString::compareString(elementname, X("VideoSegment")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateVideoSegmentType;
    }
    this->SetVideoSegment(child);
  }
  if (XMLString::compareString(elementname, X("VideoSegmentRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetVideoSegmentRef(child);
  }
  if (XMLString::compareString(elementname, X("MovingRegion")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMovingRegionType;
    }
    this->SetMovingRegion(child);
  }
  if (XMLString::compareString(elementname, X("MovingRegionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetMovingRegionRef(child);
  }
  if (XMLString::compareString(elementname, X("StillRegion")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateStillRegionType;
    }
    this->SetStillRegion(child);
  }
  if (XMLString::compareString(elementname, X("StillRegionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetStillRegionRef(child);
  }
  if (XMLString::compareString(elementname, X("AudioSegment")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAudioSegmentType;
    }
    this->SetAudioSegment(child);
  }
  if (XMLString::compareString(elementname, X("AudioSegmentRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetAudioSegmentRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetAudioVisualRegion() != Mp7JrsNodePtr())
		result.Insert(GetAudioVisualRegion());
	if (GetAudioVisualRegionRef() != Mp7JrsNodePtr())
		result.Insert(GetAudioVisualRegionRef());
	if (GetVideoSegment() != Mp7JrsNodePtr())
		result.Insert(GetVideoSegment());
	if (GetVideoSegmentRef() != Mp7JrsNodePtr())
		result.Insert(GetVideoSegmentRef());
	if (GetMovingRegion() != Mp7JrsNodePtr())
		result.Insert(GetMovingRegion());
	if (GetMovingRegionRef() != Mp7JrsNodePtr())
		result.Insert(GetMovingRegionRef());
	if (GetStillRegion() != Mp7JrsNodePtr())
		result.Insert(GetStillRegion());
	if (GetStillRegionRef() != Mp7JrsNodePtr())
		result.Insert(GetStillRegionRef());
	if (GetAudioSegment() != Mp7JrsNodePtr())
		result.Insert(GetAudioSegment());
	if (GetAudioSegmentRef() != Mp7JrsNodePtr())
		result.Insert(GetAudioSegmentRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtMethodImpl.h


