 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType_ExtImplInclude.h



#include "Mp7JrsAudioVisualSegmentType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsAudioVisualRegionType.h"
#include "Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::IMp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType_ExtPropInit.h

}

IMp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::~IMp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType_ExtPropCleanup.h

}

Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::~Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType()
{
	Cleanup();
}

void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_AudioVisualSegment = Mp7JrsAudioVisualSegmentPtr(); // Class
	m_AudioVisualSegmentRef = Mp7JrsReferencePtr(); // Class
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr(); // Class
	m_AudioVisualRegionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegment);
	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegmentRef);
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
}

void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AudioVisualSegmentTemporalDecompositionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IAudioVisualSegmentTemporalDecompositionType_LocalType
    const Mp7JrsPtr< Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_AudioVisualSegment);
		this->SetAudioVisualSegment(Mp7JrsFactory::CloneObject(tmp->GetAudioVisualSegment()));
		// Mp7JrsFactory::DeleteObject(m_AudioVisualSegmentRef);
		this->SetAudioVisualSegmentRef(Mp7JrsFactory::CloneObject(tmp->GetAudioVisualSegmentRef()));
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
		this->SetAudioVisualRegion(Mp7JrsFactory::CloneObject(tmp->GetAudioVisualRegion()));
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
		this->SetAudioVisualRegionRef(Mp7JrsFactory::CloneObject(tmp->GetAudioVisualRegionRef()));
}

Mp7JrsNodePtr Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsAudioVisualSegmentPtr Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetAudioVisualSegment() const
{
	return m_AudioVisualSegment;
}

Mp7JrsReferencePtr Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetAudioVisualSegmentRef() const
{
	return m_AudioVisualSegmentRef;
}

Mp7JrsAudioVisualRegionPtr Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetAudioVisualRegion() const
{
	return m_AudioVisualRegion;
}

Mp7JrsReferencePtr Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetAudioVisualRegionRef() const
{
	return m_AudioVisualRegionRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualSegment(const Mp7JrsAudioVisualSegmentPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualSegment().");
	}
	if (m_AudioVisualSegment != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioVisualSegment);
		m_AudioVisualSegment = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioVisualSegment) m_AudioVisualSegment->SetParent(m_myself.getPointer());
		if (m_AudioVisualSegment && m_AudioVisualSegment->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AudioVisualSegmentType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioVisualSegment->UseTypeAttribute = true;
		}
		if(m_AudioVisualSegment != Mp7JrsAudioVisualSegmentPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioVisualSegment->SetContentName(XMLString::transcode("AudioVisualSegment"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegmentRef);
	m_AudioVisualSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualSegmentRef().");
	}
	if (m_AudioVisualSegmentRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioVisualSegmentRef);
		m_AudioVisualSegmentRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioVisualSegmentRef) m_AudioVisualSegmentRef->SetParent(m_myself.getPointer());
		if (m_AudioVisualSegmentRef && m_AudioVisualSegmentRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioVisualSegmentRef->UseTypeAttribute = true;
		}
		if(m_AudioVisualSegmentRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioVisualSegmentRef->SetContentName(XMLString::transcode("AudioVisualSegmentRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegment);
	m_AudioVisualSegment = Mp7JrsAudioVisualSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualRegion(const Mp7JrsAudioVisualRegionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualRegion().");
	}
	if (m_AudioVisualRegion != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
		m_AudioVisualRegion = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioVisualRegion) m_AudioVisualRegion->SetParent(m_myself.getPointer());
		if (m_AudioVisualRegion && m_AudioVisualRegion->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AudioVisualRegionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioVisualRegion->UseTypeAttribute = true;
		}
		if(m_AudioVisualRegion != Mp7JrsAudioVisualRegionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioVisualRegion->SetContentName(XMLString::transcode("AudioVisualRegion"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegment);
	m_AudioVisualSegment = Mp7JrsAudioVisualSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegmentRef);
	m_AudioVisualSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
	m_AudioVisualRegionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::SetAudioVisualRegionRef().");
	}
	if (m_AudioVisualRegionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioVisualRegionRef);
		m_AudioVisualRegionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioVisualRegionRef) m_AudioVisualRegionRef->SetParent(m_myself.getPointer());
		if (m_AudioVisualRegionRef && m_AudioVisualRegionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioVisualRegionRef->UseTypeAttribute = true;
		}
		if(m_AudioVisualRegionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioVisualRegionRef->SetContentName(XMLString::transcode("AudioVisualRegionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegment);
	m_AudioVisualSegment = Mp7JrsAudioVisualSegmentPtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualSegmentRef);
	m_AudioVisualSegmentRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_AudioVisualRegion);
	m_AudioVisualRegion = Mp7JrsAudioVisualRegionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: AudioVisualSegmentTemporalDecompositionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_AudioVisualSegment != Mp7JrsAudioVisualSegmentPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioVisualSegment->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioVisualSegment"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioVisualSegment->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_AudioVisualSegmentRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioVisualSegmentRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioVisualSegmentRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioVisualSegmentRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_AudioVisualRegion != Mp7JrsAudioVisualRegionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioVisualRegion->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioVisualRegion"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioVisualRegion->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_AudioVisualRegionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioVisualRegionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioVisualRegionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioVisualRegionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioVisualSegment"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioVisualSegment")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAudioVisualSegmentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioVisualSegment(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioVisualSegmentRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioVisualSegmentRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioVisualSegmentRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioVisualRegion"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioVisualRegion")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAudioVisualRegionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioVisualRegion(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioVisualRegionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioVisualRegionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioVisualRegionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("AudioVisualSegment")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAudioVisualSegmentType;
    }
    this->SetAudioVisualSegment(child);
  }
  if (XMLString::compareString(elementname, X("AudioVisualSegmentRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetAudioVisualSegmentRef(child);
  }
  if (XMLString::compareString(elementname, X("AudioVisualRegion")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAudioVisualRegionType;
    }
    this->SetAudioVisualRegion(child);
  }
  if (XMLString::compareString(elementname, X("AudioVisualRegionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetAudioVisualRegionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetAudioVisualSegment() != Mp7JrsNodePtr())
		result.Insert(GetAudioVisualSegment());
	if (GetAudioVisualSegmentRef() != Mp7JrsNodePtr())
		result.Insert(GetAudioVisualSegmentRef());
	if (GetAudioVisualRegion() != Mp7JrsNodePtr())
		result.Insert(GetAudioVisualRegion());
	if (GetAudioVisualRegionRef() != Mp7JrsNodePtr())
		result.Insert(GetAudioVisualRegionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType_ExtMethodImpl.h


