 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsClassificationPreferencesType_Country_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_DatePeriod_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Language_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Form_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Genre_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Subject_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Review_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsClassificationPreferencesType_Country_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Country
#include "Mp7JrsClassificationPreferencesType_DatePeriod_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:DatePeriod
#include "Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:LanguageFormat
#include "Mp7JrsClassificationPreferencesType_Language_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Language
#include "Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:CaptionLanguage
#include "Mp7JrsClassificationPreferencesType_Form_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Form
#include "Mp7JrsClassificationPreferencesType_Genre_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Genre
#include "Mp7JrsClassificationPreferencesType_Subject_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Subject
#include "Mp7JrsClassificationPreferencesType_Review_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Review
#include "Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:ParentalGuidance

#include <assert.h>
IMp7JrsClassificationPreferencesType::IMp7JrsClassificationPreferencesType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtPropInit.h

}

IMp7JrsClassificationPreferencesType::~IMp7JrsClassificationPreferencesType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtPropCleanup.h

}

Mp7JrsClassificationPreferencesType::Mp7JrsClassificationPreferencesType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationPreferencesType::~Mp7JrsClassificationPreferencesType()
{
	Cleanup();
}

void Mp7JrsClassificationPreferencesType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Country = Mp7JrsClassificationPreferencesType_Country_CollectionPtr(); // Collection
	m_DatePeriod = Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr(); // Collection
	m_LanguageFormat = Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr(); // Collection
	m_Language = Mp7JrsClassificationPreferencesType_Language_CollectionPtr(); // Collection
	m_CaptionLanguage = Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr(); // Collection
	m_Form = Mp7JrsClassificationPreferencesType_Form_CollectionPtr(); // Collection
	m_Genre = Mp7JrsClassificationPreferencesType_Genre_CollectionPtr(); // Collection
	m_Subject = Mp7JrsClassificationPreferencesType_Subject_CollectionPtr(); // Collection
	m_Review = Mp7JrsClassificationPreferencesType_Review_CollectionPtr(); // Collection
	m_ParentalGuidance = Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtMyPropInit.h

}

void Mp7JrsClassificationPreferencesType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	// Mp7JrsFactory::DeleteObject(m_Country);
	// Mp7JrsFactory::DeleteObject(m_DatePeriod);
	// Mp7JrsFactory::DeleteObject(m_LanguageFormat);
	// Mp7JrsFactory::DeleteObject(m_Language);
	// Mp7JrsFactory::DeleteObject(m_CaptionLanguage);
	// Mp7JrsFactory::DeleteObject(m_Form);
	// Mp7JrsFactory::DeleteObject(m_Genre);
	// Mp7JrsFactory::DeleteObject(m_Subject);
	// Mp7JrsFactory::DeleteObject(m_Review);
	// Mp7JrsFactory::DeleteObject(m_ParentalGuidance);
}

void Mp7JrsClassificationPreferencesType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationPreferencesTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationPreferencesType
    const Mp7JrsPtr< Mp7JrsClassificationPreferencesType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsClassificationPreferencesType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_Country);
		this->SetCountry(Mp7JrsFactory::CloneObject(tmp->GetCountry()));
		// Mp7JrsFactory::DeleteObject(m_DatePeriod);
		this->SetDatePeriod(Mp7JrsFactory::CloneObject(tmp->GetDatePeriod()));
		// Mp7JrsFactory::DeleteObject(m_LanguageFormat);
		this->SetLanguageFormat(Mp7JrsFactory::CloneObject(tmp->GetLanguageFormat()));
		// Mp7JrsFactory::DeleteObject(m_Language);
		this->SetLanguage(Mp7JrsFactory::CloneObject(tmp->GetLanguage()));
		// Mp7JrsFactory::DeleteObject(m_CaptionLanguage);
		this->SetCaptionLanguage(Mp7JrsFactory::CloneObject(tmp->GetCaptionLanguage()));
		// Mp7JrsFactory::DeleteObject(m_Form);
		this->SetForm(Mp7JrsFactory::CloneObject(tmp->GetForm()));
		// Mp7JrsFactory::DeleteObject(m_Genre);
		this->SetGenre(Mp7JrsFactory::CloneObject(tmp->GetGenre()));
		// Mp7JrsFactory::DeleteObject(m_Subject);
		this->SetSubject(Mp7JrsFactory::CloneObject(tmp->GetSubject()));
		// Mp7JrsFactory::DeleteObject(m_Review);
		this->SetReview(Mp7JrsFactory::CloneObject(tmp->GetReview()));
		// Mp7JrsFactory::DeleteObject(m_ParentalGuidance);
		this->SetParentalGuidance(Mp7JrsFactory::CloneObject(tmp->GetParentalGuidance()));
}

Mp7JrsNodePtr Mp7JrsClassificationPreferencesType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsClassificationPreferencesType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsClassificationPreferencesType::GetBase() const
{
	return m_Base;
}

Mp7JrspreferenceValuePtr Mp7JrsClassificationPreferencesType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsClassificationPreferencesType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsClassificationPreferencesType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetpreferenceValue().");
	}
    m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
Mp7JrsClassificationPreferencesType_Country_CollectionPtr Mp7JrsClassificationPreferencesType::GetCountry() const
{
	return m_Country;
}

Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr Mp7JrsClassificationPreferencesType::GetDatePeriod() const
{
	return m_DatePeriod;
}

Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr Mp7JrsClassificationPreferencesType::GetLanguageFormat() const
{
	return m_LanguageFormat;
}

Mp7JrsClassificationPreferencesType_Language_CollectionPtr Mp7JrsClassificationPreferencesType::GetLanguage() const
{
	return m_Language;
}

Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr Mp7JrsClassificationPreferencesType::GetCaptionLanguage() const
{
	return m_CaptionLanguage;
}

Mp7JrsClassificationPreferencesType_Form_CollectionPtr Mp7JrsClassificationPreferencesType::GetForm() const
{
	return m_Form;
}

Mp7JrsClassificationPreferencesType_Genre_CollectionPtr Mp7JrsClassificationPreferencesType::GetGenre() const
{
	return m_Genre;
}

Mp7JrsClassificationPreferencesType_Subject_CollectionPtr Mp7JrsClassificationPreferencesType::GetSubject() const
{
	return m_Subject;
}

Mp7JrsClassificationPreferencesType_Review_CollectionPtr Mp7JrsClassificationPreferencesType::GetReview() const
{
	return m_Review;
}

Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr Mp7JrsClassificationPreferencesType::GetParentalGuidance() const
{
	return m_ParentalGuidance;
}

void Mp7JrsClassificationPreferencesType::SetCountry(const Mp7JrsClassificationPreferencesType_Country_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetCountry().");
	}
	if (m_Country != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Country);
		m_Country = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Country) m_Country->SetParent(m_myself.getPointer());
		if(m_Country != Mp7JrsClassificationPreferencesType_Country_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Country->SetContentName(XMLString::transcode("Country"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetDatePeriod(const Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetDatePeriod().");
	}
	if (m_DatePeriod != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DatePeriod);
		m_DatePeriod = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DatePeriod) m_DatePeriod->SetParent(m_myself.getPointer());
		if(m_DatePeriod != Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_DatePeriod->SetContentName(XMLString::transcode("DatePeriod"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetLanguageFormat(const Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetLanguageFormat().");
	}
	if (m_LanguageFormat != item)
	{
		// Mp7JrsFactory::DeleteObject(m_LanguageFormat);
		m_LanguageFormat = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_LanguageFormat) m_LanguageFormat->SetParent(m_myself.getPointer());
		if(m_LanguageFormat != Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_LanguageFormat->SetContentName(XMLString::transcode("LanguageFormat"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetLanguage(const Mp7JrsClassificationPreferencesType_Language_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetLanguage().");
	}
	if (m_Language != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Language);
		m_Language = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Language) m_Language->SetParent(m_myself.getPointer());
		if(m_Language != Mp7JrsClassificationPreferencesType_Language_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Language->SetContentName(XMLString::transcode("Language"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetCaptionLanguage(const Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetCaptionLanguage().");
	}
	if (m_CaptionLanguage != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CaptionLanguage);
		m_CaptionLanguage = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CaptionLanguage) m_CaptionLanguage->SetParent(m_myself.getPointer());
		if(m_CaptionLanguage != Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CaptionLanguage->SetContentName(XMLString::transcode("CaptionLanguage"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetForm(const Mp7JrsClassificationPreferencesType_Form_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetForm().");
	}
	if (m_Form != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Form);
		m_Form = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Form) m_Form->SetParent(m_myself.getPointer());
		if(m_Form != Mp7JrsClassificationPreferencesType_Form_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Form->SetContentName(XMLString::transcode("Form"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetGenre(const Mp7JrsClassificationPreferencesType_Genre_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetGenre().");
	}
	if (m_Genre != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Genre);
		m_Genre = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Genre) m_Genre->SetParent(m_myself.getPointer());
		if(m_Genre != Mp7JrsClassificationPreferencesType_Genre_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Genre->SetContentName(XMLString::transcode("Genre"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetSubject(const Mp7JrsClassificationPreferencesType_Subject_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetSubject().");
	}
	if (m_Subject != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Subject);
		m_Subject = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Subject) m_Subject->SetParent(m_myself.getPointer());
		if(m_Subject != Mp7JrsClassificationPreferencesType_Subject_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Subject->SetContentName(XMLString::transcode("Subject"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetReview(const Mp7JrsClassificationPreferencesType_Review_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetReview().");
	}
	if (m_Review != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Review);
		m_Review = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Review) m_Review->SetParent(m_myself.getPointer());
		if(m_Review != Mp7JrsClassificationPreferencesType_Review_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Review->SetContentName(XMLString::transcode("Review"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::SetParentalGuidance(const Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetParentalGuidance().");
	}
	if (m_ParentalGuidance != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ParentalGuidance);
		m_ParentalGuidance = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ParentalGuidance) m_ParentalGuidance->SetParent(m_myself.getPointer());
		if(m_ParentalGuidance != Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ParentalGuidance->SetContentName(XMLString::transcode("ParentalGuidance"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsClassificationPreferencesType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsClassificationPreferencesType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsClassificationPreferencesType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsClassificationPreferencesType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsClassificationPreferencesType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsClassificationPreferencesType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsClassificationPreferencesType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsClassificationPreferencesType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsClassificationPreferencesType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsClassificationPreferencesType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsClassificationPreferencesType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsClassificationPreferencesType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsClassificationPreferencesType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsClassificationPreferencesType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsClassificationPreferencesType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationPreferencesType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsClassificationPreferencesType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsClassificationPreferencesType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationPreferencesType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsClassificationPreferencesType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Country")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Country is item of type ClassificationPreferencesType_Country_LocalType
		// in element collection ClassificationPreferencesType_Country_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_Country_CollectionPtr coll = GetCountry();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_Country_CollectionType;
				SetCountry(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_Country_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_Country_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("DatePeriod")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:DatePeriod is item of type ClassificationPreferencesType_DatePeriod_LocalType
		// in element collection ClassificationPreferencesType_DatePeriod_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr coll = GetDatePeriod();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_DatePeriod_CollectionType;
				SetDatePeriod(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_DatePeriod_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_DatePeriod_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("LanguageFormat")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:LanguageFormat is item of type ClassificationPreferencesType_LanguageFormat_LocalType
		// in element collection ClassificationPreferencesType_LanguageFormat_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr coll = GetLanguageFormat();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_LanguageFormat_CollectionType;
				SetLanguageFormat(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_LanguageFormat_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_LanguageFormat_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Language")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Language is item of type ClassificationPreferencesType_Language_LocalType
		// in element collection ClassificationPreferencesType_Language_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_Language_CollectionPtr coll = GetLanguage();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_Language_CollectionType;
				SetLanguage(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_Language_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_Language_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CaptionLanguage")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:CaptionLanguage is item of type ClassificationPreferencesType_CaptionLanguage_LocalType
		// in element collection ClassificationPreferencesType_CaptionLanguage_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr coll = GetCaptionLanguage();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_CaptionLanguage_CollectionType;
				SetCaptionLanguage(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_CaptionLanguage_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Form")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Form is item of type ClassificationPreferencesType_Form_LocalType
		// in element collection ClassificationPreferencesType_Form_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_Form_CollectionPtr coll = GetForm();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_Form_CollectionType;
				SetForm(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_Form_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_Form_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Genre")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Genre is item of type ClassificationPreferencesType_Genre_LocalType
		// in element collection ClassificationPreferencesType_Genre_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_Genre_CollectionPtr coll = GetGenre();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_Genre_CollectionType;
				SetGenre(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_Genre_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_Genre_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Subject")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Subject is item of type ClassificationPreferencesType_Subject_LocalType
		// in element collection ClassificationPreferencesType_Subject_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_Subject_CollectionPtr coll = GetSubject();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_Subject_CollectionType;
				SetSubject(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_Subject_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_Subject_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Review")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Review is item of type ClassificationPreferencesType_Review_LocalType
		// in element collection ClassificationPreferencesType_Review_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_Review_CollectionPtr coll = GetReview();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_Review_CollectionType;
				SetReview(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_Review_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_Review_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ParentalGuidance")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:ParentalGuidance is item of type ClassificationPreferencesType_ParentalGuidance_LocalType
		// in element collection ClassificationPreferencesType_ParentalGuidance_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr coll = GetParentalGuidance();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationPreferencesType_ParentalGuidance_CollectionType;
				SetParentalGuidance(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationPreferencesType_ParentalGuidance_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ClassificationPreferencesType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ClassificationPreferencesType");
	}		
	
	return result;
}

XMLCh * Mp7JrsClassificationPreferencesType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsClassificationPreferencesType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsClassificationPreferencesType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationPreferencesType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_Country != Mp7JrsClassificationPreferencesType_Country_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Country->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_DatePeriod != Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_DatePeriod->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_LanguageFormat != Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_LanguageFormat->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Language != Mp7JrsClassificationPreferencesType_Language_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Language->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_CaptionLanguage != Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_CaptionLanguage->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Form != Mp7JrsClassificationPreferencesType_Form_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Form->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Genre != Mp7JrsClassificationPreferencesType_Genre_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Genre->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Subject != Mp7JrsClassificationPreferencesType_Subject_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Subject->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Review != Mp7JrsClassificationPreferencesType_Review_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Review->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_ParentalGuidance != Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_ParentalGuidance->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsClassificationPreferencesType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("preferenceValue")))
	{
        // Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttributeNS(X(""), X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
        Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
        tmp->Parse(parent->getAttribute(X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Country"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Country")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_Country_CollectionPtr tmp = CreateClassificationPreferencesType_Country_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetCountry(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("DatePeriod"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("DatePeriod")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr tmp = CreateClassificationPreferencesType_DatePeriod_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetDatePeriod(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("LanguageFormat"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("LanguageFormat")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr tmp = CreateClassificationPreferencesType_LanguageFormat_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetLanguageFormat(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Language"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Language")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_Language_CollectionPtr tmp = CreateClassificationPreferencesType_Language_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetLanguage(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("CaptionLanguage"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("CaptionLanguage")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr tmp = CreateClassificationPreferencesType_CaptionLanguage_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetCaptionLanguage(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Form"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Form")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_Form_CollectionPtr tmp = CreateClassificationPreferencesType_Form_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetForm(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Genre"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Genre")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_Genre_CollectionPtr tmp = CreateClassificationPreferencesType_Genre_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetGenre(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Subject"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Subject")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_Subject_CollectionPtr tmp = CreateClassificationPreferencesType_Subject_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSubject(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Review"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Review")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_Review_CollectionPtr tmp = CreateClassificationPreferencesType_Review_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetReview(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("ParentalGuidance"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("ParentalGuidance")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr tmp = CreateClassificationPreferencesType_ParentalGuidance_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetParentalGuidance(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationPreferencesType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Country")) == 0))
  {
    Mp7JrsClassificationPreferencesType_Country_CollectionPtr tmp = CreateClassificationPreferencesType_Country_CollectionType;
    this->SetCountry(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("DatePeriod")) == 0))
  {
    Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr tmp = CreateClassificationPreferencesType_DatePeriod_CollectionType;
    this->SetDatePeriod(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("LanguageFormat")) == 0))
  {
    Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr tmp = CreateClassificationPreferencesType_LanguageFormat_CollectionType;
    this->SetLanguageFormat(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Language")) == 0))
  {
    Mp7JrsClassificationPreferencesType_Language_CollectionPtr tmp = CreateClassificationPreferencesType_Language_CollectionType;
    this->SetLanguage(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("CaptionLanguage")) == 0))
  {
    Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr tmp = CreateClassificationPreferencesType_CaptionLanguage_CollectionType;
    this->SetCaptionLanguage(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Form")) == 0))
  {
    Mp7JrsClassificationPreferencesType_Form_CollectionPtr tmp = CreateClassificationPreferencesType_Form_CollectionType;
    this->SetForm(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Genre")) == 0))
  {
    Mp7JrsClassificationPreferencesType_Genre_CollectionPtr tmp = CreateClassificationPreferencesType_Genre_CollectionType;
    this->SetGenre(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Subject")) == 0))
  {
    Mp7JrsClassificationPreferencesType_Subject_CollectionPtr tmp = CreateClassificationPreferencesType_Subject_CollectionType;
    this->SetSubject(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Review")) == 0))
  {
    Mp7JrsClassificationPreferencesType_Review_CollectionPtr tmp = CreateClassificationPreferencesType_Review_CollectionType;
    this->SetReview(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("ParentalGuidance")) == 0))
  {
    Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr tmp = CreateClassificationPreferencesType_ParentalGuidance_CollectionType;
    this->SetParentalGuidance(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationPreferencesType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCountry() != Mp7JrsNodePtr())
		result.Insert(GetCountry());
	if (GetDatePeriod() != Mp7JrsNodePtr())
		result.Insert(GetDatePeriod());
	if (GetLanguageFormat() != Mp7JrsNodePtr())
		result.Insert(GetLanguageFormat());
	if (GetLanguage() != Mp7JrsNodePtr())
		result.Insert(GetLanguage());
	if (GetCaptionLanguage() != Mp7JrsNodePtr())
		result.Insert(GetCaptionLanguage());
	if (GetForm() != Mp7JrsNodePtr())
		result.Insert(GetForm());
	if (GetGenre() != Mp7JrsNodePtr())
		result.Insert(GetGenre());
	if (GetSubject() != Mp7JrsNodePtr())
		result.Insert(GetSubject());
	if (GetReview() != Mp7JrsNodePtr())
		result.Insert(GetReview());
	if (GetParentalGuidance() != Mp7JrsNodePtr())
		result.Insert(GetParentalGuidance());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtMethodImpl.h


