 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtImplInclude.h



#include "Mp7JrsContentManagementType.h"
#include "Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType.h"
#include "Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType.h"
#include "Mp7JrsDescriptionMetadataType.h"
#include "Mp7JrsCompleteDescriptionType_Relationships_CollectionType.h"
#include "Mp7JrsCompleteDescriptionType_OrderingKey_CollectionType.h"
#include "Mp7JrsClassificationSchemeDescriptionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsGraphType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Relationships
#include "Mp7JrsOrderingKeyType.h" // Element collection urn:mpeg:mpeg7:schema:2004:OrderingKey
#include "Mp7JrsClassificationSchemeType.h" // Element collection urn:mpeg:mpeg7:schema:2004:ClassificationScheme
#include "Mp7JrsClassificationSchemeBaseType.h" // Element collection urn:mpeg:mpeg7:schema:2004:ClassificationSchemeBase

#include <assert.h>
IMp7JrsClassificationSchemeDescriptionType::IMp7JrsClassificationSchemeDescriptionType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtPropInit.h

}

IMp7JrsClassificationSchemeDescriptionType::~IMp7JrsClassificationSchemeDescriptionType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtPropCleanup.h

}

Mp7JrsClassificationSchemeDescriptionType::Mp7JrsClassificationSchemeDescriptionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationSchemeDescriptionType::~Mp7JrsClassificationSchemeDescriptionType()
{
	Cleanup();
}

void Mp7JrsClassificationSchemeDescriptionType::Init()
{
	// Init base
	m_Base = CreateContentManagementType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_ClassificationScheme = Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr(); // Collection
	m_ClassificationSchemeBase = Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtMyPropInit.h

}

void Mp7JrsClassificationSchemeDescriptionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_ClassificationScheme);
	// Mp7JrsFactory::DeleteObject(m_ClassificationSchemeBase);
}

void Mp7JrsClassificationSchemeDescriptionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationSchemeDescriptionTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationSchemeDescriptionType
    const Mp7JrsPtr< Mp7JrsClassificationSchemeDescriptionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsContentManagementPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsClassificationSchemeDescriptionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_ClassificationScheme);
		this->SetClassificationScheme(Mp7JrsFactory::CloneObject(tmp->GetClassificationScheme()));
		// Mp7JrsFactory::DeleteObject(m_ClassificationSchemeBase);
		this->SetClassificationSchemeBase(Mp7JrsFactory::CloneObject(tmp->GetClassificationSchemeBase()));
}

Mp7JrsNodePtr Mp7JrsClassificationSchemeDescriptionType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsClassificationSchemeDescriptionType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsContentManagementType > Mp7JrsClassificationSchemeDescriptionType::GetBase() const
{
	return m_Base;
}

Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr Mp7JrsClassificationSchemeDescriptionType::GetClassificationScheme() const
{
	return m_ClassificationScheme;
}

Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr Mp7JrsClassificationSchemeDescriptionType::GetClassificationSchemeBase() const
{
	return m_ClassificationSchemeBase;
}

// implementing setter for choice 
/* element */
void Mp7JrsClassificationSchemeDescriptionType::SetClassificationScheme(const Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeDescriptionType::SetClassificationScheme().");
	}
	if (m_ClassificationScheme != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ClassificationScheme);
		m_ClassificationScheme = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ClassificationScheme) m_ClassificationScheme->SetParent(m_myself.getPointer());
		if(m_ClassificationScheme != Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ClassificationScheme->SetContentName(XMLString::transcode("ClassificationScheme"));
		}
	// Mp7JrsFactory::DeleteObject(m_ClassificationSchemeBase);
	m_ClassificationSchemeBase = Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsClassificationSchemeDescriptionType::SetClassificationSchemeBase(const Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeDescriptionType::SetClassificationSchemeBase().");
	}
	if (m_ClassificationSchemeBase != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ClassificationSchemeBase);
		m_ClassificationSchemeBase = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ClassificationSchemeBase) m_ClassificationSchemeBase->SetParent(m_myself.getPointer());
		if(m_ClassificationSchemeBase != Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ClassificationSchemeBase->SetContentName(XMLString::transcode("ClassificationSchemeBase"));
		}
	// Mp7JrsFactory::DeleteObject(m_ClassificationScheme);
	m_ClassificationScheme = Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsDescriptionMetadataPtr Mp7JrsClassificationSchemeDescriptionType::GetDescriptionMetadata() const
{
	return GetBase()->GetBase()->GetDescriptionMetadata();
}

// Element is optional
bool Mp7JrsClassificationSchemeDescriptionType::IsValidDescriptionMetadata() const
{
	return GetBase()->GetBase()->IsValidDescriptionMetadata();
}

Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr Mp7JrsClassificationSchemeDescriptionType::GetRelationships() const
{
	return GetBase()->GetBase()->GetRelationships();
}

Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr Mp7JrsClassificationSchemeDescriptionType::GetOrderingKey() const
{
	return GetBase()->GetBase()->GetOrderingKey();
}

void Mp7JrsClassificationSchemeDescriptionType::SetDescriptionMetadata(const Mp7JrsDescriptionMetadataPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeDescriptionType::SetDescriptionMetadata().");
	}
	GetBase()->GetBase()->SetDescriptionMetadata(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationSchemeDescriptionType::InvalidateDescriptionMetadata()
{
	GetBase()->GetBase()->InvalidateDescriptionMetadata();
}
void Mp7JrsClassificationSchemeDescriptionType::SetRelationships(const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeDescriptionType::SetRelationships().");
	}
	GetBase()->GetBase()->SetRelationships(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationSchemeDescriptionType::SetOrderingKey(const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationSchemeDescriptionType::SetOrderingKey().");
	}
	GetBase()->GetBase()->SetOrderingKey(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsClassificationSchemeDescriptionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("ClassificationScheme")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:ClassificationScheme is item of type ClassificationSchemeType
		// in element collection ClassificationSchemeDescriptionType_ClassificationScheme_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr coll = GetClassificationScheme();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationSchemeDescriptionType_ClassificationScheme_CollectionType;
				SetClassificationScheme(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationSchemeType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationSchemePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ClassificationSchemeBase")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:ClassificationSchemeBase is item of abstract type ClassificationSchemeBaseType
		// in element collection ClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr coll = GetClassificationSchemeBase();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType;
				SetClassificationSchemeBase(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationSchemeBasePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ClassificationSchemeDescriptionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ClassificationSchemeDescriptionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsClassificationSchemeDescriptionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsClassificationSchemeDescriptionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsClassificationSchemeDescriptionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationSchemeDescriptionType"));
	// Element serialization:
	if (m_ClassificationScheme != Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_ClassificationScheme->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_ClassificationSchemeBase != Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_ClassificationSchemeBase->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsClassificationSchemeDescriptionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsContentManagementType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
	do // Deserialize choice just one time!
    {
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("ClassificationScheme"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("ClassificationScheme")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr tmp = CreateClassificationSchemeDescriptionType_ClassificationScheme_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetClassificationScheme(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("ClassificationSchemeBase"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("ClassificationSchemeBase")) == 0))
        {
            // Deserialize factory type
            Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr tmp = CreateClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetClassificationSchemeBase(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationSchemeDescriptionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("ClassificationScheme")) == 0))
  {
    Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr tmp = CreateClassificationSchemeDescriptionType_ClassificationScheme_CollectionType;
    this->SetClassificationScheme(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("ClassificationSchemeBase")) == 0))
  {
    Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr tmp = CreateClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType;
    this->SetClassificationSchemeBase(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationSchemeDescriptionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetClassificationScheme() != Mp7JrsNodePtr())
		result.Insert(GetClassificationScheme());
	if (GetClassificationSchemeBase() != Mp7JrsNodePtr())
		result.Insert(GetClassificationSchemeBase());
	if (GetDescriptionMetadata() != Mp7JrsNodePtr())
		result.Insert(GetDescriptionMetadata());
	if (GetRelationships() != Mp7JrsNodePtr())
		result.Insert(GetRelationships());
	if (GetOrderingKey() != Mp7JrsNodePtr())
		result.Insert(GetOrderingKey());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtMethodImpl.h


