 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_Age_LocalType_ExtImplInclude.h



#include "Mp7JrsClassificationType_Target_Age_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsClassificationType_Target_Age_LocalType::IMp7JrsClassificationType_Target_Age_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_Age_LocalType_ExtPropInit.h

}

IMp7JrsClassificationType_Target_Age_LocalType::~IMp7JrsClassificationType_Target_Age_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_Age_LocalType_ExtPropCleanup.h

}

Mp7JrsClassificationType_Target_Age_LocalType::Mp7JrsClassificationType_Target_Age_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationType_Target_Age_LocalType::~Mp7JrsClassificationType_Target_Age_LocalType()
{
	Cleanup();
}

void Mp7JrsClassificationType_Target_Age_LocalType::Init()
{

	// Init attributes
	m_min = 0; // Value
	m_min_Exist = false;
	m_max = 0; // Value
	m_max_Exist = false;



// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_Age_LocalType_ExtMyPropInit.h

}

void Mp7JrsClassificationType_Target_Age_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_Age_LocalType_ExtMyPropCleanup.h


}

void Mp7JrsClassificationType_Target_Age_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationType_Target_Age_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationType_Target_Age_LocalType
    const Mp7JrsPtr< Mp7JrsClassificationType_Target_Age_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if (tmp->Existmin())
	{
		this->Setmin(tmp->Getmin());
	}
	else
	{
		Invalidatemin();
	}
	}
	{
	if (tmp->Existmax())
	{
		this->Setmax(tmp->Getmax());
	}
	else
	{
		Invalidatemax();
	}
	}
}

Mp7JrsNodePtr Mp7JrsClassificationType_Target_Age_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsClassificationType_Target_Age_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


unsigned Mp7JrsClassificationType_Target_Age_LocalType::Getmin() const
{
	return m_min;
}

bool Mp7JrsClassificationType_Target_Age_LocalType::Existmin() const
{
	return m_min_Exist;
}
void Mp7JrsClassificationType_Target_Age_LocalType::Setmin(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_Target_Age_LocalType::Setmin().");
	}
    m_min = item;
	m_min_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_Target_Age_LocalType::Invalidatemin()
{
	m_min_Exist = false;
}
unsigned Mp7JrsClassificationType_Target_Age_LocalType::Getmax() const
{
	return m_max;
}

bool Mp7JrsClassificationType_Target_Age_LocalType::Existmax() const
{
	return m_max_Exist;
}
void Mp7JrsClassificationType_Target_Age_LocalType::Setmax(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_Target_Age_LocalType::Setmax().");
	}
    m_max = item;
	m_max_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_Target_Age_LocalType::Invalidatemax()
{
	m_max_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsClassificationType_Target_Age_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsClassificationType_Target_Age_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsClassificationType_Target_Age_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsClassificationType_Target_Age_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationType_Target_Age_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_min_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_min);
		element->setAttributeNS(X(""), X("min"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_max_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_max);
		element->setAttributeNS(X(""), X("max"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsClassificationType_Target_Age_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("min")))
	{
        // deserialize value type
        this->Setmin(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("min"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("min")))
	{
        // deserialize value type
        this->Setmin(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("min"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("max")))
	{
        // deserialize value type
        this->Setmax(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("max"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("max")))
	{
        // deserialize value type
        this->Setmax(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("max"))));
        * current = parent;
    }

// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_Age_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationType_Target_Age_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationType_Target_Age_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_Age_LocalType_ExtMethodImpl.h


