 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtImplInclude.h



#include "Mp7Jrsunsigned12.h"
#include "Mp7JrsColorQuantizationType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsColorQuantizationType_LocalType::IMp7JrsColorQuantizationType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtPropInit.h

}

IMp7JrsColorQuantizationType_LocalType::~IMp7JrsColorQuantizationType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtPropCleanup.h

}

Mp7JrsColorQuantizationType_LocalType::Mp7JrsColorQuantizationType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsColorQuantizationType_LocalType::~Mp7JrsColorQuantizationType_LocalType()
{
	Cleanup();
}

void Mp7JrsColorQuantizationType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Component = Mp7JrsColorQuantizationType_Component_LocalType::UninitializedEnumeration; // Enumeration
	m_NumOfBins = Mp7Jrsunsigned12Ptr(); // Class with content 


// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtMyPropInit.h

}

void Mp7JrsColorQuantizationType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_NumOfBins);
}

void Mp7JrsColorQuantizationType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ColorQuantizationType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IColorQuantizationType_LocalType
    const Mp7JrsPtr< Mp7JrsColorQuantizationType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		this->SetComponent(tmp->GetComponent());
		// Mp7JrsFactory::DeleteObject(m_NumOfBins);
		this->SetNumOfBins(Mp7JrsFactory::CloneObject(tmp->GetNumOfBins()));
}

Mp7JrsNodePtr Mp7JrsColorQuantizationType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsColorQuantizationType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsColorQuantizationType_Component_LocalType::Enumeration Mp7JrsColorQuantizationType_LocalType::GetComponent() const
{
	return m_Component;
}

Mp7Jrsunsigned12Ptr Mp7JrsColorQuantizationType_LocalType::GetNumOfBins() const
{
	return m_NumOfBins;
}

void Mp7JrsColorQuantizationType_LocalType::SetComponent(Mp7JrsColorQuantizationType_Component_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorQuantizationType_LocalType::SetComponent().");
	}
	if (m_Component != item)
	{
		// nothing to free here, hopefully
		m_Component = item;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsColorQuantizationType_LocalType::SetNumOfBins(const Mp7Jrsunsigned12Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorQuantizationType_LocalType::SetNumOfBins().");
	}
	if (m_NumOfBins != item)
	{
		// Mp7JrsFactory::DeleteObject(m_NumOfBins);
		m_NumOfBins = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_NumOfBins) m_NumOfBins->SetParent(m_myself.getPointer());
		if (m_NumOfBins && m_NumOfBins->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned12"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_NumOfBins->UseTypeAttribute = true;
		}
		if(m_NumOfBins != Mp7Jrsunsigned12Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_NumOfBins->SetContentName(XMLString::transcode("NumOfBins"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: ColorQuantizationType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsColorQuantizationType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsColorQuantizationType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsColorQuantizationType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsColorQuantizationType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ColorQuantizationType_LocalType"));
	// Element serialization:
	if(m_Component != Mp7JrsColorQuantizationType_Component_LocalType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsColorQuantizationType_Component_LocalType::ToText(m_Component);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("Component"), false);
		XMLString::release(&tmp);
	}
	// Class with content		
	
	if (m_NumOfBins != Mp7Jrsunsigned12Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_NumOfBins->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("NumOfBins"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_NumOfBins->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsColorQuantizationType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

        // Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("Component"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Component")) == 0))
        {
            Mp7JrsColorQuantizationType_Component_LocalType::Enumeration tmp = Mp7JrsColorQuantizationType_Component_LocalType::Parse(Mp7JrsUtil::GetElementText(parent));
            if(tmp == Mp7JrsColorQuantizationType_Component_LocalType::UninitializedEnumeration)
            {
                    return false;
            }
            this->SetComponent(tmp);
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("NumOfBins"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("NumOfBins")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned12;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetNumOfBins(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsColorQuantizationType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("NumOfBins")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned12;
    }
    this->SetNumOfBins(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsColorQuantizationType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetNumOfBins() != Mp7JrsNodePtr())
		result.Insert(GetNumOfBins());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtMethodImpl.h


