 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtImplInclude.h



#include "Mp7JrsInlineTermDefinitionType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Definition_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Definition
#include "Mp7JrsInlineTermDefinitionType_Term_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Term

#include <assert.h>
IMp7JrsControlledTermUseType::IMp7JrsControlledTermUseType()
{

// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtPropInit.h

}

IMp7JrsControlledTermUseType::~IMp7JrsControlledTermUseType()
{
// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtPropCleanup.h

}

Mp7JrsControlledTermUseType::Mp7JrsControlledTermUseType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsControlledTermUseType::~Mp7JrsControlledTermUseType()
{
	Cleanup();
}

void Mp7JrsControlledTermUseType::Init()
{
	// Init base
	m_Base = CreateInlineTermDefinitionType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_href = Mp7JrstermReferencePtr(); // Create emtpy class ptr



// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtMyPropInit.h

}

void Mp7JrsControlledTermUseType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_href);
}

void Mp7JrsControlledTermUseType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ControlledTermUseTypePtr, since we
	// might need GetBase(), which isn't defined in IControlledTermUseType
    const Mp7JrsPtr< Mp7JrsControlledTermUseType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsInlineTermDefinitionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsControlledTermUseType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_href);
		this->Sethref(Mp7JrsFactory::CloneObject(tmp->Gethref()));
	}
}

Mp7JrsNodePtr Mp7JrsControlledTermUseType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsControlledTermUseType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsInlineTermDefinitionType > Mp7JrsControlledTermUseType::GetBase() const
{
	return m_Base;
}

Mp7JrstermReferencePtr Mp7JrsControlledTermUseType::Gethref() const
{
	return m_href;
}

void Mp7JrsControlledTermUseType::Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsControlledTermUseType::Sethref().");
	}
    m_href = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_href) m_href->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsInlineTermDefinitionType_Name_CollectionPtr Mp7JrsControlledTermUseType::GetName() const
{
	return GetBase()->GetName();
}

Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr Mp7JrsControlledTermUseType::GetDefinition() const
{
	return GetBase()->GetDefinition();
}

Mp7JrsInlineTermDefinitionType_Term_CollectionPtr Mp7JrsControlledTermUseType::GetTerm() const
{
	return GetBase()->GetTerm();
}

void Mp7JrsControlledTermUseType::SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsControlledTermUseType::SetName().");
	}
	GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsControlledTermUseType::SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsControlledTermUseType::SetDefinition().");
	}
	GetBase()->SetDefinition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsControlledTermUseType::SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsControlledTermUseType::SetTerm().");
	}
	GetBase()->SetTerm(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsControlledTermUseType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ControlledTermUseType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ControlledTermUseType");
	}		
	
	return result;
}

XMLCh * Mp7JrsControlledTermUseType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsControlledTermUseType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsControlledTermUseType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ControlledTermUseType"));
    // Attribute Serialization:
	// Class
	if (m_href != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_href->ToText();
		element->setAttributeNS(X(""), X("href"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:

}

bool Mp7JrsControlledTermUseType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("href")))
	{
        // Deserialize class type
		Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
		tmp->Parse(parent->getAttributeNS(X(""), X("href")));
        this->Sethref(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("href")))
	{
		// Deserialize class type
        Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
        tmp->Parse(parent->getAttribute(X("href")));
        this->Sethref(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsInlineTermDefinitionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsControlledTermUseType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsControlledTermUseType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetDefinition() != Mp7JrsNodePtr())
		result.Insert(GetDefinition());
	if (GetTerm() != Mp7JrsNodePtr())
		result.Insert(GetTerm());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// begin extension included
// file Mp7JrsControlledTermUseType_ExtMethodImpl.h


void IMp7JrsControlledTermUseType::SetTermReferenceURN(XMLCh* urn, XMLCh* term, XMLCh* name, Mp7JrsClientID client) 
{
	Mp7JrstermReferencePtr href = CreatetermReferenceType;
	Sethref(href,client);

	Mp7JrstermReferenceType_LocalPtr hrefPattern = CreatetermReferenceType_LocalType;
	href->SettermReferenceType_LocalType(hrefPattern,client);
	
	XMLCh* buf = new XMLCh[XMLString::stringLen(urn)+XMLString::stringLen(term)+3];
	XMLString::copyString(buf,urn);
	XMLString::catString(buf,X(":")); // FTT L":" doesn't work on 32bit unicode systems (like mac)
	XMLString::catString(buf,term);

	hrefPattern->SetContent(XMLString::replicate(buf),client);

	delete [] buf;

	XMLString::release(&urn);
	XMLString::release(&term);

	if (name) SetTermName(name,client);
}
	
void IMp7JrsControlledTermUseType::SetTermReferenceAnyURI(XMLCh* uri, XMLCh* term, XMLCh* name, Mp7JrsClientID client) 
{
	Mp7JrstermReferencePtr href = CreatetermReferenceType;
	Sethref(href,client);

	Mp7JrstermReferenceType_Local0Ptr ref = CreatetermReferenceType_LocalType0; 
	href->SettermReferenceType_LocalType0(ref,client);
	
	XMLCh* buf = new XMLCh[XMLString::stringLen(uri)+XMLString::stringLen(term)+3];
	XMLString::copyString(buf,uri);
	XMLString::catString(buf,X("/")); // FTT L"/" doesn't work on 32bit unicode systems (like mac)
	XMLString::catString(buf,term);

	ref->SetContent(XMLString::replicate(buf),client);

	delete [] buf;

	XMLString::release(&uri);
	XMLString::release(&term);

	if (name) SetTermName(name,client);
}

void IMp7JrsControlledTermUseType::GetTermReference(XMLCh** uri, XMLCh** term) 
{
	Mp7JrstermReferencePtr href = Gethref();
	if (!href) return;

	Mp7JrstermReferenceType_LocalPtr hrefPattern = href->GettermReferenceType_LocalType();

	XMLCh* colon = XMLString::transcode(":");

	// URN case
	if (hrefPattern) {
		XMLCh* hrefPat = hrefPattern->GetContent();

		XMLCh* uriBuf = XMLString::replicate(hrefPat);

		int lastColon = XMLString::lastIndexOf(uriBuf,colon[0]); // FTT L doesn't work on mac
		XMLString::copyNString (uriBuf,hrefPat,lastColon); 

		XMLCh* termBuf = XMLString::replicate(hrefPat);
		hrefPat+=lastColon+1;
		XMLString::copyNString (termBuf,hrefPat,XMLString::stringLen(hrefPat));

		*uri = uriBuf;
		*term = termBuf;
	}
	// anyURI case
	else {
		Mp7JrstermReferenceType_Local0Ptr hrefURI = href->GettermReferenceType_LocalType0();
		XMLCh* uriStr = hrefURI->GetContent();

		XMLCh* uriBuf = XMLString::replicate(uriStr);

		int lastSlash = XMLString::lastIndexOf(uriBuf,colon[0]); // FTT L doesn't work on mac
		XMLString::copyNString (uriBuf,uriStr,lastSlash); 

		XMLCh* termBuf = XMLString::replicate(uriStr);
		uriStr+=lastSlash+1;
		XMLString::copyNString (termBuf,uriStr,XMLString::stringLen(uriStr));

		*uri = uriBuf;
		*term = termBuf;
	}

	XMLString::release(&colon);
}

	
void IMp7JrsControlledTermUseType::SetTermName(XMLCh* name, Mp7JrsClientID client) 
{
	Mp7JrsInlineTermDefinitionType_Name_CollectionPtr nameColl = CreateInlineTermDefinitionType_Name_CollectionType;
	Mp7JrsInlineTermDefinitionType_Name_LocalPtr nameElem = CreateInlineTermDefinitionType_Name_LocalType;
	nameColl->addElement(nameElem,client);
	SetName(nameColl,client);

	nameElem->SetContent(name,client); 
	
}
// end extension included


