 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsCreationPreferencesType_Title_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Creator_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Keyword_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Location_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_DatePeriod_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Tool_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsCreationPreferencesType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsCreationPreferencesType_Title_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Title
#include "Mp7JrsCreationPreferencesType_Creator_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Creator
#include "Mp7JrsCreationPreferencesType_Keyword_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Keyword
#include "Mp7JrsCreationPreferencesType_Location_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Location
#include "Mp7JrsCreationPreferencesType_DatePeriod_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:DatePeriod
#include "Mp7JrsCreationPreferencesType_Tool_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Tool

#include <assert.h>
IMp7JrsCreationPreferencesType::IMp7JrsCreationPreferencesType()
{

// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtPropInit.h

}

IMp7JrsCreationPreferencesType::~IMp7JrsCreationPreferencesType()
{
// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtPropCleanup.h

}

Mp7JrsCreationPreferencesType::Mp7JrsCreationPreferencesType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsCreationPreferencesType::~Mp7JrsCreationPreferencesType()
{
	Cleanup();
}

void Mp7JrsCreationPreferencesType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Title = Mp7JrsCreationPreferencesType_Title_CollectionPtr(); // Collection
	m_Creator = Mp7JrsCreationPreferencesType_Creator_CollectionPtr(); // Collection
	m_Keyword = Mp7JrsCreationPreferencesType_Keyword_CollectionPtr(); // Collection
	m_Location = Mp7JrsCreationPreferencesType_Location_CollectionPtr(); // Collection
	m_DatePeriod = Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr(); // Collection
	m_Tool = Mp7JrsCreationPreferencesType_Tool_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtMyPropInit.h

}

void Mp7JrsCreationPreferencesType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	// Mp7JrsFactory::DeleteObject(m_Title);
	// Mp7JrsFactory::DeleteObject(m_Creator);
	// Mp7JrsFactory::DeleteObject(m_Keyword);
	// Mp7JrsFactory::DeleteObject(m_Location);
	// Mp7JrsFactory::DeleteObject(m_DatePeriod);
	// Mp7JrsFactory::DeleteObject(m_Tool);
}

void Mp7JrsCreationPreferencesType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use CreationPreferencesTypePtr, since we
	// might need GetBase(), which isn't defined in ICreationPreferencesType
    const Mp7JrsPtr< Mp7JrsCreationPreferencesType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsCreationPreferencesType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_Title);
		this->SetTitle(Mp7JrsFactory::CloneObject(tmp->GetTitle()));
		// Mp7JrsFactory::DeleteObject(m_Creator);
		this->SetCreator(Mp7JrsFactory::CloneObject(tmp->GetCreator()));
		// Mp7JrsFactory::DeleteObject(m_Keyword);
		this->SetKeyword(Mp7JrsFactory::CloneObject(tmp->GetKeyword()));
		// Mp7JrsFactory::DeleteObject(m_Location);
		this->SetLocation(Mp7JrsFactory::CloneObject(tmp->GetLocation()));
		// Mp7JrsFactory::DeleteObject(m_DatePeriod);
		this->SetDatePeriod(Mp7JrsFactory::CloneObject(tmp->GetDatePeriod()));
		// Mp7JrsFactory::DeleteObject(m_Tool);
		this->SetTool(Mp7JrsFactory::CloneObject(tmp->GetTool()));
}

Mp7JrsNodePtr Mp7JrsCreationPreferencesType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsCreationPreferencesType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsCreationPreferencesType::GetBase() const
{
	return m_Base;
}

Mp7JrspreferenceValuePtr Mp7JrsCreationPreferencesType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsCreationPreferencesType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsCreationPreferencesType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetpreferenceValue().");
	}
    m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
Mp7JrsCreationPreferencesType_Title_CollectionPtr Mp7JrsCreationPreferencesType::GetTitle() const
{
	return m_Title;
}

Mp7JrsCreationPreferencesType_Creator_CollectionPtr Mp7JrsCreationPreferencesType::GetCreator() const
{
	return m_Creator;
}

Mp7JrsCreationPreferencesType_Keyword_CollectionPtr Mp7JrsCreationPreferencesType::GetKeyword() const
{
	return m_Keyword;
}

Mp7JrsCreationPreferencesType_Location_CollectionPtr Mp7JrsCreationPreferencesType::GetLocation() const
{
	return m_Location;
}

Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr Mp7JrsCreationPreferencesType::GetDatePeriod() const
{
	return m_DatePeriod;
}

Mp7JrsCreationPreferencesType_Tool_CollectionPtr Mp7JrsCreationPreferencesType::GetTool() const
{
	return m_Tool;
}

void Mp7JrsCreationPreferencesType::SetTitle(const Mp7JrsCreationPreferencesType_Title_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetTitle().");
	}
	if (m_Title != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Title);
		m_Title = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Title) m_Title->SetParent(m_myself.getPointer());
		if(m_Title != Mp7JrsCreationPreferencesType_Title_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Title->SetContentName(XMLString::transcode("Title"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::SetCreator(const Mp7JrsCreationPreferencesType_Creator_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetCreator().");
	}
	if (m_Creator != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Creator);
		m_Creator = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Creator) m_Creator->SetParent(m_myself.getPointer());
		if(m_Creator != Mp7JrsCreationPreferencesType_Creator_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Creator->SetContentName(XMLString::transcode("Creator"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::SetKeyword(const Mp7JrsCreationPreferencesType_Keyword_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetKeyword().");
	}
	if (m_Keyword != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Keyword);
		m_Keyword = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Keyword) m_Keyword->SetParent(m_myself.getPointer());
		if(m_Keyword != Mp7JrsCreationPreferencesType_Keyword_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Keyword->SetContentName(XMLString::transcode("Keyword"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::SetLocation(const Mp7JrsCreationPreferencesType_Location_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetLocation().");
	}
	if (m_Location != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Location);
		m_Location = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Location) m_Location->SetParent(m_myself.getPointer());
		if(m_Location != Mp7JrsCreationPreferencesType_Location_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Location->SetContentName(XMLString::transcode("Location"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::SetDatePeriod(const Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetDatePeriod().");
	}
	if (m_DatePeriod != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DatePeriod);
		m_DatePeriod = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DatePeriod) m_DatePeriod->SetParent(m_myself.getPointer());
		if(m_DatePeriod != Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_DatePeriod->SetContentName(XMLString::transcode("DatePeriod"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::SetTool(const Mp7JrsCreationPreferencesType_Tool_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetTool().");
	}
	if (m_Tool != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Tool);
		m_Tool = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Tool) m_Tool->SetParent(m_myself.getPointer());
		if(m_Tool != Mp7JrsCreationPreferencesType_Tool_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Tool->SetContentName(XMLString::transcode("Tool"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsCreationPreferencesType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsCreationPreferencesType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsCreationPreferencesType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsCreationPreferencesType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsCreationPreferencesType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsCreationPreferencesType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsCreationPreferencesType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsCreationPreferencesType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsCreationPreferencesType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsCreationPreferencesType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsCreationPreferencesType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsCreationPreferencesType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsCreationPreferencesType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsCreationPreferencesType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsCreationPreferencesType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCreationPreferencesType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsCreationPreferencesType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsCreationPreferencesType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCreationPreferencesType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsCreationPreferencesType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Title")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Title is item of type CreationPreferencesType_Title_LocalType
		// in element collection CreationPreferencesType_Title_CollectionType
		
		context->Found = true;
		Mp7JrsCreationPreferencesType_Title_CollectionPtr coll = GetTitle();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCreationPreferencesType_Title_CollectionType;
				SetTitle(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationPreferencesType_Title_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationPreferencesType_Title_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Creator")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Creator is item of type CreationPreferencesType_Creator_LocalType
		// in element collection CreationPreferencesType_Creator_CollectionType
		
		context->Found = true;
		Mp7JrsCreationPreferencesType_Creator_CollectionPtr coll = GetCreator();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCreationPreferencesType_Creator_CollectionType;
				SetCreator(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationPreferencesType_Creator_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationPreferencesType_Creator_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Keyword")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Keyword is item of type CreationPreferencesType_Keyword_LocalType
		// in element collection CreationPreferencesType_Keyword_CollectionType
		
		context->Found = true;
		Mp7JrsCreationPreferencesType_Keyword_CollectionPtr coll = GetKeyword();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCreationPreferencesType_Keyword_CollectionType;
				SetKeyword(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationPreferencesType_Keyword_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationPreferencesType_Keyword_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Location")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Location is item of type CreationPreferencesType_Location_LocalType
		// in element collection CreationPreferencesType_Location_CollectionType
		
		context->Found = true;
		Mp7JrsCreationPreferencesType_Location_CollectionPtr coll = GetLocation();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCreationPreferencesType_Location_CollectionType;
				SetLocation(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationPreferencesType_Location_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationPreferencesType_Location_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("DatePeriod")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:DatePeriod is item of type CreationPreferencesType_DatePeriod_LocalType
		// in element collection CreationPreferencesType_DatePeriod_CollectionType
		
		context->Found = true;
		Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr coll = GetDatePeriod();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCreationPreferencesType_DatePeriod_CollectionType;
				SetDatePeriod(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationPreferencesType_DatePeriod_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationPreferencesType_DatePeriod_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Tool")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Tool is item of type CreationPreferencesType_Tool_LocalType
		// in element collection CreationPreferencesType_Tool_CollectionType
		
		context->Found = true;
		Mp7JrsCreationPreferencesType_Tool_CollectionPtr coll = GetTool();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCreationPreferencesType_Tool_CollectionType;
				SetTool(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationPreferencesType_Tool_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationPreferencesType_Tool_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for CreationPreferencesType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "CreationPreferencesType");
	}		
	
	return result;
}

XMLCh * Mp7JrsCreationPreferencesType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsCreationPreferencesType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsCreationPreferencesType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("CreationPreferencesType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_Title != Mp7JrsCreationPreferencesType_Title_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Title->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Creator != Mp7JrsCreationPreferencesType_Creator_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Creator->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Keyword != Mp7JrsCreationPreferencesType_Keyword_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Keyword->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Location != Mp7JrsCreationPreferencesType_Location_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Location->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_DatePeriod != Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_DatePeriod->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Tool != Mp7JrsCreationPreferencesType_Tool_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Tool->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsCreationPreferencesType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("preferenceValue")))
	{
        // Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttributeNS(X(""), X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
        Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
        tmp->Parse(parent->getAttribute(X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Title"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Title")) == 0))
        {
            // Deserialize factory type
            Mp7JrsCreationPreferencesType_Title_CollectionPtr tmp = CreateCreationPreferencesType_Title_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetTitle(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Creator"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Creator")) == 0))
        {
            // Deserialize factory type
            Mp7JrsCreationPreferencesType_Creator_CollectionPtr tmp = CreateCreationPreferencesType_Creator_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetCreator(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Keyword"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Keyword")) == 0))
        {
            // Deserialize factory type
            Mp7JrsCreationPreferencesType_Keyword_CollectionPtr tmp = CreateCreationPreferencesType_Keyword_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetKeyword(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Location"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Location")) == 0))
        {
            // Deserialize factory type
            Mp7JrsCreationPreferencesType_Location_CollectionPtr tmp = CreateCreationPreferencesType_Location_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetLocation(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("DatePeriod"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("DatePeriod")) == 0))
        {
            // Deserialize factory type
            Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr tmp = CreateCreationPreferencesType_DatePeriod_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetDatePeriod(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Tool"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Tool")) == 0))
        {
            // Deserialize factory type
            Mp7JrsCreationPreferencesType_Tool_CollectionPtr tmp = CreateCreationPreferencesType_Tool_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetTool(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsCreationPreferencesType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Title")) == 0))
  {
    Mp7JrsCreationPreferencesType_Title_CollectionPtr tmp = CreateCreationPreferencesType_Title_CollectionType;
    this->SetTitle(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Creator")) == 0))
  {
    Mp7JrsCreationPreferencesType_Creator_CollectionPtr tmp = CreateCreationPreferencesType_Creator_CollectionType;
    this->SetCreator(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Keyword")) == 0))
  {
    Mp7JrsCreationPreferencesType_Keyword_CollectionPtr tmp = CreateCreationPreferencesType_Keyword_CollectionType;
    this->SetKeyword(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Location")) == 0))
  {
    Mp7JrsCreationPreferencesType_Location_CollectionPtr tmp = CreateCreationPreferencesType_Location_CollectionType;
    this->SetLocation(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("DatePeriod")) == 0))
  {
    Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr tmp = CreateCreationPreferencesType_DatePeriod_CollectionType;
    this->SetDatePeriod(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Tool")) == 0))
  {
    Mp7JrsCreationPreferencesType_Tool_CollectionPtr tmp = CreateCreationPreferencesType_Tool_CollectionType;
    this->SetTool(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsCreationPreferencesType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTitle() != Mp7JrsNodePtr())
		result.Insert(GetTitle());
	if (GetCreator() != Mp7JrsNodePtr())
		result.Insert(GetCreator());
	if (GetKeyword() != Mp7JrsNodePtr())
		result.Insert(GetKeyword());
	if (GetLocation() != Mp7JrsNodePtr())
		result.Insert(GetLocation());
	if (GetDatePeriod() != Mp7JrsNodePtr())
		result.Insert(GetDatePeriod());
	if (GetTool() != Mp7JrsNodePtr())
		result.Insert(GetTool());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtMethodImpl.h


