
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsErrorEventType_Status_LocalType_ExtImplInclude.h


#include "Mp7JrsErrorEventType_Status_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsErrorEventType_Status_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsErrorEventType_Status_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsErrorEventType_Status_LocalType::ToText(Mp7JrsErrorEventType_Status_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/undefined:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("undefined");
			break;
		case /*Enumeration::*/checked:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("checked");
			break;
		case /*Enumeration::*/needs_restoration:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("needs restoration");
			break;
		case /*Enumeration::*/restored:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("restored");
			break;
		case /*Enumeration::*/deleted:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("deleted");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsErrorEventType_Status_LocalType::Enumeration Mp7JrsErrorEventType_Status_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsErrorEventType_Status_LocalType::Enumeration result = Mp7JrsErrorEventType_Status_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "undefined") == 0)
	{
		result = Mp7JrsErrorEventType_Status_LocalType::/*Enumeration::*/undefined;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "checked") == 0)
	{
		result = Mp7JrsErrorEventType_Status_LocalType::/*Enumeration::*/checked;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "needs restoration") == 0)
	{
		result = Mp7JrsErrorEventType_Status_LocalType::/*Enumeration::*/needs_restoration;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "restored") == 0)
	{
		result = Mp7JrsErrorEventType_Status_LocalType::/*Enumeration::*/restored;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "deleted") == 0)
	{
		result = Mp7JrsErrorEventType_Status_LocalType::/*Enumeration::*/deleted;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
