 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtImplInclude.h



#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsTermUseType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtPropInit.h

}

IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::~IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtPropCleanup.h

}

Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::~Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType()
{
	Cleanup();
}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Init()
{

	// Init attributes
	m_index = NULL; // String
	m_index_Exist = false;
	m_frequency = CreatezeroToOneType; // Create a valid class
	m_frequency->SetContent(0.0); // Use Value initialiser (xxx2)
	m_frequency_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Text = Mp7JrsTermUsePtr(); // Class
	m_Text_Exist = false;
	m_InkSegmentRef = Mp7JrsReferencePtr(); // Class
	m_InkSegmentRef_Exist = false;


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtMyPropInit.h

}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_index);
	// Mp7JrsFactory::DeleteObject(m_frequency);
	// Mp7JrsFactory::DeleteObject(m_Text);
	// Mp7JrsFactory::DeleteObject(m_InkSegmentRef);
}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use HandWritingRecogInformationType_InkLexicon_Entry_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IHandWritingRecogInformationType_InkLexicon_Entry_LocalType
    const Mp7JrsPtr< Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	XMLString::release(&m_index);
	if (tmp->Existindex())
	{
		this->Setindex(XMLString::replicate(tmp->Getindex()));
	}
	else
	{
		Invalidateindex();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_frequency);
	if (tmp->Existfrequency())
	{
		this->Setfrequency(Mp7JrsFactory::CloneObject(tmp->Getfrequency()));
	}
	else
	{
		Invalidatefrequency();
	}
	}
	if (tmp->IsValidText())
	{
		// Mp7JrsFactory::DeleteObject(m_Text);
		this->SetText(Mp7JrsFactory::CloneObject(tmp->GetText()));
	}
	else
	{
		InvalidateText();
	}
	if (tmp->IsValidInkSegmentRef())
	{
		// Mp7JrsFactory::DeleteObject(m_InkSegmentRef);
		this->SetInkSegmentRef(Mp7JrsFactory::CloneObject(tmp->GetInkSegmentRef()));
	}
	else
	{
		InvalidateInkSegmentRef();
	}
}

Mp7JrsNodePtr Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Getindex() const
{
	return m_index;
}

bool Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Existindex() const
{
	return m_index_Exist;
}
void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Setindex(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Setindex().");
	}
    m_index = item;
	m_index_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Invalidateindex()
{
	m_index_Exist = false;
}
Mp7JrszeroToOnePtr Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Getfrequency() const
{
	return m_frequency;
}

bool Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Existfrequency() const
{
	return m_frequency_Exist;
}
void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Setfrequency(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Setfrequency().");
	}
    m_frequency = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_frequency) m_frequency->SetParent(m_myself.getPointer());
	m_frequency_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Invalidatefrequency()
{
	m_frequency_Exist = false;
}
Mp7JrsTermUsePtr Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::GetText() const
{
	return m_Text;
}

// Element is optional
bool Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::IsValidText() const
{
	return m_Text_Exist;
}

Mp7JrsReferencePtr Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::GetInkSegmentRef() const
{
	return m_InkSegmentRef;
}

// Element is optional
bool Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::IsValidInkSegmentRef() const
{
	return m_InkSegmentRef_Exist;
}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::SetText(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::SetText().");
	}
	if (m_Text != item || m_Text_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Text);
		m_Text = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Text) m_Text->SetParent(m_myself.getPointer());
		if (m_Text && m_Text->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Text->UseTypeAttribute = true;
		}
		m_Text_Exist = true;
		if(m_Text != Mp7JrsTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Text->SetContentName(XMLString::transcode("Text"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::InvalidateText()
{
	m_Text_Exist = false;
}
void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::SetInkSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::SetInkSegmentRef().");
	}
	if (m_InkSegmentRef != item || m_InkSegmentRef_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_InkSegmentRef);
		m_InkSegmentRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_InkSegmentRef) m_InkSegmentRef->SetParent(m_myself.getPointer());
		if (m_InkSegmentRef && m_InkSegmentRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_InkSegmentRef->UseTypeAttribute = true;
		}
		m_InkSegmentRef_Exist = true;
		if(m_InkSegmentRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_InkSegmentRef->SetContentName(XMLString::transcode("InkSegmentRef"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::InvalidateInkSegmentRef()
{
	m_InkSegmentRef_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Text")) == 0)
	{
		// Text is simple element TermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetText()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetText(p, client);
					if((p = GetText()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("InkSegmentRef")) == 0)
	{
		// InkSegmentRef is simple element ReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetInkSegmentRef()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetInkSegmentRef(p, client);
					if((p = GetInkSegmentRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for HandWritingRecogInformationType_InkLexicon_Entry_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "HandWritingRecogInformationType_InkLexicon_Entry_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("HandWritingRecogInformationType_InkLexicon_Entry_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_index_Exist)
	{
	// String
	if(m_index != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("index"), m_index);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_frequency_Exist)
	{
	// Class
	if (m_frequency != Mp7JrszeroToOnePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_frequency->ToText();
		element->setAttributeNS(X(""), X("frequency"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_Text != Mp7JrsTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Text->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Text"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Text->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_InkSegmentRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_InkSegmentRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("InkSegmentRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_InkSegmentRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("index")))
	{
        // Deserialize string type
        this->Setindex(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("index"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("index")))
	{
        // Deserialize string type
        this->Setindex(Mp7JrsConvert::TextToString(parent->getAttribute(X("index"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("frequency")))
	{
        // Deserialize class type
		Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
		tmp->Parse(parent->getAttributeNS(X(""), X("frequency")));
        this->Setfrequency(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("frequency")))
	{
		// Deserialize class type
        Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
        tmp->Parse(parent->getAttribute(X("frequency")));
        this->Setfrequency(tmp);
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Text"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Text")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetText(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("InkSegmentRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("InkSegmentRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetInkSegmentRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Text")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTermUseType;
    }
    this->SetText(child);
  }
  if (XMLString::compareString(elementname, X("InkSegmentRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetInkSegmentRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetText() != Mp7JrsNodePtr())
		result.Insert(GetText());
	if (GetInkSegmentRef() != Mp7JrsNodePtr())
		result.Insert(GetInkSegmentRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtMethodImpl.h


