 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtImplInclude.h



#include "Mp7JrsAudioLLDScalarType.h"
#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType.h"
#include "Mp7JrsintegerVector.h"
#include "Mp7JrsHarmonicSpectralSpreadType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:SeriesOfScalar

#include <assert.h>
IMp7JrsHarmonicSpectralSpreadType::IMp7JrsHarmonicSpectralSpreadType()
{

// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtPropInit.h

}

IMp7JrsHarmonicSpectralSpreadType::~IMp7JrsHarmonicSpectralSpreadType()
{
// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtPropCleanup.h

}

Mp7JrsHarmonicSpectralSpreadType::Mp7JrsHarmonicSpectralSpreadType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsHarmonicSpectralSpreadType::~Mp7JrsHarmonicSpectralSpreadType()
{
	Cleanup();
}

void Mp7JrsHarmonicSpectralSpreadType::Init()
{
	// Init base
	m_Base = CreateAudioLLDScalarType;
	m_Base->m_myself = m_myself.getPointer();
	




// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtMyPropInit.h

}

void Mp7JrsHarmonicSpectralSpreadType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
}

void Mp7JrsHarmonicSpectralSpreadType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use HarmonicSpectralSpreadTypePtr, since we
	// might need GetBase(), which isn't defined in IHarmonicSpectralSpreadType
    const Mp7JrsPtr< Mp7JrsHarmonicSpectralSpreadType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsAudioLLDScalarPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsHarmonicSpectralSpreadType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
}

Mp7JrsNodePtr Mp7JrsHarmonicSpectralSpreadType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsHarmonicSpectralSpreadType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsAudioLLDScalarType > Mp7JrsHarmonicSpectralSpreadType::GetBase() const
{
	return m_Base;
}

Mp7JrszeroToOnePtr Mp7JrsHarmonicSpectralSpreadType::Getconfidence() const
{
	return GetBase()->Getconfidence();
}

bool Mp7JrsHarmonicSpectralSpreadType::Existconfidence() const
{
	return GetBase()->Existconfidence();
}
void Mp7JrsHarmonicSpectralSpreadType::Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHarmonicSpectralSpreadType::Setconfidence().");
	}
	GetBase()->Setconfidence(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsHarmonicSpectralSpreadType::Invalidateconfidence()
{
	GetBase()->Invalidateconfidence();
}
float Mp7JrsHarmonicSpectralSpreadType::GetScalar() const
{
	return GetBase()->GetScalar();
}

Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr Mp7JrsHarmonicSpectralSpreadType::GetSeriesOfScalar() const
{
	return GetBase()->GetSeriesOfScalar();
}

// implementing setter for choice 
/* element */
void Mp7JrsHarmonicSpectralSpreadType::SetScalar(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHarmonicSpectralSpreadType::SetScalar().");
	}
	GetBase()->SetScalar(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsHarmonicSpectralSpreadType::SetSeriesOfScalar(const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHarmonicSpectralSpreadType::SetSeriesOfScalar().");
	}
	GetBase()->SetSeriesOfScalar(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsintegerVectorPtr Mp7JrsHarmonicSpectralSpreadType::Getchannels() const
{
	return GetBase()->GetBase()->Getchannels();
}

bool Mp7JrsHarmonicSpectralSpreadType::Existchannels() const
{
	return GetBase()->GetBase()->Existchannels();
}
void Mp7JrsHarmonicSpectralSpreadType::Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHarmonicSpectralSpreadType::Setchannels().");
	}
	GetBase()->GetBase()->Setchannels(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsHarmonicSpectralSpreadType::Invalidatechannels()
{
	GetBase()->GetBase()->Invalidatechannels();
}

Mp7JrsNodeEnum Mp7JrsHarmonicSpectralSpreadType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for HarmonicSpectralSpreadType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "HarmonicSpectralSpreadType");
	}		
	
	return result;
}

XMLCh * Mp7JrsHarmonicSpectralSpreadType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsHarmonicSpectralSpreadType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsHarmonicSpectralSpreadType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("HarmonicSpectralSpreadType"));
	// Element serialization:

}

bool Mp7JrsHarmonicSpectralSpreadType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsAudioLLDScalarType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsHarmonicSpectralSpreadType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsHarmonicSpectralSpreadType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSeriesOfScalar() != Mp7JrsNodePtr())
		result.Insert(GetSeriesOfScalar());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralSpreadType_ExtMethodImpl.h


