 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtImplInclude.h



#include "Mp7JrsMediaLocatorType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsRegionLocatorType.h"
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType::IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtPropInit.h

}

IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType::~IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtPropCleanup.h

}

Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::~Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType()
{
	Cleanup();
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Init()
{

	// Init attributes
	m_fieldIDRef = NULL; // String
	m_fieldIDRef_Exist = false;
	m_translationX = 0; // Value
	m_translationX_Default = 0;
	m_translationX_Exist = false;
	m_translationY = 0; // Value
	m_translationY_Default = 0;
	m_translationY_Exist = false;
	m_rotation = 0.0; // Value
	m_rotation_Default = 0.0;
	m_rotation_Exist = false;
	m_scaleX = 0.0; // Value
	m_scaleX_Default = 1.0;
	m_scaleX_Exist = false;
	m_scaleY = 0.0; // Value
	m_scaleY_Default = 1.0;
	m_scaleY_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_OverlaidMediaLocator = Mp7JrsMediaLocatorPtr(); // Class
	m_OverlaidMediaRef = Mp7JrsReferencePtr(); // Class
	m_MediaRegionLocator = Mp7JrsRegionLocatorPtr(); // Class
	m_MediaRegionLocator_Exist = false;


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtMyPropInit.h

}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_fieldIDRef);
	// Mp7JrsFactory::DeleteObject(m_OverlaidMediaLocator);
	// Mp7JrsFactory::DeleteObject(m_OverlaidMediaRef);
	// Mp7JrsFactory::DeleteObject(m_MediaRegionLocator);
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use InkMediaInformationType_OverlaidMedia_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IInkMediaInformationType_OverlaidMedia_LocalType
    const Mp7JrsPtr< Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	XMLString::release(&m_fieldIDRef);
	if (tmp->ExistfieldIDRef())
	{
		this->SetfieldIDRef(XMLString::replicate(tmp->GetfieldIDRef()));
	}
	else
	{
		InvalidatefieldIDRef();
	}
	}
	{
	if (tmp->ExisttranslationX())
	{
		this->SettranslationX(tmp->GettranslationX());
	}
	else
	{
		InvalidatetranslationX();
	}
	}
	{
	if (tmp->ExisttranslationY())
	{
		this->SettranslationY(tmp->GettranslationY());
	}
	else
	{
		InvalidatetranslationY();
	}
	}
	{
	if (tmp->Existrotation())
	{
		this->Setrotation(tmp->Getrotation());
	}
	else
	{
		Invalidaterotation();
	}
	}
	{
	if (tmp->ExistscaleX())
	{
		this->SetscaleX(tmp->GetscaleX());
	}
	else
	{
		InvalidatescaleX();
	}
	}
	{
	if (tmp->ExistscaleY())
	{
		this->SetscaleY(tmp->GetscaleY());
	}
	else
	{
		InvalidatescaleY();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_OverlaidMediaLocator);
		this->SetOverlaidMediaLocator(Mp7JrsFactory::CloneObject(tmp->GetOverlaidMediaLocator()));
		// Mp7JrsFactory::DeleteObject(m_OverlaidMediaRef);
		this->SetOverlaidMediaRef(Mp7JrsFactory::CloneObject(tmp->GetOverlaidMediaRef()));
	if (tmp->IsValidMediaRegionLocator())
	{
		// Mp7JrsFactory::DeleteObject(m_MediaRegionLocator);
		this->SetMediaRegionLocator(Mp7JrsFactory::CloneObject(tmp->GetMediaRegionLocator()));
	}
	else
	{
		InvalidateMediaRegionLocator();
	}
}

Mp7JrsNodePtr Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetfieldIDRef() const
{
	return m_fieldIDRef;
}

bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::ExistfieldIDRef() const
{
	return m_fieldIDRef_Exist;
}
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetfieldIDRef(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetfieldIDRef().");
	}
    m_fieldIDRef = item;
	m_fieldIDRef_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::InvalidatefieldIDRef()
{
	m_fieldIDRef_Exist = false;
}
int Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GettranslationX() const
{
	if (this->ExisttranslationX()) {
		return m_translationX;
	} else {
		return m_translationX_Default;
	}
}

bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::ExisttranslationX() const
{
	return m_translationX_Exist;
}
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SettranslationX(int item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SettranslationX().");
	}
    m_translationX = item;
	m_translationX_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::InvalidatetranslationX()
{
	m_translationX_Exist = false;
}
int Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GettranslationY() const
{
	if (this->ExisttranslationY()) {
		return m_translationY;
	} else {
		return m_translationY_Default;
	}
}

bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::ExisttranslationY() const
{
	return m_translationY_Exist;
}
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SettranslationY(int item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SettranslationY().");
	}
    m_translationY = item;
	m_translationY_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::InvalidatetranslationY()
{
	m_translationY_Exist = false;
}
float Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Getrotation() const
{
	if (this->Existrotation()) {
		return m_rotation;
	} else {
		return m_rotation_Default;
	}
}

bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Existrotation() const
{
	return m_rotation_Exist;
}
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Setrotation(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Setrotation().");
	}
    m_rotation = item;
	m_rotation_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Invalidaterotation()
{
	m_rotation_Exist = false;
}
float Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetscaleX() const
{
	if (this->ExistscaleX()) {
		return m_scaleX;
	} else {
		return m_scaleX_Default;
	}
}

bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::ExistscaleX() const
{
	return m_scaleX_Exist;
}
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetscaleX(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetscaleX().");
	}
    m_scaleX = item;
	m_scaleX_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::InvalidatescaleX()
{
	m_scaleX_Exist = false;
}
float Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetscaleY() const
{
	if (this->ExistscaleY()) {
		return m_scaleY;
	} else {
		return m_scaleY_Default;
	}
}

bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::ExistscaleY() const
{
	return m_scaleY_Exist;
}
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetscaleY(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetscaleY().");
	}
    m_scaleY = item;
	m_scaleY_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::InvalidatescaleY()
{
	m_scaleY_Exist = false;
}
Mp7JrsMediaLocatorPtr Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetOverlaidMediaLocator() const
{
	return m_OverlaidMediaLocator;
}

Mp7JrsReferencePtr Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetOverlaidMediaRef() const
{
	return m_OverlaidMediaRef;
}

Mp7JrsRegionLocatorPtr Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetMediaRegionLocator() const
{
	return m_MediaRegionLocator;
}

// Element is optional
bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::IsValidMediaRegionLocator() const
{
	return m_MediaRegionLocator_Exist;
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetOverlaidMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetOverlaidMediaLocator().");
	}
	if (m_OverlaidMediaLocator != item)
	{
		// Mp7JrsFactory::DeleteObject(m_OverlaidMediaLocator);
		m_OverlaidMediaLocator = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_OverlaidMediaLocator) m_OverlaidMediaLocator->SetParent(m_myself.getPointer());
		if (m_OverlaidMediaLocator && m_OverlaidMediaLocator->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaLocatorType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_OverlaidMediaLocator->UseTypeAttribute = true;
		}
		if(m_OverlaidMediaLocator != Mp7JrsMediaLocatorPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_OverlaidMediaLocator->SetContentName(XMLString::transcode("OverlaidMediaLocator"));
		}
	// Mp7JrsFactory::DeleteObject(m_OverlaidMediaRef);
	m_OverlaidMediaRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetOverlaidMediaRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetOverlaidMediaRef().");
	}
	if (m_OverlaidMediaRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_OverlaidMediaRef);
		m_OverlaidMediaRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_OverlaidMediaRef) m_OverlaidMediaRef->SetParent(m_myself.getPointer());
		if (m_OverlaidMediaRef && m_OverlaidMediaRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_OverlaidMediaRef->UseTypeAttribute = true;
		}
		if(m_OverlaidMediaRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_OverlaidMediaRef->SetContentName(XMLString::transcode("OverlaidMediaRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_OverlaidMediaLocator);
	m_OverlaidMediaLocator = Mp7JrsMediaLocatorPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetMediaRegionLocator(const Mp7JrsRegionLocatorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::SetMediaRegionLocator().");
	}
	if (m_MediaRegionLocator != item || m_MediaRegionLocator_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaRegionLocator);
		m_MediaRegionLocator = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaRegionLocator) m_MediaRegionLocator->SetParent(m_myself.getPointer());
		if (m_MediaRegionLocator && m_MediaRegionLocator->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:RegionLocatorType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaRegionLocator->UseTypeAttribute = true;
		}
		m_MediaRegionLocator_Exist = true;
		if(m_MediaRegionLocator != Mp7JrsRegionLocatorPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaRegionLocator->SetContentName(XMLString::transcode("MediaRegionLocator"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::InvalidateMediaRegionLocator()
{
	m_MediaRegionLocator_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("OverlaidMediaLocator")) == 0)
	{
		// OverlaidMediaLocator is simple element MediaLocatorType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetOverlaidMediaLocator()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaLocatorType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaLocatorPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetOverlaidMediaLocator(p, client);
					if((p = GetOverlaidMediaLocator()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("OverlaidMediaRef")) == 0)
	{
		// OverlaidMediaRef is simple element ReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetOverlaidMediaRef()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetOverlaidMediaRef(p, client);
					if((p = GetOverlaidMediaRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaRegionLocator")) == 0)
	{
		// MediaRegionLocator is simple element RegionLocatorType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMediaRegionLocator()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:RegionLocatorType")))) != empty)
			{
				// Is type allowed
				Mp7JrsRegionLocatorPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMediaRegionLocator(p, client);
					if((p = GetMediaRegionLocator()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for InkMediaInformationType_OverlaidMedia_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "InkMediaInformationType_OverlaidMedia_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("InkMediaInformationType_OverlaidMedia_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_fieldIDRef_Exist)
	{
	// String
	if(m_fieldIDRef != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("fieldIDRef"), m_fieldIDRef);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_translationX_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_translationX);
		element->setAttributeNS(X(""), X("translationX"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_translationY_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_translationY);
		element->setAttributeNS(X(""), X("translationY"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_rotation_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_rotation);
		element->setAttributeNS(X(""), X("rotation"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_scaleX_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_scaleX);
		element->setAttributeNS(X(""), X("scaleX"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_scaleY_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_scaleY);
		element->setAttributeNS(X(""), X("scaleY"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_OverlaidMediaLocator != Mp7JrsMediaLocatorPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_OverlaidMediaLocator->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("OverlaidMediaLocator"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_OverlaidMediaLocator->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_OverlaidMediaRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_OverlaidMediaRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("OverlaidMediaRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_OverlaidMediaRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MediaRegionLocator != Mp7JrsRegionLocatorPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaRegionLocator->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaRegionLocator"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaRegionLocator->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("fieldIDRef")))
	{
        // Deserialize string type
        this->SetfieldIDRef(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("fieldIDRef"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("fieldIDRef")))
	{
        // Deserialize string type
        this->SetfieldIDRef(Mp7JrsConvert::TextToString(parent->getAttribute(X("fieldIDRef"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("translationX")))
	{
        // deserialize value type
        this->SettranslationX(Mp7JrsConvert::TextToInt(parent->getAttributeNS(X(""), X("translationX"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("translationX")))
	{
        // deserialize value type
        this->SettranslationX(Mp7JrsConvert::TextToInt(parent->getAttribute(X("translationX"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("translationY")))
	{
        // deserialize value type
        this->SettranslationY(Mp7JrsConvert::TextToInt(parent->getAttributeNS(X(""), X("translationY"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("translationY")))
	{
        // deserialize value type
        this->SettranslationY(Mp7JrsConvert::TextToInt(parent->getAttribute(X("translationY"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("rotation")))
	{
        // deserialize value type
        this->Setrotation(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("rotation"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("rotation")))
	{
        // deserialize value type
        this->Setrotation(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("rotation"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("scaleX")))
	{
        // deserialize value type
        this->SetscaleX(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("scaleX"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("scaleX")))
	{
        // deserialize value type
        this->SetscaleX(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("scaleX"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("scaleY")))
	{
        // deserialize value type
        this->SetscaleY(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("scaleY"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("scaleY")))
	{
        // deserialize value type
        this->SetscaleY(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("scaleY"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("OverlaidMediaLocator"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("OverlaidMediaLocator")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaLocatorType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetOverlaidMediaLocator(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("OverlaidMediaRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("OverlaidMediaRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetOverlaidMediaRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaRegionLocator"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaRegionLocator")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateRegionLocatorType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMediaRegionLocator(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("OverlaidMediaLocator")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaLocatorType;
    }
    this->SetOverlaidMediaLocator(child);
  }
  if (XMLString::compareString(elementname, X("OverlaidMediaRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetOverlaidMediaRef(child);
  }
  if (XMLString::compareString(elementname, X("MediaRegionLocator")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateRegionLocatorType;
    }
    this->SetMediaRegionLocator(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMediaRegionLocator() != Mp7JrsNodePtr())
		result.Insert(GetMediaRegionLocator());
	if (GetOverlaidMediaLocator() != Mp7JrsNodePtr())
		result.Insert(GetOverlaidMediaLocator());
	if (GetOverlaidMediaRef() != Mp7JrsNodePtr())
		result.Insert(GetOverlaidMediaRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtMethodImpl.h


