 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtImplInclude.h



#include "Mp7JrsHandWritingRecogInformationType.h"
#include "Mp7JrsHandWritingRecogResultType.h"
#include "Mp7JrsInkSegmentType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsInkSegmentType_LocalType::IMp7JrsInkSegmentType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtPropInit.h

}

IMp7JrsInkSegmentType_LocalType::~IMp7JrsInkSegmentType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtPropCleanup.h

}

Mp7JrsInkSegmentType_LocalType::Mp7JrsInkSegmentType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsInkSegmentType_LocalType::~Mp7JrsInkSegmentType_LocalType()
{
	Cleanup();
}

void Mp7JrsInkSegmentType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_HandWritingRecogInformation = Mp7JrsHandWritingRecogInformationPtr(); // Class
	m_HandWritingRecogResult = Mp7JrsHandWritingRecogResultPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtMyPropInit.h

}

void Mp7JrsInkSegmentType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_HandWritingRecogInformation);
	// Mp7JrsFactory::DeleteObject(m_HandWritingRecogResult);
}

void Mp7JrsInkSegmentType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use InkSegmentType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IInkSegmentType_LocalType
    const Mp7JrsPtr< Mp7JrsInkSegmentType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_HandWritingRecogInformation);
		this->SetHandWritingRecogInformation(Mp7JrsFactory::CloneObject(tmp->GetHandWritingRecogInformation()));
		// Mp7JrsFactory::DeleteObject(m_HandWritingRecogResult);
		this->SetHandWritingRecogResult(Mp7JrsFactory::CloneObject(tmp->GetHandWritingRecogResult()));
}

Mp7JrsNodePtr Mp7JrsInkSegmentType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsInkSegmentType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsHandWritingRecogInformationPtr Mp7JrsInkSegmentType_LocalType::GetHandWritingRecogInformation() const
{
	return m_HandWritingRecogInformation;
}

Mp7JrsHandWritingRecogResultPtr Mp7JrsInkSegmentType_LocalType::GetHandWritingRecogResult() const
{
	return m_HandWritingRecogResult;
}

// implementing setter for choice 
/* element */
void Mp7JrsInkSegmentType_LocalType::SetHandWritingRecogInformation(const Mp7JrsHandWritingRecogInformationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkSegmentType_LocalType::SetHandWritingRecogInformation().");
	}
	if (m_HandWritingRecogInformation != item)
	{
		// Mp7JrsFactory::DeleteObject(m_HandWritingRecogInformation);
		m_HandWritingRecogInformation = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_HandWritingRecogInformation) m_HandWritingRecogInformation->SetParent(m_myself.getPointer());
		if (m_HandWritingRecogInformation && m_HandWritingRecogInformation->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:HandWritingRecogInformationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_HandWritingRecogInformation->UseTypeAttribute = true;
		}
		if(m_HandWritingRecogInformation != Mp7JrsHandWritingRecogInformationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_HandWritingRecogInformation->SetContentName(XMLString::transcode("HandWritingRecogInformation"));
		}
	// Mp7JrsFactory::DeleteObject(m_HandWritingRecogResult);
	m_HandWritingRecogResult = Mp7JrsHandWritingRecogResultPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsInkSegmentType_LocalType::SetHandWritingRecogResult(const Mp7JrsHandWritingRecogResultPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInkSegmentType_LocalType::SetHandWritingRecogResult().");
	}
	if (m_HandWritingRecogResult != item)
	{
		// Mp7JrsFactory::DeleteObject(m_HandWritingRecogResult);
		m_HandWritingRecogResult = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_HandWritingRecogResult) m_HandWritingRecogResult->SetParent(m_myself.getPointer());
		if (m_HandWritingRecogResult && m_HandWritingRecogResult->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:HandWritingRecogResultType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_HandWritingRecogResult->UseTypeAttribute = true;
		}
		if(m_HandWritingRecogResult != Mp7JrsHandWritingRecogResultPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_HandWritingRecogResult->SetContentName(XMLString::transcode("HandWritingRecogResult"));
		}
	// Mp7JrsFactory::DeleteObject(m_HandWritingRecogInformation);
	m_HandWritingRecogInformation = Mp7JrsHandWritingRecogInformationPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: InkSegmentType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsInkSegmentType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsInkSegmentType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsInkSegmentType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsInkSegmentType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_HandWritingRecogInformation != Mp7JrsHandWritingRecogInformationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_HandWritingRecogInformation->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("HandWritingRecogInformation"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_HandWritingRecogInformation->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_HandWritingRecogResult != Mp7JrsHandWritingRecogResultPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_HandWritingRecogResult->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("HandWritingRecogResult"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_HandWritingRecogResult->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsInkSegmentType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("HandWritingRecogInformation"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("HandWritingRecogInformation")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateHandWritingRecogInformationType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetHandWritingRecogInformation(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("HandWritingRecogResult"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("HandWritingRecogResult")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateHandWritingRecogResultType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetHandWritingRecogResult(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsInkSegmentType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("HandWritingRecogInformation")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateHandWritingRecogInformationType;
    }
    this->SetHandWritingRecogInformation(child);
  }
  if (XMLString::compareString(elementname, X("HandWritingRecogResult")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateHandWritingRecogResultType;
    }
    this->SetHandWritingRecogResult(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsInkSegmentType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetHandWritingRecogInformation() != Mp7JrsNodePtr())
		result.Insert(GetHandWritingRecogInformation());
	if (GetHandWritingRecogResult() != Mp7JrsNodePtr())
		result.Insert(GetHandWritingRecogResult());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtMethodImpl.h


