 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtImplInclude.h



#include "Mp7JrsInlineTermDefinitionType.h"
#include "Mp7JrstermRelationQualifierType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Definition_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Definition
#include "Mp7JrsInlineTermDefinitionType_Term_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Term

#include <assert.h>
IMp7JrsInlineTermDefinitionType_Term_LocalType::IMp7JrsInlineTermDefinitionType_Term_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtPropInit.h

}

IMp7JrsInlineTermDefinitionType_Term_LocalType::~IMp7JrsInlineTermDefinitionType_Term_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtPropCleanup.h

}

Mp7JrsInlineTermDefinitionType_Term_LocalType::Mp7JrsInlineTermDefinitionType_Term_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsInlineTermDefinitionType_Term_LocalType::~Mp7JrsInlineTermDefinitionType_Term_LocalType()
{
	Cleanup();
}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::Init()
{
	// Init base
	m_Base = CreateInlineTermDefinitionType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_relation = Mp7JrstermRelationQualifierPtr(); // Create emtpy class ptr
	m_relation_Exist = false;
	m_termID = NULL; // String
	m_termID_Exist = false;



// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtMyPropInit.h

}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_relation);
	XMLString::release(&m_termID);
}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use InlineTermDefinitionType_Term_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IInlineTermDefinitionType_Term_LocalType
    const Mp7JrsPtr< Mp7JrsInlineTermDefinitionType_Term_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsInlineTermDefinitionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsInlineTermDefinitionType_Term_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_relation);
	if (tmp->Existrelation())
	{
		this->Setrelation(Mp7JrsFactory::CloneObject(tmp->Getrelation()));
	}
	else
	{
		Invalidaterelation();
	}
	}
	{
	XMLString::release(&m_termID);
	if (tmp->ExisttermID())
	{
		this->SettermID(XMLString::replicate(tmp->GettermID()));
	}
	else
	{
		InvalidatetermID();
	}
	}
}

Mp7JrsNodePtr Mp7JrsInlineTermDefinitionType_Term_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsInlineTermDefinitionType_Term_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsInlineTermDefinitionType > Mp7JrsInlineTermDefinitionType_Term_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrstermRelationQualifierPtr Mp7JrsInlineTermDefinitionType_Term_LocalType::Getrelation() const
{
	if (this->Existrelation()) {
		return m_relation;
	} else {
		return m_relation_Default;
	}
}

bool Mp7JrsInlineTermDefinitionType_Term_LocalType::Existrelation() const
{
	return m_relation_Exist;
}
void Mp7JrsInlineTermDefinitionType_Term_LocalType::Setrelation(const Mp7JrstermRelationQualifierPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInlineTermDefinitionType_Term_LocalType::Setrelation().");
	}
    m_relation = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_relation) m_relation->SetParent(m_myself.getPointer());
	m_relation_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::Invalidaterelation()
{
	m_relation_Exist = false;
}
XMLCh * Mp7JrsInlineTermDefinitionType_Term_LocalType::GettermID() const
{
	return m_termID;
}

bool Mp7JrsInlineTermDefinitionType_Term_LocalType::ExisttermID() const
{
	return m_termID_Exist;
}
void Mp7JrsInlineTermDefinitionType_Term_LocalType::SettermID(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInlineTermDefinitionType_Term_LocalType::SettermID().");
	}
    m_termID = item;
	m_termID_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::InvalidatetermID()
{
	m_termID_Exist = false;
}
Mp7JrsInlineTermDefinitionType_Name_CollectionPtr Mp7JrsInlineTermDefinitionType_Term_LocalType::GetName() const
{
	return GetBase()->GetName();
}

Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr Mp7JrsInlineTermDefinitionType_Term_LocalType::GetDefinition() const
{
	return GetBase()->GetDefinition();
}

Mp7JrsInlineTermDefinitionType_Term_CollectionPtr Mp7JrsInlineTermDefinitionType_Term_LocalType::GetTerm() const
{
	return GetBase()->GetTerm();
}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInlineTermDefinitionType_Term_LocalType::SetName().");
	}
	GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInlineTermDefinitionType_Term_LocalType::SetDefinition().");
	}
	GetBase()->SetDefinition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsInlineTermDefinitionType_Term_LocalType::SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsInlineTermDefinitionType_Term_LocalType::SetTerm().");
	}
	GetBase()->SetTerm(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsInlineTermDefinitionType_Term_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for InlineTermDefinitionType_Term_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "InlineTermDefinitionType_Term_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsInlineTermDefinitionType_Term_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsInlineTermDefinitionType_Term_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsInlineTermDefinitionType_Term_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("InlineTermDefinitionType_Term_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_relation_Exist)
	{
	// Class
	if (m_relation != Mp7JrstermRelationQualifierPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_relation->ToText();
		element->setAttributeNS(X(""), X("relation"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_termID_Exist)
	{
	// String
	if(m_termID != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("termID"), m_termID);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsInlineTermDefinitionType_Term_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("relation")))
	{
        // Deserialize class type
		Mp7JrstermRelationQualifierPtr tmp = CreatetermRelationQualifierType;
		tmp->Parse(parent->getAttributeNS(X(""), X("relation")));
        this->Setrelation(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("relation")))
	{
		// Deserialize class type
        Mp7JrstermRelationQualifierPtr tmp = CreatetermRelationQualifierType;
        tmp->Parse(parent->getAttribute(X("relation")));
        this->Setrelation(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("termID")))
	{
        // Deserialize string type
        this->SettermID(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("termID"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("termID")))
	{
        // Deserialize string type
        this->SettermID(Mp7JrsConvert::TextToString(parent->getAttribute(X("termID"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsInlineTermDefinitionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsInlineTermDefinitionType_Term_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsInlineTermDefinitionType_Term_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetDefinition() != Mp7JrsNodePtr())
		result.Insert(GetDefinition());
	if (GetTerm() != Mp7JrsNodePtr())
		result.Insert(GetTerm());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtMethodImpl.h


