 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtImplInclude.h



#include "Mp7JrsMaskType.h"
#include "Mp7JrsMediaSpaceMaskType_SubInterval_CollectionType.h"
#include "Mp7JrsMediaSpaceMaskType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsMediaSpaceMaskType_SubInterval_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:SubInterval

#include <assert.h>
IMp7JrsMediaSpaceMaskType::IMp7JrsMediaSpaceMaskType()
{

// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtPropInit.h

}

IMp7JrsMediaSpaceMaskType::~IMp7JrsMediaSpaceMaskType()
{
// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtPropCleanup.h

}

Mp7JrsMediaSpaceMaskType::Mp7JrsMediaSpaceMaskType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaSpaceMaskType::~Mp7JrsMediaSpaceMaskType()
{
	Cleanup();
}

void Mp7JrsMediaSpaceMaskType::Init()
{
	// Init base
	m_Base = CreateMaskType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_SubInterval = Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtMyPropInit.h

}

void Mp7JrsMediaSpaceMaskType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_SubInterval);
}

void Mp7JrsMediaSpaceMaskType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaSpaceMaskTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaSpaceMaskType
    const Mp7JrsPtr< Mp7JrsMediaSpaceMaskType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsMaskPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMediaSpaceMaskType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_SubInterval);
		this->SetSubInterval(Mp7JrsFactory::CloneObject(tmp->GetSubInterval()));
}

Mp7JrsNodePtr Mp7JrsMediaSpaceMaskType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsMediaSpaceMaskType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsMaskType > Mp7JrsMediaSpaceMaskType::GetBase() const
{
	return m_Base;
}

Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr Mp7JrsMediaSpaceMaskType::GetSubInterval() const
{
	return m_SubInterval;
}

void Mp7JrsMediaSpaceMaskType::SetSubInterval(const Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaSpaceMaskType::SetSubInterval().");
	}
	if (m_SubInterval != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SubInterval);
		m_SubInterval = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SubInterval) m_SubInterval->SetParent(m_myself.getPointer());
		if(m_SubInterval != Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SubInterval->SetContentName(XMLString::transcode("SubInterval"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsMediaSpaceMaskType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("SubInterval")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:SubInterval is item of type MediaSpaceMaskType_SubInterval_LocalType
		// in element collection MediaSpaceMaskType_SubInterval_CollectionType
		
		context->Found = true;
		Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr coll = GetSubInterval();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMediaSpaceMaskType_SubInterval_CollectionType;
				SetSubInterval(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaSpaceMaskType_SubInterval_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaSpaceMaskType_SubInterval_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MediaSpaceMaskType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MediaSpaceMaskType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMediaSpaceMaskType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsMediaSpaceMaskType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsMediaSpaceMaskType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaSpaceMaskType"));
	// Element serialization:
	if (m_SubInterval != Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SubInterval->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsMediaSpaceMaskType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsMaskType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("SubInterval"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("SubInterval")) == 0))
        {
            // Deserialize factory type
            Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr tmp = CreateMediaSpaceMaskType_SubInterval_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSubInterval(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaSpaceMaskType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("SubInterval")) == 0))
  {
    Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr tmp = CreateMediaSpaceMaskType_SubInterval_CollectionType;
    this->SetSubInterval(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaSpaceMaskType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSubInterval() != Mp7JrsNodePtr())
		result.Insert(GetSubInterval());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtMethodImpl.h


