 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtImplInclude.h



#include "Mp7JrsCollectionType.h"
#include "Mp7JrsMixedCollectionType_CollectionType.h"
#include "Mp7JrsMixedCollectionType_CollectionType0.h"
#include "Mp7JrsMixedCollectionType_Descriptor_CollectionType.h"
#include "Mp7JrsMixedCollectionType_CollectionType1.h"
#include "Mp7JrsMixedCollectionType_CollectionType2.h"
#include "Mp7JrsCreationInformationType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsUsageInformationType.h"
#include "Mp7JrsCollectionType_TextAnnotation_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsMixedCollectionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsTextAnnotationType.h" // Element collection urn:mpeg:mpeg7:schema:2004:TextAnnotation
#include "Mp7JrsMixedCollectionType_LocalType.h" // Choice collection Content
#include "Mp7JrsMultimediaContentType.h" // Choice collection element Content
#include "Mp7JrsMixedCollectionType_LocalType0.h" // Choice collection Segment
#include "Mp7JrsSegmentType.h" // Choice collection element Segment
#include "Mp7JrsDType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Descriptor
#include "Mp7JrsMixedCollectionType_LocalType1.h" // Choice collection Concept
#include "Mp7JrsSemanticBaseType.h" // Choice collection element Concept
#include "Mp7JrsMixedCollectionType_LocalType2.h" // Choice collection MixedCollection
#include "Mp7JrsMixedCollectionType.h" // Choice collection element MixedCollection

#include <assert.h>
IMp7JrsMixedCollectionType::IMp7JrsMixedCollectionType()
{

// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtPropInit.h

}

IMp7JrsMixedCollectionType::~IMp7JrsMixedCollectionType()
{
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtPropCleanup.h

}

Mp7JrsMixedCollectionType::Mp7JrsMixedCollectionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMixedCollectionType::~Mp7JrsMixedCollectionType()
{
	Cleanup();
}

void Mp7JrsMixedCollectionType::Init()
{
	// Init base
	m_Base = CreateCollectionType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_MixedCollectionType_LocalType = Mp7JrsMixedCollectionType_CollectionPtr(); // Collection
	m_MixedCollectionType_LocalType0 = Mp7JrsMixedCollectionType_Collection0Ptr(); // Collection
	m_Descriptor = Mp7JrsMixedCollectionType_Descriptor_CollectionPtr(); // Collection
	m_MixedCollectionType_LocalType1 = Mp7JrsMixedCollectionType_Collection1Ptr(); // Collection
	m_MixedCollectionType_LocalType2 = Mp7JrsMixedCollectionType_Collection2Ptr(); // Collection


// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtMyPropInit.h

}

void Mp7JrsMixedCollectionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType);
	// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType0);
	// Mp7JrsFactory::DeleteObject(m_Descriptor);
	// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType1);
	// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType2);
}

void Mp7JrsMixedCollectionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MixedCollectionTypePtr, since we
	// might need GetBase(), which isn't defined in IMixedCollectionType
    const Mp7JrsPtr< Mp7JrsMixedCollectionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsCollectionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMixedCollectionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType);
		this->SetMixedCollectionType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetMixedCollectionType_LocalType()));
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType0);
		this->SetMixedCollectionType_LocalType0(Mp7JrsFactory::CloneObject(tmp->GetMixedCollectionType_LocalType0()));
		// Mp7JrsFactory::DeleteObject(m_Descriptor);
		this->SetDescriptor(Mp7JrsFactory::CloneObject(tmp->GetDescriptor()));
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType1);
		this->SetMixedCollectionType_LocalType1(Mp7JrsFactory::CloneObject(tmp->GetMixedCollectionType_LocalType1()));
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType2);
		this->SetMixedCollectionType_LocalType2(Mp7JrsFactory::CloneObject(tmp->GetMixedCollectionType_LocalType2()));
}

Mp7JrsNodePtr Mp7JrsMixedCollectionType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsMixedCollectionType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsCollectionType > Mp7JrsMixedCollectionType::GetBase() const
{
	return m_Base;
}

Mp7JrsMixedCollectionType_CollectionPtr Mp7JrsMixedCollectionType::GetMixedCollectionType_LocalType() const
{
	return m_MixedCollectionType_LocalType;
}

Mp7JrsMixedCollectionType_Collection0Ptr Mp7JrsMixedCollectionType::GetMixedCollectionType_LocalType0() const
{
	return m_MixedCollectionType_LocalType0;
}

Mp7JrsMixedCollectionType_Descriptor_CollectionPtr Mp7JrsMixedCollectionType::GetDescriptor() const
{
	return m_Descriptor;
}

Mp7JrsMixedCollectionType_Collection1Ptr Mp7JrsMixedCollectionType::GetMixedCollectionType_LocalType1() const
{
	return m_MixedCollectionType_LocalType1;
}

Mp7JrsMixedCollectionType_Collection2Ptr Mp7JrsMixedCollectionType::GetMixedCollectionType_LocalType2() const
{
	return m_MixedCollectionType_LocalType2;
}

void Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType(const Mp7JrsMixedCollectionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType().");
	}
	if (m_MixedCollectionType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType);
		m_MixedCollectionType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MixedCollectionType_LocalType) m_MixedCollectionType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType0(const Mp7JrsMixedCollectionType_Collection0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType0().");
	}
	if (m_MixedCollectionType_LocalType0 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType0);
		m_MixedCollectionType_LocalType0 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MixedCollectionType_LocalType0) m_MixedCollectionType_LocalType0->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::SetDescriptor(const Mp7JrsMixedCollectionType_Descriptor_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetDescriptor().");
	}
	if (m_Descriptor != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Descriptor);
		m_Descriptor = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Descriptor) m_Descriptor->SetParent(m_myself.getPointer());
		if(m_Descriptor != Mp7JrsMixedCollectionType_Descriptor_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Descriptor->SetContentName(XMLString::transcode("Descriptor"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType1(const Mp7JrsMixedCollectionType_Collection1Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType1().");
	}
	if (m_MixedCollectionType_LocalType1 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType1);
		m_MixedCollectionType_LocalType1 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MixedCollectionType_LocalType1) m_MixedCollectionType_LocalType1->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType2(const Mp7JrsMixedCollectionType_Collection2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetMixedCollectionType_LocalType2().");
	}
	if (m_MixedCollectionType_LocalType2 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionType_LocalType2);
		m_MixedCollectionType_LocalType2 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MixedCollectionType_LocalType2) m_MixedCollectionType_LocalType2->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsMixedCollectionType::Getname() const
{
	return GetBase()->Getname();
}

bool Mp7JrsMixedCollectionType::Existname() const
{
	return GetBase()->Existname();
}
void Mp7JrsMixedCollectionType::Setname(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::Setname().");
	}
	GetBase()->Setname(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::Invalidatename()
{
	GetBase()->Invalidatename();
}
Mp7JrsCreationInformationPtr Mp7JrsMixedCollectionType::GetCreationInformation() const
{
	return GetBase()->GetCreationInformation();
}

Mp7JrsReferencePtr Mp7JrsMixedCollectionType::GetCreationInformationRef() const
{
	return GetBase()->GetCreationInformationRef();
}

Mp7JrsUsageInformationPtr Mp7JrsMixedCollectionType::GetUsageInformation() const
{
	return GetBase()->GetUsageInformation();
}

Mp7JrsReferencePtr Mp7JrsMixedCollectionType::GetUsageInformationRef() const
{
	return GetBase()->GetUsageInformationRef();
}

Mp7JrsCollectionType_TextAnnotation_CollectionPtr Mp7JrsMixedCollectionType::GetTextAnnotation() const
{
	return GetBase()->GetTextAnnotation();
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsMixedCollectionType::SetCreationInformation(const Mp7JrsCreationInformationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetCreationInformation().");
	}
	GetBase()->SetCreationInformation(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMixedCollectionType::SetCreationInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetCreationInformationRef().");
	}
	GetBase()->SetCreationInformationRef(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsMixedCollectionType::SetUsageInformation(const Mp7JrsUsageInformationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetUsageInformation().");
	}
	GetBase()->SetUsageInformation(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMixedCollectionType::SetUsageInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetUsageInformationRef().");
	}
	GetBase()->SetUsageInformationRef(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::SetTextAnnotation(const Mp7JrsCollectionType_TextAnnotation_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetTextAnnotation().");
	}
	GetBase()->SetTextAnnotation(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsMixedCollectionType::Getid() const
{
	return GetBase()->GetBase()->Getid();
}

bool Mp7JrsMixedCollectionType::Existid() const
{
	return GetBase()->GetBase()->Existid();
}
void Mp7JrsMixedCollectionType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::Setid().");
	}
	GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::Invalidateid()
{
	GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsMixedCollectionType::GettimeBase() const
{
	return GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsMixedCollectionType::ExisttimeBase() const
{
	return GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsMixedCollectionType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SettimeBase().");
	}
	GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::InvalidatetimeBase()
{
	GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsMixedCollectionType::GettimeUnit() const
{
	return GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsMixedCollectionType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsMixedCollectionType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SettimeUnit().");
	}
	GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsMixedCollectionType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsMixedCollectionType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsMixedCollectionType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsMixedCollectionType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsMixedCollectionType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsMixedCollectionType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixedCollectionType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsMixedCollectionType::GetHeader() const
{
	return GetBase()->GetBase()->GetHeader();
}

void Mp7JrsMixedCollectionType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType::SetHeader().");
	}
	GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsMixedCollectionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Content")) == 0)
	{
		// Content is contained in itemtype MixedCollectionType_LocalType
		// in choice collection MixedCollectionType_CollectionType
		
		context->Found = true;
		Mp7JrsMixedCollectionType_CollectionPtr coll = GetMixedCollectionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType;
				SetMixedCollectionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_LocalPtr)coll->elementAt(i))->GetContent()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_LocalPtr item = CreateMixedCollectionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsMultimediaContentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_LocalPtr)coll->elementAt(i))->SetContent(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_LocalPtr)coll->elementAt(i))->GetContent()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ContentRef")) == 0)
	{
		// ContentRef is contained in itemtype MixedCollectionType_LocalType
		// in choice collection MixedCollectionType_CollectionType
		
		context->Found = true;
		Mp7JrsMixedCollectionType_CollectionPtr coll = GetMixedCollectionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType;
				SetMixedCollectionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_LocalPtr)coll->elementAt(i))->GetContentRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_LocalPtr item = CreateMixedCollectionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_LocalPtr)coll->elementAt(i))->SetContentRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_LocalPtr)coll->elementAt(i))->GetContentRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Segment")) == 0)
	{
		// Segment is contained in itemtype MixedCollectionType_LocalType0
		// in choice collection MixedCollectionType_CollectionType0
		
		context->Found = true;
		Mp7JrsMixedCollectionType_Collection0Ptr coll = GetMixedCollectionType_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType0;
				SetMixedCollectionType_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_Local0Ptr)coll->elementAt(i))->GetSegment()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_Local0Ptr item = CreateMixedCollectionType_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsSegmentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_Local0Ptr)coll->elementAt(i))->SetSegment(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_Local0Ptr)coll->elementAt(i))->GetSegment()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SegmentRef")) == 0)
	{
		// SegmentRef is contained in itemtype MixedCollectionType_LocalType0
		// in choice collection MixedCollectionType_CollectionType0
		
		context->Found = true;
		Mp7JrsMixedCollectionType_Collection0Ptr coll = GetMixedCollectionType_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType0;
				SetMixedCollectionType_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_Local0Ptr)coll->elementAt(i))->GetSegmentRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_Local0Ptr item = CreateMixedCollectionType_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_Local0Ptr)coll->elementAt(i))->SetSegmentRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_Local0Ptr)coll->elementAt(i))->GetSegmentRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Descriptor")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Descriptor is item of abstract type DType
		// in element collection MixedCollectionType_Descriptor_CollectionType
		
		context->Found = true;
		Mp7JrsMixedCollectionType_Descriptor_CollectionPtr coll = GetDescriptor();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_Descriptor_CollectionType;
				SetDescriptor(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsDPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Concept")) == 0)
	{
		// Concept is contained in itemtype MixedCollectionType_LocalType1
		// in choice collection MixedCollectionType_CollectionType1
		
		context->Found = true;
		Mp7JrsMixedCollectionType_Collection1Ptr coll = GetMixedCollectionType_LocalType1();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType1;
				SetMixedCollectionType_LocalType1(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_Local1Ptr)coll->elementAt(i))->GetConcept()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_Local1Ptr item = CreateMixedCollectionType_LocalType1;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsSemanticBasePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_Local1Ptr)coll->elementAt(i))->SetConcept(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_Local1Ptr)coll->elementAt(i))->GetConcept()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ConceptRef")) == 0)
	{
		// ConceptRef is contained in itemtype MixedCollectionType_LocalType1
		// in choice collection MixedCollectionType_CollectionType1
		
		context->Found = true;
		Mp7JrsMixedCollectionType_Collection1Ptr coll = GetMixedCollectionType_LocalType1();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType1;
				SetMixedCollectionType_LocalType1(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_Local1Ptr)coll->elementAt(i))->GetConceptRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_Local1Ptr item = CreateMixedCollectionType_LocalType1;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_Local1Ptr)coll->elementAt(i))->SetConceptRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_Local1Ptr)coll->elementAt(i))->GetConceptRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MixedCollection")) == 0)
	{
		// MixedCollection is contained in itemtype MixedCollectionType_LocalType2
		// in choice collection MixedCollectionType_CollectionType2
		
		context->Found = true;
		Mp7JrsMixedCollectionType_Collection2Ptr coll = GetMixedCollectionType_LocalType2();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType2;
				SetMixedCollectionType_LocalType2(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_Local2Ptr)coll->elementAt(i))->GetMixedCollection()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_Local2Ptr item = CreateMixedCollectionType_LocalType2;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MixedCollectionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMixedCollectionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_Local2Ptr)coll->elementAt(i))->SetMixedCollection(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_Local2Ptr)coll->elementAt(i))->GetMixedCollection()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MixedCollectionRef")) == 0)
	{
		// MixedCollectionRef is contained in itemtype MixedCollectionType_LocalType2
		// in choice collection MixedCollectionType_CollectionType2
		
		context->Found = true;
		Mp7JrsMixedCollectionType_Collection2Ptr coll = GetMixedCollectionType_LocalType2();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMixedCollectionType_CollectionType2;
				SetMixedCollectionType_LocalType2(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMixedCollectionType_Local2Ptr)coll->elementAt(i))->GetMixedCollectionRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsMixedCollectionType_Local2Ptr item = CreateMixedCollectionType_LocalType2;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMixedCollectionType_Local2Ptr)coll->elementAt(i))->SetMixedCollectionRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsMixedCollectionType_Local2Ptr)coll->elementAt(i))->GetMixedCollectionRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MixedCollectionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MixedCollectionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMixedCollectionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsMixedCollectionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsMixedCollectionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MixedCollectionType"));
	// Element serialization:
	if (m_MixedCollectionType_LocalType != Mp7JrsMixedCollectionType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MixedCollectionType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_MixedCollectionType_LocalType0 != Mp7JrsMixedCollectionType_Collection0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MixedCollectionType_LocalType0->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Descriptor != Mp7JrsMixedCollectionType_Descriptor_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Descriptor->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_MixedCollectionType_LocalType1 != Mp7JrsMixedCollectionType_Collection1Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MixedCollectionType_LocalType1->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_MixedCollectionType_LocalType2 != Mp7JrsMixedCollectionType_Collection2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MixedCollectionType_LocalType2->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsMixedCollectionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsCollectionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:Content
            Mp7JrsUtil::HasNodeName(parent, X("Content"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Content")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:ContentRef
            Mp7JrsUtil::HasNodeName(parent, X("ContentRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ContentRef")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsMixedCollectionType_CollectionPtr tmp = CreateMixedCollectionType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMixedCollectionType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:Segment
            Mp7JrsUtil::HasNodeName(parent, X("Segment"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Segment")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:SegmentRef
            Mp7JrsUtil::HasNodeName(parent, X("SegmentRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SegmentRef")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsMixedCollectionType_Collection0Ptr tmp = CreateMixedCollectionType_CollectionType0;
            tmp->Deserialize(doc, parent, current);
            this->SetMixedCollectionType_LocalType0(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Descriptor"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Descriptor")) == 0))
        {
            // Deserialize factory type
            Mp7JrsMixedCollectionType_Descriptor_CollectionPtr tmp = CreateMixedCollectionType_Descriptor_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetDescriptor(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:Concept
            Mp7JrsUtil::HasNodeName(parent, X("Concept"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Concept")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:ConceptRef
            Mp7JrsUtil::HasNodeName(parent, X("ConceptRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ConceptRef")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsMixedCollectionType_Collection1Ptr tmp = CreateMixedCollectionType_CollectionType1;
            tmp->Deserialize(doc, parent, current);
            this->SetMixedCollectionType_LocalType1(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:MixedCollection
            Mp7JrsUtil::HasNodeName(parent, X("MixedCollection"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:MixedCollection")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:MixedCollectionRef
            Mp7JrsUtil::HasNodeName(parent, X("MixedCollectionRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:MixedCollectionRef")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsMixedCollectionType_Collection2Ptr tmp = CreateMixedCollectionType_CollectionType2;
            tmp->Deserialize(doc, parent, current);
            this->SetMixedCollectionType_LocalType2(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMixedCollectionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Content"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Content")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("ContentRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("ContentRef")) == 0)
    )
  {
    Mp7JrsMixedCollectionType_CollectionPtr tmp = CreateMixedCollectionType_CollectionType;
    this->SetMixedCollectionType_LocalType(tmp);
    child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Segment"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Segment")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("SegmentRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("SegmentRef")) == 0)
    )
  {
    Mp7JrsMixedCollectionType_Collection0Ptr tmp = CreateMixedCollectionType_CollectionType0;
    this->SetMixedCollectionType_LocalType0(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Descriptor")) == 0))
  {
    Mp7JrsMixedCollectionType_Descriptor_CollectionPtr tmp = CreateMixedCollectionType_Descriptor_CollectionType;
    this->SetDescriptor(tmp);
    child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Concept"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Concept")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("ConceptRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("ConceptRef")) == 0)
    )
  {
    Mp7JrsMixedCollectionType_Collection1Ptr tmp = CreateMixedCollectionType_CollectionType1;
    this->SetMixedCollectionType_LocalType1(tmp);
    child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("MixedCollection"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("MixedCollection")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("MixedCollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("MixedCollectionRef")) == 0)
    )
  {
    Mp7JrsMixedCollectionType_Collection2Ptr tmp = CreateMixedCollectionType_CollectionType2;
    this->SetMixedCollectionType_LocalType2(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMixedCollectionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMixedCollectionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetMixedCollectionType_LocalType());
	if (GetMixedCollectionType_LocalType0() != Mp7JrsNodePtr())
		result.Insert(GetMixedCollectionType_LocalType0());
	if (GetDescriptor() != Mp7JrsNodePtr())
		result.Insert(GetDescriptor());
	if (GetMixedCollectionType_LocalType1() != Mp7JrsNodePtr())
		result.Insert(GetMixedCollectionType_LocalType1());
	if (GetMixedCollectionType_LocalType2() != Mp7JrsNodePtr())
		result.Insert(GetMixedCollectionType_LocalType2());
	if (GetTextAnnotation() != Mp7JrsNodePtr())
		result.Insert(GetTextAnnotation());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	if (GetCreationInformation() != Mp7JrsNodePtr())
		result.Insert(GetCreationInformation());
	if (GetCreationInformationRef() != Mp7JrsNodePtr())
		result.Insert(GetCreationInformationRef());
	if (GetUsageInformation() != Mp7JrsNodePtr())
		result.Insert(GetUsageInformation());
	if (GetUsageInformationRef() != Mp7JrsNodePtr())
		result.Insert(GetUsageInformationRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_ExtMethodImpl.h


