 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtImplInclude.h



#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType2.h"
#include "Mp7JrsMosaicType_WarpingParam_CollectionType.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalType.h" // Sequence collection MediaTimePoint
#include "Mp7JrsmediaTimePointType.h" // Sequence collection element MediaTimePoint
#include "Mp7JrsMediaRelTimePointType.h" // Sequence collection element MediaRelTimePoint
#include "Mp7JrsMediaRelIncrTimePointType.h" // Sequence collection element MediaRelIncrTimePoint
#include "Mp7JrsfloatVector.h" // Sequence collection element MotionParam

#include <assert.h>
IMp7JrsMosaicType_WarpingParam_LocalType0::IMp7JrsMosaicType_WarpingParam_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtPropInit.h

}

IMp7JrsMosaicType_WarpingParam_LocalType0::~IMp7JrsMosaicType_WarpingParam_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtPropCleanup.h

}

Mp7JrsMosaicType_WarpingParam_LocalType0::Mp7JrsMosaicType_WarpingParam_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMosaicType_WarpingParam_LocalType0::~Mp7JrsMosaicType_WarpingParam_LocalType0()
{
	Cleanup();
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::Init()
{

	// Init attributes
	m_modelType = Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr(); // Create emtpy class ptr
	m_sourceSequenceWidth = 1; // Value
	m_sourceSequenceHeight = 1; // Value
	m_xOffset = 0.0; // Value
	m_yOffset = 0.0; // Value
	m_xOrigin = 0.0; // Value
	m_yOrigin = 0.0; // Value

	// Init elements (element, union sequence choice all any)
	
	m_MosaicType_WarpingParam_LocalType = Mp7JrsMosaicType_WarpingParam_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtMyPropInit.h

}

void Mp7JrsMosaicType_WarpingParam_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_modelType);
	// Mp7JrsFactory::DeleteObject(m_MosaicType_WarpingParam_LocalType);
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MosaicType_WarpingParam_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in IMosaicType_WarpingParam_LocalType0
    const Mp7JrsPtr< Mp7JrsMosaicType_WarpingParam_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_modelType);
		this->SetmodelType(Mp7JrsFactory::CloneObject(tmp->GetmodelType()));
	}
	{
		this->SetsourceSequenceWidth(tmp->GetsourceSequenceWidth());
	}
	{
		this->SetsourceSequenceHeight(tmp->GetsourceSequenceHeight());
	}
	{
		this->SetxOffset(tmp->GetxOffset());
	}
	{
		this->SetyOffset(tmp->GetyOffset());
	}
	{
		this->SetxOrigin(tmp->GetxOrigin());
	}
	{
		this->SetyOrigin(tmp->GetyOrigin());
	}
		// Mp7JrsFactory::DeleteObject(m_MosaicType_WarpingParam_LocalType);
		this->SetMosaicType_WarpingParam_LocalType(Mp7JrsFactory::CloneObject(tmp->GetMosaicType_WarpingParam_LocalType()));
}

Mp7JrsNodePtr Mp7JrsMosaicType_WarpingParam_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMosaicType_WarpingParam_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr Mp7JrsMosaicType_WarpingParam_LocalType0::GetmodelType() const
{
	return m_modelType;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetmodelType(const Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetmodelType().");
	}
    m_modelType = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_modelType) m_modelType->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsMosaicType_WarpingParam_LocalType0::GetsourceSequenceWidth() const
{
	return m_sourceSequenceWidth;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetsourceSequenceWidth(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetsourceSequenceWidth().");
	}
    m_sourceSequenceWidth = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsMosaicType_WarpingParam_LocalType0::GetsourceSequenceHeight() const
{
	return m_sourceSequenceHeight;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetsourceSequenceHeight(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetsourceSequenceHeight().");
	}
    m_sourceSequenceHeight = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsMosaicType_WarpingParam_LocalType0::GetxOffset() const
{
	return m_xOffset;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetxOffset(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetxOffset().");
	}
    m_xOffset = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsMosaicType_WarpingParam_LocalType0::GetyOffset() const
{
	return m_yOffset;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetyOffset(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetyOffset().");
	}
    m_yOffset = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsMosaicType_WarpingParam_LocalType0::GetxOrigin() const
{
	return m_xOrigin;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetxOrigin(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetxOrigin().");
	}
    m_xOrigin = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsMosaicType_WarpingParam_LocalType0::GetyOrigin() const
{
	return m_yOrigin;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetyOrigin(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetyOrigin().");
	}
    m_yOrigin = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsMosaicType_WarpingParam_CollectionPtr Mp7JrsMosaicType_WarpingParam_LocalType0::GetMosaicType_WarpingParam_LocalType() const
{
	return m_MosaicType_WarpingParam_LocalType;
}

void Mp7JrsMosaicType_WarpingParam_LocalType0::SetMosaicType_WarpingParam_LocalType(const Mp7JrsMosaicType_WarpingParam_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMosaicType_WarpingParam_LocalType0::SetMosaicType_WarpingParam_LocalType().");
	}
	if (m_MosaicType_WarpingParam_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MosaicType_WarpingParam_LocalType);
		m_MosaicType_WarpingParam_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MosaicType_WarpingParam_LocalType) m_MosaicType_WarpingParam_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsMosaicType_WarpingParam_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("MediaTimePoint")) == 0)
	{
		// MediaTimePoint is contained in itemtype MosaicType_WarpingParam_LocalType
		// in sequence collection MosaicType_WarpingParam_CollectionType

		context->Found = true;
		Mp7JrsMosaicType_WarpingParam_CollectionPtr coll = GetMosaicType_WarpingParam_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMosaicType_WarpingParam_CollectionType;
				SetMosaicType_WarpingParam_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMediaTimePoint()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsMosaicType_WarpingParam_LocalPtr item = CreateMosaicType_WarpingParam_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMediaTimePoint(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j+1))->GetMediaTimePoint());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMediaTimePoint(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j-1))->GetMediaTimePoint());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:mediaTimePointType")))) != empty)
			{
				// Is type allowed
				Mp7JrsmediaTimePointPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->SetMediaTimePoint(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMediaTimePoint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaRelTimePoint")) == 0)
	{
		// MediaRelTimePoint is contained in itemtype MosaicType_WarpingParam_LocalType
		// in sequence collection MosaicType_WarpingParam_CollectionType

		context->Found = true;
		Mp7JrsMosaicType_WarpingParam_CollectionPtr coll = GetMosaicType_WarpingParam_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMosaicType_WarpingParam_CollectionType;
				SetMosaicType_WarpingParam_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMediaRelTimePoint()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsMosaicType_WarpingParam_LocalPtr item = CreateMosaicType_WarpingParam_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMediaRelTimePoint(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j+1))->GetMediaRelTimePoint());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMediaRelTimePoint(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j-1))->GetMediaRelTimePoint());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaRelTimePointType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaRelTimePointPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->SetMediaRelTimePoint(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMediaRelTimePoint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaRelIncrTimePoint")) == 0)
	{
		// MediaRelIncrTimePoint is contained in itemtype MosaicType_WarpingParam_LocalType
		// in sequence collection MosaicType_WarpingParam_CollectionType

		context->Found = true;
		Mp7JrsMosaicType_WarpingParam_CollectionPtr coll = GetMosaicType_WarpingParam_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMosaicType_WarpingParam_CollectionType;
				SetMosaicType_WarpingParam_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMediaRelIncrTimePoint()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsMosaicType_WarpingParam_LocalPtr item = CreateMosaicType_WarpingParam_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMediaRelIncrTimePoint(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j+1))->GetMediaRelIncrTimePoint());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMediaRelIncrTimePoint(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j-1))->GetMediaRelIncrTimePoint());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaRelIncrTimePointType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaRelIncrTimePointPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->SetMediaRelIncrTimePoint(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMediaRelIncrTimePoint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MotionParam")) == 0)
	{
		// MotionParam is contained in itemtype MosaicType_WarpingParam_LocalType
		// in sequence collection MosaicType_WarpingParam_CollectionType

		context->Found = true;
		Mp7JrsMosaicType_WarpingParam_CollectionPtr coll = GetMosaicType_WarpingParam_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateMosaicType_WarpingParam_CollectionType;
				SetMosaicType_WarpingParam_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMotionParam()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsMosaicType_WarpingParam_LocalPtr item = CreateMosaicType_WarpingParam_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMotionParam(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j+1))->GetMotionParam());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j))->SetMotionParam(
						((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(j-1))->GetMotionParam());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:floatVector")))) != empty)
			{
				// Is type allowed
				Mp7JrsfloatVectorPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->SetMotionParam(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsMosaicType_WarpingParam_LocalPtr)coll->elementAt(i))->GetMotionParam()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MosaicType_WarpingParam_LocalType0
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MosaicType_WarpingParam_LocalType0");
	}		
	
	return result;
}

XMLCh * Mp7JrsMosaicType_WarpingParam_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMosaicType_WarpingParam_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMosaicType_WarpingParam_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MosaicType_WarpingParam_LocalType0"));
    // Attribute Serialization:
	// Class
	if (m_modelType != Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_modelType->ToText();
		element->setAttributeNS(X(""), X("modelType"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_sourceSequenceWidth);
		element->setAttributeNS(X(""), X("sourceSequenceWidth"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_sourceSequenceHeight);
		element->setAttributeNS(X(""), X("sourceSequenceHeight"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_xOffset);
		element->setAttributeNS(X(""), X("xOffset"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_yOffset);
		element->setAttributeNS(X(""), X("yOffset"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_xOrigin);
		element->setAttributeNS(X(""), X("xOrigin"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_yOrigin);
		element->setAttributeNS(X(""), X("yOrigin"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:
	if (m_MosaicType_WarpingParam_LocalType != Mp7JrsMosaicType_WarpingParam_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MosaicType_WarpingParam_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsMosaicType_WarpingParam_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("modelType")))
	{
        // Deserialize class type
		Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr tmp = CreateMosaicType_WarpingParam_modelType_LocalType2;
		tmp->Parse(parent->getAttributeNS(X(""), X("modelType")));
        this->SetmodelType(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("modelType")))
	{
		// Deserialize class type
        Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr tmp = CreateMosaicType_WarpingParam_modelType_LocalType2;
        tmp->Parse(parent->getAttribute(X("modelType")));
        this->SetmodelType(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("sourceSequenceWidth")))
	{
        // deserialize value type
        this->SetsourceSequenceWidth(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("sourceSequenceWidth"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("sourceSequenceWidth")))
	{
        // deserialize value type
        this->SetsourceSequenceWidth(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("sourceSequenceWidth"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("sourceSequenceHeight")))
	{
        // deserialize value type
        this->SetsourceSequenceHeight(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("sourceSequenceHeight"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("sourceSequenceHeight")))
	{
        // deserialize value type
        this->SetsourceSequenceHeight(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("sourceSequenceHeight"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("xOffset")))
	{
        // deserialize value type
        this->SetxOffset(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("xOffset"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("xOffset")))
	{
        // deserialize value type
        this->SetxOffset(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("xOffset"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("yOffset")))
	{
        // deserialize value type
        this->SetyOffset(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("yOffset"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("yOffset")))
	{
        // deserialize value type
        this->SetyOffset(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("yOffset"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("xOrigin")))
	{
        // deserialize value type
        this->SetxOrigin(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("xOrigin"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("xOrigin")))
	{
        // deserialize value type
        this->SetxOrigin(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("xOrigin"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("yOrigin")))
	{
        // deserialize value type
        this->SetyOrigin(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("yOrigin"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("yOrigin")))
	{
        // deserialize value type
        this->SetyOrigin(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("yOrigin"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Sequence Collection
        if((parent != NULL) && (
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:MediaTimePoint")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("MediaTimePoint"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:MediaRelTimePoint")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("MediaRelTimePoint"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:MediaRelIncrTimePoint")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("MediaRelIncrTimePoint"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:MotionParam")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("MotionParam"), X("urn:mpeg:mpeg7:schema:2004")))
                ))
        {
            // Deserialize factory type
            Mp7JrsMosaicType_WarpingParam_CollectionPtr tmp = CreateMosaicType_WarpingParam_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMosaicType_WarpingParam_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMosaicType_WarpingParam_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsMosaicType_WarpingParam_CollectionPtr tmp = CreateMosaicType_WarpingParam_CollectionType;
    this->SetMosaicType_WarpingParam_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMosaicType_WarpingParam_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMosaicType_WarpingParam_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetMosaicType_WarpingParam_LocalType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtMethodImpl.h


