 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtImplInclude.h



#include "Mp7Jrsunsigned3.h"
#include "Mp7JrsMotionActivityType_Intensity_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMotionActivityType_Intensity_LocalType::IMp7JrsMotionActivityType_Intensity_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtPropInit.h

}

IMp7JrsMotionActivityType_Intensity_LocalType::~IMp7JrsMotionActivityType_Intensity_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtPropCleanup.h

}

Mp7JrsMotionActivityType_Intensity_LocalType::Mp7JrsMotionActivityType_Intensity_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMotionActivityType_Intensity_LocalType::~Mp7JrsMotionActivityType_Intensity_LocalType()
{
	Cleanup();
}

void Mp7JrsMotionActivityType_Intensity_LocalType::Init()
{
	// Init base
	m_Base = Createunsigned3;
	m_Base->m_myself = m_myself.getPointer();
	




// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtMyPropInit.h

}

void Mp7JrsMotionActivityType_Intensity_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
}

void Mp7JrsMotionActivityType_Intensity_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MotionActivityType_Intensity_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMotionActivityType_Intensity_LocalType
    const Mp7JrsPtr< Mp7JrsMotionActivityType_Intensity_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7Jrsunsigned3Ptr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMotionActivityType_Intensity_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
}

Mp7JrsNodePtr Mp7JrsMotionActivityType_Intensity_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsMotionActivityType_Intensity_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7Jrsunsigned3 > Mp7JrsMotionActivityType_Intensity_LocalType::GetBase() const
{
	return m_Base;
}

void Mp7JrsMotionActivityType_Intensity_LocalType::SetContent(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_Intensity_LocalType::SetContent().");
	}
	GetBase()->SetContent(item);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsMotionActivityType_Intensity_LocalType::GetContent() const
{
	return GetBase()->GetContent();
}

Mp7JrsNodeEnum Mp7JrsMotionActivityType_Intensity_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for MotionActivityType_Intensity_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "MotionActivityType_Intensity_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsMotionActivityType_Intensity_LocalType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsMotionActivityType_Intensity_LocalType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}

bool Mp7JrsMotionActivityType_Intensity_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsMotionActivityType_Intensity_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsMotionActivityType_Intensity_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MotionActivityType_Intensity_LocalType"));
	// Element serialization:

}

bool Mp7JrsMotionActivityType_Intensity_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7Jrsunsigned3
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMotionActivityType_Intensity_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMotionActivityType_Intensity_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_Intensity_LocalType_ExtMethodImpl.h


