 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtImplInclude.h



#include "Mp7Jrsunsigned6.h"
#include "Mp7Jrsunsigned5.h"
#include "Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType::IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtPropInit.h

}

IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType::~IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtPropCleanup.h

}

Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::~Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType()
{
	Cleanup();
}

void Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::Init()
{

	// Init attributes
	m_numOfShortRuns = Createunsigned6; // Create a valid class
	m_numOfShortRuns->SetContent(0); // Use Value initialiser (xxx2)
	m_numOfMediumRuns = Createunsigned5; // Create a valid class
	m_numOfMediumRuns->SetContent(0); // Use Value initialiser (xxx2)
	m_numOfLongRuns = Createunsigned5; // Create a valid class
	m_numOfLongRuns->SetContent(0); // Use Value initialiser (xxx2)



// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtMyPropInit.h

}

void Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_numOfShortRuns);
	// Mp7JrsFactory::DeleteObject(m_numOfMediumRuns);
	// Mp7JrsFactory::DeleteObject(m_numOfLongRuns);
}

void Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MotionActivityType_SpatialDistributionParams_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMotionActivityType_SpatialDistributionParams_LocalType
    const Mp7JrsPtr< Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_numOfShortRuns);
		this->SetnumOfShortRuns(Mp7JrsFactory::CloneObject(tmp->GetnumOfShortRuns()));
	}
	{
	// Mp7JrsFactory::DeleteObject(m_numOfMediumRuns);
		this->SetnumOfMediumRuns(Mp7JrsFactory::CloneObject(tmp->GetnumOfMediumRuns()));
	}
	{
	// Mp7JrsFactory::DeleteObject(m_numOfLongRuns);
		this->SetnumOfLongRuns(Mp7JrsFactory::CloneObject(tmp->GetnumOfLongRuns()));
	}
}

Mp7JrsNodePtr Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7Jrsunsigned6Ptr Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::GetnumOfShortRuns() const
{
	return m_numOfShortRuns;
}

void Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::SetnumOfShortRuns(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::SetnumOfShortRuns().");
	}
    m_numOfShortRuns = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_numOfShortRuns) m_numOfShortRuns->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7Jrsunsigned5Ptr Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::GetnumOfMediumRuns() const
{
	return m_numOfMediumRuns;
}

void Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::SetnumOfMediumRuns(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::SetnumOfMediumRuns().");
	}
    m_numOfMediumRuns = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_numOfMediumRuns) m_numOfMediumRuns->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7Jrsunsigned5Ptr Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::GetnumOfLongRuns() const
{
	return m_numOfLongRuns;
}

void Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::SetnumOfLongRuns(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::SetnumOfLongRuns().");
	}
    m_numOfLongRuns = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_numOfLongRuns) m_numOfLongRuns->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MotionActivityType_SpatialDistributionParams_LocalType"));
    // Attribute Serialization:
	// Class
	if (m_numOfShortRuns != Mp7Jrsunsigned6Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_numOfShortRuns->ToText();
		element->setAttributeNS(X(""), X("numOfShortRuns"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Class
	if (m_numOfMediumRuns != Mp7Jrsunsigned5Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_numOfMediumRuns->ToText();
		element->setAttributeNS(X(""), X("numOfMediumRuns"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Class
	if (m_numOfLongRuns != Mp7Jrsunsigned5Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_numOfLongRuns->ToText();
		element->setAttributeNS(X(""), X("numOfLongRuns"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:

}

bool Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("numOfShortRuns")))
	{
        // Deserialize class type
		Mp7Jrsunsigned6Ptr tmp = Createunsigned6;
		tmp->Parse(parent->getAttributeNS(X(""), X("numOfShortRuns")));
        this->SetnumOfShortRuns(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("numOfShortRuns")))
	{
		// Deserialize class type
        Mp7Jrsunsigned6Ptr tmp = Createunsigned6;
        tmp->Parse(parent->getAttribute(X("numOfShortRuns")));
        this->SetnumOfShortRuns(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("numOfMediumRuns")))
	{
        // Deserialize class type
		Mp7Jrsunsigned5Ptr tmp = Createunsigned5;
		tmp->Parse(parent->getAttributeNS(X(""), X("numOfMediumRuns")));
        this->SetnumOfMediumRuns(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("numOfMediumRuns")))
	{
		// Deserialize class type
        Mp7Jrsunsigned5Ptr tmp = Createunsigned5;
        tmp->Parse(parent->getAttribute(X("numOfMediumRuns")));
        this->SetnumOfMediumRuns(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("numOfLongRuns")))
	{
        // Deserialize class type
		Mp7Jrsunsigned5Ptr tmp = Createunsigned5;
		tmp->Parse(parent->getAttributeNS(X(""), X("numOfLongRuns")));
        this->SetnumOfLongRuns(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("numOfLongRuns")))
	{
		// Deserialize class type
        Mp7Jrsunsigned5Ptr tmp = Createunsigned5;
        tmp->Parse(parent->getAttribute(X("numOfLongRuns")));
        this->SetnumOfLongRuns(tmp);
        * current = parent;
    }

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtMethodImpl.h


