 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType_ExtImplInclude.h



#include "Mp7JrsMovingRegionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsMovingRegionMediaSourceDecompositionType_LocalType::IMp7JrsMovingRegionMediaSourceDecompositionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType_ExtPropInit.h

}

IMp7JrsMovingRegionMediaSourceDecompositionType_LocalType::~IMp7JrsMovingRegionMediaSourceDecompositionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType_ExtPropCleanup.h

}

Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::~Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType()
{
	Cleanup();
}

void Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_MovingRegion = Mp7JrsMovingRegionPtr(); // Class
	m_MovingRegionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
}

void Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MovingRegionMediaSourceDecompositionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMovingRegionMediaSourceDecompositionType_LocalType
    const Mp7JrsPtr< Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_MovingRegion);
		this->SetMovingRegion(Mp7JrsFactory::CloneObject(tmp->GetMovingRegion()));
		// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
		this->SetMovingRegionRef(Mp7JrsFactory::CloneObject(tmp->GetMovingRegionRef()));
}

Mp7JrsNodePtr Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsMovingRegionPtr Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::GetMovingRegion() const
{
	return m_MovingRegion;
}

Mp7JrsReferencePtr Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::GetMovingRegionRef() const
{
	return m_MovingRegionRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::SetMovingRegion(const Mp7JrsMovingRegionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::SetMovingRegion().");
	}
	if (m_MovingRegion != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MovingRegion);
		m_MovingRegion = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MovingRegion) m_MovingRegion->SetParent(m_myself.getPointer());
		if (m_MovingRegion && m_MovingRegion->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MovingRegionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MovingRegion->UseTypeAttribute = true;
		}
		if(m_MovingRegion != Mp7JrsMovingRegionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MovingRegion->SetContentName(XMLString::transcode("MovingRegion"));
		}
	// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
	m_MovingRegionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::SetMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::SetMovingRegionRef().");
	}
	if (m_MovingRegionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MovingRegionRef);
		m_MovingRegionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MovingRegionRef) m_MovingRegionRef->SetParent(m_myself.getPointer());
		if (m_MovingRegionRef && m_MovingRegionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MovingRegionRef->UseTypeAttribute = true;
		}
		if(m_MovingRegionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MovingRegionRef->SetContentName(XMLString::transcode("MovingRegionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_MovingRegion);
	m_MovingRegion = Mp7JrsMovingRegionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: MovingRegionMediaSourceDecompositionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_MovingRegion != Mp7JrsMovingRegionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MovingRegion->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MovingRegion"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MovingRegion->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MovingRegionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MovingRegionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MovingRegionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MovingRegionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MovingRegion"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MovingRegion")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMovingRegionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMovingRegion(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MovingRegionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MovingRegionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMovingRegionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("MovingRegion")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMovingRegionType;
    }
    this->SetMovingRegion(child);
  }
  if (XMLString::compareString(elementname, X("MovingRegionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetMovingRegionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMovingRegion() != Mp7JrsNodePtr())
		result.Insert(GetMovingRegion());
	if (GetMovingRegionRef() != Mp7JrsNodePtr())
		result.Insert(GetMovingRegionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType_ExtMethodImpl.h


