 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtImplInclude.h



#include "Mp7JrsPartitionType_dim_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsPartitionType_dim_LocalType::IMp7JrsPartitionType_dim_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtPropInit.h

}

IMp7JrsPartitionType_dim_LocalType::~IMp7JrsPartitionType_dim_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtPropCleanup.h

}

Mp7JrsPartitionType_dim_LocalType::Mp7JrsPartitionType_dim_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPartitionType_dim_LocalType::~Mp7JrsPartitionType_dim_LocalType()
{
	Cleanup();
}

void Mp7JrsPartitionType_dim_LocalType::Init()
{
	// Init base
	m_Base = 1;




// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtMyPropInit.h

}

void Mp7JrsPartitionType_dim_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtMyPropCleanup.h


}

void Mp7JrsPartitionType_dim_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PartitionType_dim_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPartitionType_dim_LocalType
    const Mp7JrsPtr< Mp7JrsPartitionType_dim_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	m_Base = tmp->GetContent();
}

Mp7JrsNodePtr Mp7JrsPartitionType_dim_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsPartitionType_dim_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


void Mp7JrsPartitionType_dim_LocalType::SetContent(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPartitionType_dim_LocalType::SetContent().");
	}
    if (m_Base != item)
    {
		m_Base = item;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsPartitionType_dim_LocalType::GetContent() const
{
	return m_Base;
}

Mp7JrsNodeEnum Mp7JrsPartitionType_dim_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for PartitionType_dim_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "PartitionType_dim_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsPartitionType_dim_LocalType::ToText() const
{
	return Mp7JrsConvert::BinToText(m_Base);
}


bool Mp7JrsPartitionType_dim_LocalType::Parse(const XMLCh * const txt)
{
	m_Base = Mp7JrsConvert::TextToUnsignedInt(txt);
	return true;
}

bool Mp7JrsPartitionType_dim_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsPartitionType_dim_LocalType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsPartitionType_dim_LocalType::ContentToString() const
{
	// Mp7JrsPartitionType_dim_LocalType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsPartitionType_dim_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


    {
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_Base);
		element->appendChild(doc->createTextNode(tmp));
		XMLString::release(&tmp);
    }

	assert(element);
// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PartitionType_dim_LocalType"));
	// Element serialization:

}

bool Mp7JrsPartitionType_dim_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

  m_Base = Mp7JrsConvert::TextToUnsignedInt(Mp7JrsUtil::GetElementText(parent));
  found = true;
// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPartitionType_dim_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPartitionType_dim_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPartitionType_dim_LocalType_ExtMethodImpl.h


