 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtImplInclude.h



#include "Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionType.h"
#include "Mp7JrsTextualType.h"
#include "Mp7JrsPlaceType_PostalAddress_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsPlaceType_PostalAddress_LocalType::IMp7JrsPlaceType_PostalAddress_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtPropInit.h

}

IMp7JrsPlaceType_PostalAddress_LocalType::~IMp7JrsPlaceType_PostalAddress_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtPropCleanup.h

}

Mp7JrsPlaceType_PostalAddress_LocalType::Mp7JrsPlaceType_PostalAddress_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPlaceType_PostalAddress_LocalType::~Mp7JrsPlaceType_PostalAddress_LocalType()
{
	Cleanup();
}

void Mp7JrsPlaceType_PostalAddress_LocalType::Init()
{

	// Init attributes
	m_lang = NULL; // String
	m_lang_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_AddressLine = Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr(); // Collection
	m_PostingIdentifier = Mp7JrsTextualPtr(); // Class
	m_PostingIdentifier_Exist = false;


// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtMyPropInit.h

}

void Mp7JrsPlaceType_PostalAddress_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_lang);
	// Mp7JrsFactory::DeleteObject(m_AddressLine);
	// Mp7JrsFactory::DeleteObject(m_PostingIdentifier);
}

void Mp7JrsPlaceType_PostalAddress_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PlaceType_PostalAddress_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPlaceType_PostalAddress_LocalType
    const Mp7JrsPtr< Mp7JrsPlaceType_PostalAddress_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	XMLString::release(&m_lang);
	if (tmp->Existlang())
	{
		this->Setlang(XMLString::replicate(tmp->Getlang()));
	}
	else
	{
		Invalidatelang();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_AddressLine);
		this->SetAddressLine(Mp7JrsFactory::CloneObject(tmp->GetAddressLine()));
	if (tmp->IsValidPostingIdentifier())
	{
		// Mp7JrsFactory::DeleteObject(m_PostingIdentifier);
		this->SetPostingIdentifier(Mp7JrsFactory::CloneObject(tmp->GetPostingIdentifier()));
	}
	else
	{
		InvalidatePostingIdentifier();
	}
}

Mp7JrsNodePtr Mp7JrsPlaceType_PostalAddress_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsPlaceType_PostalAddress_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsPlaceType_PostalAddress_LocalType::Getlang() const
{
	return m_lang;
}

bool Mp7JrsPlaceType_PostalAddress_LocalType::Existlang() const
{
	return m_lang_Exist;
}
void Mp7JrsPlaceType_PostalAddress_LocalType::Setlang(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_PostalAddress_LocalType::Setlang().");
	}
    m_lang = item;
	m_lang_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_PostalAddress_LocalType::Invalidatelang()
{
	m_lang_Exist = false;
}
Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr Mp7JrsPlaceType_PostalAddress_LocalType::GetAddressLine() const
{
	return m_AddressLine;
}

Mp7JrsTextualPtr Mp7JrsPlaceType_PostalAddress_LocalType::GetPostingIdentifier() const
{
	return m_PostingIdentifier;
}

// Element is optional
bool Mp7JrsPlaceType_PostalAddress_LocalType::IsValidPostingIdentifier() const
{
	return m_PostingIdentifier_Exist;
}

void Mp7JrsPlaceType_PostalAddress_LocalType::SetAddressLine(const Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_PostalAddress_LocalType::SetAddressLine().");
	}
	if (m_AddressLine != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AddressLine);
		m_AddressLine = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AddressLine) m_AddressLine->SetParent(m_myself.getPointer());
		if(m_AddressLine != Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AddressLine->SetContentName(XMLString::transcode("AddressLine"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_PostalAddress_LocalType::SetPostingIdentifier(const Mp7JrsTextualPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_PostalAddress_LocalType::SetPostingIdentifier().");
	}
	if (m_PostingIdentifier != item || m_PostingIdentifier_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_PostingIdentifier);
		m_PostingIdentifier = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PostingIdentifier) m_PostingIdentifier->SetParent(m_myself.getPointer());
		if (m_PostingIdentifier && m_PostingIdentifier->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_PostingIdentifier->UseTypeAttribute = true;
		}
		m_PostingIdentifier_Exist = true;
		if(m_PostingIdentifier != Mp7JrsTextualPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PostingIdentifier->SetContentName(XMLString::transcode("PostingIdentifier"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_PostalAddress_LocalType::InvalidatePostingIdentifier()
{
	m_PostingIdentifier_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsPlaceType_PostalAddress_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("AddressLine")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:AddressLine is item of type TextualType
		// in element collection PlaceType_PostalAddress_AddressLine_CollectionType
		
		context->Found = true;
		Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr coll = GetAddressLine();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreatePlaceType_PostalAddress_AddressLine_CollectionType;
				SetAddressLine(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextualPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PostingIdentifier")) == 0)
	{
		// PostingIdentifier is simple element TextualType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPostingIdentifier()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextualPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPostingIdentifier(p, client);
					if((p = GetPostingIdentifier()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for PlaceType_PostalAddress_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "PlaceType_PostalAddress_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsPlaceType_PostalAddress_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPlaceType_PostalAddress_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsPlaceType_PostalAddress_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PlaceType_PostalAddress_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_lang_Exist)
	{
	// String
	if(m_lang != (XMLCh *)NULL)
	{
		element->setAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("xml:lang"), m_lang);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_AddressLine != Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_AddressLine->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	// Class
	
	if (m_PostingIdentifier != Mp7JrsTextualPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_PostingIdentifier->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("PostingIdentifier"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_PostingIdentifier->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsPlaceType_PostalAddress_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang")))
	{
        // Deserialize string type
        this->Setlang(Mp7JrsConvert::TextToString(parent->getAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("lang")))
	{
        // Deserialize string type
        this->Setlang(Mp7JrsConvert::TextToString(parent->getAttribute(X("lang"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("AddressLine"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("AddressLine")) == 0))
        {
            // Deserialize factory type
            Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr tmp = CreatePlaceType_PostalAddress_AddressLine_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetAddressLine(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("PostingIdentifier"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("PostingIdentifier")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTextualType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPostingIdentifier(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPlaceType_PostalAddress_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("AddressLine")) == 0))
  {
    Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr tmp = CreatePlaceType_PostalAddress_AddressLine_CollectionType;
    this->SetAddressLine(tmp);
    child = tmp;
  }
  if (XMLString::compareString(elementname, X("PostingIdentifier")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTextualType;
    }
    this->SetPostingIdentifier(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPlaceType_PostalAddress_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetAddressLine() != Mp7JrsNodePtr())
		result.Insert(GetAddressLine());
	if (GetPostingIdentifier() != Mp7JrsNodePtr())
		result.Insert(GetPostingIdentifier());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtMethodImpl.h


