 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtImplInclude.h



#include "Mp7JrsTimeType.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType2.h"
#include "Mp7JrstimePointType.h"
#include "Mp7JrsRelTimePointType.h"
#include "Mp7JrsRelIncrTimePointType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsIncrDurationType.h"
#include "Mp7JrsPreferenceConditionType_Time_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsPreferenceConditionType_Time_LocalType::IMp7JrsPreferenceConditionType_Time_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtPropInit.h

}

IMp7JrsPreferenceConditionType_Time_LocalType::~IMp7JrsPreferenceConditionType_Time_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtPropCleanup.h

}

Mp7JrsPreferenceConditionType_Time_LocalType::Mp7JrsPreferenceConditionType_Time_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPreferenceConditionType_Time_LocalType::~Mp7JrsPreferenceConditionType_Time_LocalType()
{
	Cleanup();
}

void Mp7JrsPreferenceConditionType_Time_LocalType::Init()
{
	// Init base
	m_Base = CreateTimeType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_recurrence = Mp7JrsPreferenceConditionType_Time_recurrence_Local2Ptr(); // Create emtpy class ptr
	m_recurrence_Exist = false;
	m_numOfRecurrences = 1; // Value
	m_numOfRecurrences_Exist = false;



// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtMyPropInit.h

}

void Mp7JrsPreferenceConditionType_Time_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_recurrence);
}

void Mp7JrsPreferenceConditionType_Time_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PreferenceConditionType_Time_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPreferenceConditionType_Time_LocalType
    const Mp7JrsPtr< Mp7JrsPreferenceConditionType_Time_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsTimePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsPreferenceConditionType_Time_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_recurrence);
	if (tmp->Existrecurrence())
	{
		this->Setrecurrence(Mp7JrsFactory::CloneObject(tmp->Getrecurrence()));
	}
	else
	{
		Invalidaterecurrence();
	}
	}
	{
	if (tmp->ExistnumOfRecurrences())
	{
		this->SetnumOfRecurrences(tmp->GetnumOfRecurrences());
	}
	else
	{
		InvalidatenumOfRecurrences();
	}
	}
}

Mp7JrsNodePtr Mp7JrsPreferenceConditionType_Time_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsPreferenceConditionType_Time_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsTimeType > Mp7JrsPreferenceConditionType_Time_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsPreferenceConditionType_Time_recurrence_Local2Ptr Mp7JrsPreferenceConditionType_Time_LocalType::Getrecurrence() const
{
	if (this->Existrecurrence()) {
		return m_recurrence;
	} else {
		return m_recurrence_Default;
	}
}

bool Mp7JrsPreferenceConditionType_Time_LocalType::Existrecurrence() const
{
	return m_recurrence_Exist;
}
void Mp7JrsPreferenceConditionType_Time_LocalType::Setrecurrence(const Mp7JrsPreferenceConditionType_Time_recurrence_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPreferenceConditionType_Time_LocalType::Setrecurrence().");
	}
    m_recurrence = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_recurrence) m_recurrence->SetParent(m_myself.getPointer());
	m_recurrence_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPreferenceConditionType_Time_LocalType::Invalidaterecurrence()
{
	m_recurrence_Exist = false;
}
unsigned Mp7JrsPreferenceConditionType_Time_LocalType::GetnumOfRecurrences() const
{
	return m_numOfRecurrences;
}

bool Mp7JrsPreferenceConditionType_Time_LocalType::ExistnumOfRecurrences() const
{
	return m_numOfRecurrences_Exist;
}
void Mp7JrsPreferenceConditionType_Time_LocalType::SetnumOfRecurrences(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPreferenceConditionType_Time_LocalType::SetnumOfRecurrences().");
	}
    m_numOfRecurrences = item;
	m_numOfRecurrences_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPreferenceConditionType_Time_LocalType::InvalidatenumOfRecurrences()
{
	m_numOfRecurrences_Exist = false;
}
Mp7JrstimePointPtr Mp7JrsPreferenceConditionType_Time_LocalType::GetTimePoint() const
{
	return GetBase()->GetTimePoint();
}

Mp7JrsRelTimePointPtr Mp7JrsPreferenceConditionType_Time_LocalType::GetRelTimePoint() const
{
	return GetBase()->GetRelTimePoint();
}

Mp7JrsRelIncrTimePointPtr Mp7JrsPreferenceConditionType_Time_LocalType::GetRelIncrTimePoint() const
{
	return GetBase()->GetRelIncrTimePoint();
}

Mp7JrsdurationPtr Mp7JrsPreferenceConditionType_Time_LocalType::GetDuration() const
{
	return GetBase()->GetDuration();
}

Mp7JrsIncrDurationPtr Mp7JrsPreferenceConditionType_Time_LocalType::GetIncrDuration() const
{
	return GetBase()->GetIncrDuration();
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsPreferenceConditionType_Time_LocalType::SetTimePoint(const Mp7JrstimePointPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPreferenceConditionType_Time_LocalType::SetTimePoint().");
	}
	GetBase()->SetTimePoint(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsPreferenceConditionType_Time_LocalType::SetRelTimePoint(const Mp7JrsRelTimePointPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPreferenceConditionType_Time_LocalType::SetRelTimePoint().");
	}
	GetBase()->SetRelTimePoint(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsPreferenceConditionType_Time_LocalType::SetRelIncrTimePoint(const Mp7JrsRelIncrTimePointPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPreferenceConditionType_Time_LocalType::SetRelIncrTimePoint().");
	}
	GetBase()->SetRelIncrTimePoint(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsPreferenceConditionType_Time_LocalType::SetDuration(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPreferenceConditionType_Time_LocalType::SetDuration().");
	}
	GetBase()->SetDuration(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsPreferenceConditionType_Time_LocalType::SetIncrDuration(const Mp7JrsIncrDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPreferenceConditionType_Time_LocalType::SetIncrDuration().");
	}
	GetBase()->SetIncrDuration(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsPreferenceConditionType_Time_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for PreferenceConditionType_Time_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "PreferenceConditionType_Time_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsPreferenceConditionType_Time_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPreferenceConditionType_Time_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsPreferenceConditionType_Time_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PreferenceConditionType_Time_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_recurrence_Exist)
	{
	// Class
	if (m_recurrence != Mp7JrsPreferenceConditionType_Time_recurrence_Local2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_recurrence->ToText();
		element->setAttributeNS(X(""), X("recurrence"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_numOfRecurrences_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_numOfRecurrences);
		element->setAttributeNS(X(""), X("numOfRecurrences"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsPreferenceConditionType_Time_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("recurrence")))
	{
        // Deserialize class type
		Mp7JrsPreferenceConditionType_Time_recurrence_Local2Ptr tmp = CreatePreferenceConditionType_Time_recurrence_LocalType2;
		tmp->Parse(parent->getAttributeNS(X(""), X("recurrence")));
        this->Setrecurrence(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("recurrence")))
	{
		// Deserialize class type
        Mp7JrsPreferenceConditionType_Time_recurrence_Local2Ptr tmp = CreatePreferenceConditionType_Time_recurrence_LocalType2;
        tmp->Parse(parent->getAttribute(X("recurrence")));
        this->Setrecurrence(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("numOfRecurrences")))
	{
        // deserialize value type
        this->SetnumOfRecurrences(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("numOfRecurrences"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("numOfRecurrences")))
	{
        // deserialize value type
        this->SetnumOfRecurrences(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("numOfRecurrences"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsTimeType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPreferenceConditionType_Time_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPreferenceConditionType_Time_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetTimePoint());
	if (GetRelTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetRelTimePoint());
	if (GetRelIncrTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetRelIncrTimePoint());
	if (GetDuration() != Mp7JrsNodePtr())
		result.Insert(GetDuration());
	if (GetIncrDuration() != Mp7JrsNodePtr())
		result.Insert(GetIncrDuration());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_LocalType_ExtMethodImpl.h


