 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtImplInclude.h



#include "Mp7JrsPositionType.h"
#include "Mp7JrsExtentType.h"
#include "Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtPropInit.h

}

IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::~IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtPropCleanup.h

}

Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::~Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType()
{
	Cleanup();
}

void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_TimePoint = Mp7JrsPositionPtr(); // Class
	m_TimePoint_Exist = false;
	m_Duration = Mp7JrsExtentPtr(); // Class
	m_Duration_Exist = false;


// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtMyPropInit.h

}

void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_TimePoint);
	// Mp7JrsFactory::DeleteObject(m_Duration);
}

void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SemanticTimeType_SemanticTimeInterval_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISemanticTimeType_SemanticTimeInterval_LocalType
    const Mp7JrsPtr< Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	if (tmp->IsValidTimePoint())
	{
		// Mp7JrsFactory::DeleteObject(m_TimePoint);
		this->SetTimePoint(Mp7JrsFactory::CloneObject(tmp->GetTimePoint()));
	}
	else
	{
		InvalidateTimePoint();
	}
	if (tmp->IsValidDuration())
	{
		// Mp7JrsFactory::DeleteObject(m_Duration);
		this->SetDuration(Mp7JrsFactory::CloneObject(tmp->GetDuration()));
	}
	else
	{
		InvalidateDuration();
	}
}

Mp7JrsNodePtr Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsPositionPtr Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::GetTimePoint() const
{
	return m_TimePoint;
}

// Element is optional
bool Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::IsValidTimePoint() const
{
	return m_TimePoint_Exist;
}

Mp7JrsExtentPtr Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::GetDuration() const
{
	return m_Duration;
}

// Element is optional
bool Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::IsValidDuration() const
{
	return m_Duration_Exist;
}

void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::SetTimePoint(const Mp7JrsPositionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::SetTimePoint().");
	}
	if (m_TimePoint != item || m_TimePoint_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_TimePoint);
		m_TimePoint = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TimePoint) m_TimePoint->SetParent(m_myself.getPointer());
		if (m_TimePoint && m_TimePoint->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PositionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TimePoint->UseTypeAttribute = true;
		}
		m_TimePoint_Exist = true;
		if(m_TimePoint != Mp7JrsPositionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TimePoint->SetContentName(XMLString::transcode("TimePoint"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::InvalidateTimePoint()
{
	m_TimePoint_Exist = false;
}
void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::SetDuration(const Mp7JrsExtentPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::SetDuration().");
	}
	if (m_Duration != item || m_Duration_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Duration);
		m_Duration = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Duration) m_Duration->SetParent(m_myself.getPointer());
		if (m_Duration && m_Duration->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ExtentType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Duration->UseTypeAttribute = true;
		}
		m_Duration_Exist = true;
		if(m_Duration != Mp7JrsExtentPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Duration->SetContentName(XMLString::transcode("Duration"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::InvalidateDuration()
{
	m_Duration_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("TimePoint")) == 0)
	{
		// TimePoint is simple element PositionType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTimePoint()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PositionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsPositionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTimePoint(p, client);
					if((p = GetTimePoint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Duration")) == 0)
	{
		// Duration is simple element ExtentType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetDuration()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ExtentType")))) != empty)
			{
				// Is type allowed
				Mp7JrsExtentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetDuration(p, client);
					if((p = GetDuration()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SemanticTimeType_SemanticTimeInterval_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SemanticTimeType_SemanticTimeInterval_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SemanticTimeType_SemanticTimeInterval_LocalType"));
	// Element serialization:
	// Class
	
	if (m_TimePoint != Mp7JrsPositionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TimePoint->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TimePoint"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TimePoint->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Duration != Mp7JrsExtentPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Duration->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Duration"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Duration->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TimePoint"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TimePoint")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreatePositionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTimePoint(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Duration"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Duration")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateExtentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetDuration(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("TimePoint")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreatePositionType;
    }
    this->SetTimePoint(child);
  }
  if (XMLString::compareString(elementname, X("Duration")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateExtentType;
    }
    this->SetDuration(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetTimePoint());
	if (GetDuration() != Mp7JrsNodePtr())
		result.Insert(GetDuration());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtMethodImpl.h


