 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtImplInclude.h



#include "Mp7JrsAudioDType.h"
#include "Mp7JrsSoundModelStateHistogramType_CollectionType.h"
#include "Mp7JrsintegerVector.h"
#include "Mp7JrsSoundModelStateHistogramType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsSoundModelStateHistogramType_LocalType.h" // Sequence collection RelativeFrequency
#include "Mp7JrsnonNegativeReal.h" // Sequence collection element RelativeFrequency

#include <assert.h>
IMp7JrsSoundModelStateHistogramType::IMp7JrsSoundModelStateHistogramType()
{

// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtPropInit.h

}

IMp7JrsSoundModelStateHistogramType::~IMp7JrsSoundModelStateHistogramType()
{
// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtPropCleanup.h

}

Mp7JrsSoundModelStateHistogramType::Mp7JrsSoundModelStateHistogramType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSoundModelStateHistogramType::~Mp7JrsSoundModelStateHistogramType()
{
	Cleanup();
}

void Mp7JrsSoundModelStateHistogramType::Init()
{
	// Init base
	m_Base = CreateAudioDType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_SoundModelStateHistogramType_LocalType = Mp7JrsSoundModelStateHistogramType_CollectionPtr(); // Collection
	m_SoundModelRef = XMLString::transcode(""); //  Mandatory String


// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtMyPropInit.h

}

void Mp7JrsSoundModelStateHistogramType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_SoundModelStateHistogramType_LocalType);
	XMLString::release(&this->m_SoundModelRef);
	this->m_SoundModelRef = NULL;
}

void Mp7JrsSoundModelStateHistogramType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SoundModelStateHistogramTypePtr, since we
	// might need GetBase(), which isn't defined in ISoundModelStateHistogramType
    const Mp7JrsPtr< Mp7JrsSoundModelStateHistogramType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsAudioDPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSoundModelStateHistogramType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_SoundModelStateHistogramType_LocalType);
		this->SetSoundModelStateHistogramType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSoundModelStateHistogramType_LocalType()));
		this->SetSoundModelRef(XMLString::replicate(tmp->GetSoundModelRef()));
}

Mp7JrsNodePtr Mp7JrsSoundModelStateHistogramType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSoundModelStateHistogramType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsAudioDType > Mp7JrsSoundModelStateHistogramType::GetBase() const
{
	return m_Base;
}

Mp7JrsSoundModelStateHistogramType_CollectionPtr Mp7JrsSoundModelStateHistogramType::GetSoundModelStateHistogramType_LocalType() const
{
	return m_SoundModelStateHistogramType_LocalType;
}

XMLCh * Mp7JrsSoundModelStateHistogramType::GetSoundModelRef() const
{
	return m_SoundModelRef;
}

void Mp7JrsSoundModelStateHistogramType::SetSoundModelStateHistogramType_LocalType(const Mp7JrsSoundModelStateHistogramType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSoundModelStateHistogramType::SetSoundModelStateHistogramType_LocalType().");
	}
	if (m_SoundModelStateHistogramType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SoundModelStateHistogramType_LocalType);
		m_SoundModelStateHistogramType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SoundModelStateHistogramType_LocalType) m_SoundModelStateHistogramType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSoundModelStateHistogramType::SetSoundModelRef(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSoundModelStateHistogramType::SetSoundModelRef().");
	}
	if (m_SoundModelRef != item)
	{
		XMLString::release(&m_SoundModelRef);
		m_SoundModelRef = item;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsintegerVectorPtr Mp7JrsSoundModelStateHistogramType::Getchannels() const
{
	return GetBase()->Getchannels();
}

bool Mp7JrsSoundModelStateHistogramType::Existchannels() const
{
	return GetBase()->Existchannels();
}
void Mp7JrsSoundModelStateHistogramType::Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSoundModelStateHistogramType::Setchannels().");
	}
	GetBase()->Setchannels(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSoundModelStateHistogramType::Invalidatechannels()
{
	GetBase()->Invalidatechannels();
}

Mp7JrsNodeEnum Mp7JrsSoundModelStateHistogramType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("RelativeFrequency")) == 0)
	{
		// RelativeFrequency is contained in itemtype SoundModelStateHistogramType_LocalType
		// in sequence collection SoundModelStateHistogramType_CollectionType

		context->Found = true;
		Mp7JrsSoundModelStateHistogramType_CollectionPtr coll = GetSoundModelStateHistogramType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSoundModelStateHistogramType_CollectionType;
				SetSoundModelStateHistogramType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSoundModelStateHistogramType_LocalPtr)coll->elementAt(i))->GetRelativeFrequency()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsSoundModelStateHistogramType_LocalPtr item = CreateSoundModelStateHistogramType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsSoundModelStateHistogramType_LocalPtr)coll->elementAt(j))->SetRelativeFrequency(
						((Mp7JrsSoundModelStateHistogramType_LocalPtr)coll->elementAt(j+1))->GetRelativeFrequency());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsSoundModelStateHistogramType_LocalPtr)coll->elementAt(j))->SetRelativeFrequency(
						((Mp7JrsSoundModelStateHistogramType_LocalPtr)coll->elementAt(j-1))->GetRelativeFrequency());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:nonNegativeReal")))) != empty)
			{
				// Is type allowed
				Mp7JrsnonNegativeRealPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSoundModelStateHistogramType_LocalPtr)coll->elementAt(i))->SetRelativeFrequency(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsSoundModelStateHistogramType_LocalPtr)coll->elementAt(i))->GetRelativeFrequency()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SoundModelStateHistogramType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SoundModelStateHistogramType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSoundModelStateHistogramType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsSoundModelStateHistogramType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsSoundModelStateHistogramType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SoundModelStateHistogramType"));
	// Element serialization:
	if (m_SoundModelStateHistogramType_LocalType != Mp7JrsSoundModelStateHistogramType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SoundModelStateHistogramType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	 // String
	if(m_SoundModelRef != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_SoundModelRef, X("urn:mpeg:mpeg7:schema:2004"), X("SoundModelRef"), false);

}

bool Mp7JrsSoundModelStateHistogramType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsAudioDType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Sequence Collection
        if((parent != NULL) && (
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:StateRef")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("StateRef"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:RelativeFrequency")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("RelativeFrequency"), X("urn:mpeg:mpeg7:schema:2004")))
                ))
        {
            // Deserialize factory type
            Mp7JrsSoundModelStateHistogramType_CollectionPtr tmp = CreateSoundModelStateHistogramType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSoundModelStateHistogramType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("SoundModelRef"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetSoundModelRef(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetSoundModelRef(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSoundModelStateHistogramType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsSoundModelStateHistogramType_CollectionPtr tmp = CreateSoundModelStateHistogramType_CollectionType;
    this->SetSoundModelStateHistogramType_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSoundModelStateHistogramType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSoundModelStateHistogramType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSoundModelStateHistogramType_LocalType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtMethodImpl.h


