 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtImplInclude.h



#include "Mp7JrsSpaceFrequencyGraphType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsSpaceFrequencyGraphType_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSpaceFrequencyGraphType_LocalType0::IMp7JrsSpaceFrequencyGraphType_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtPropInit.h

}

IMp7JrsSpaceFrequencyGraphType_LocalType0::~IMp7JrsSpaceFrequencyGraphType_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtPropCleanup.h

}

Mp7JrsSpaceFrequencyGraphType_LocalType0::Mp7JrsSpaceFrequencyGraphType_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpaceFrequencyGraphType_LocalType0::~Mp7JrsSpaceFrequencyGraphType_LocalType0()
{
	Cleanup();
}

void Mp7JrsSpaceFrequencyGraphType_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_FrequencyChild = Mp7JrsSpaceFrequencyGraphPtr(); // Class
	m_FrequencyChildRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtMyPropInit.h

}

void Mp7JrsSpaceFrequencyGraphType_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_FrequencyChild);
	// Mp7JrsFactory::DeleteObject(m_FrequencyChildRef);
}

void Mp7JrsSpaceFrequencyGraphType_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SpaceFrequencyGraphType_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in ISpaceFrequencyGraphType_LocalType0
    const Mp7JrsPtr< Mp7JrsSpaceFrequencyGraphType_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_FrequencyChild);
		this->SetFrequencyChild(Mp7JrsFactory::CloneObject(tmp->GetFrequencyChild()));
		// Mp7JrsFactory::DeleteObject(m_FrequencyChildRef);
		this->SetFrequencyChildRef(Mp7JrsFactory::CloneObject(tmp->GetFrequencyChildRef()));
}

Mp7JrsNodePtr Mp7JrsSpaceFrequencyGraphType_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpaceFrequencyGraphType_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSpaceFrequencyGraphPtr Mp7JrsSpaceFrequencyGraphType_LocalType0::GetFrequencyChild() const
{
	return m_FrequencyChild;
}

Mp7JrsReferencePtr Mp7JrsSpaceFrequencyGraphType_LocalType0::GetFrequencyChildRef() const
{
	return m_FrequencyChildRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsSpaceFrequencyGraphType_LocalType0::SetFrequencyChild(const Mp7JrsSpaceFrequencyGraphPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpaceFrequencyGraphType_LocalType0::SetFrequencyChild().");
	}
	if (m_FrequencyChild != item)
	{
		// Mp7JrsFactory::DeleteObject(m_FrequencyChild);
		m_FrequencyChild = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_FrequencyChild) m_FrequencyChild->SetParent(m_myself.getPointer());
		if (m_FrequencyChild && m_FrequencyChild->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SpaceFrequencyGraphType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_FrequencyChild->UseTypeAttribute = true;
		}
		if(m_FrequencyChild != Mp7JrsSpaceFrequencyGraphPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_FrequencyChild->SetContentName(XMLString::transcode("FrequencyChild"));
		}
	// Mp7JrsFactory::DeleteObject(m_FrequencyChildRef);
	m_FrequencyChildRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSpaceFrequencyGraphType_LocalType0::SetFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpaceFrequencyGraphType_LocalType0::SetFrequencyChildRef().");
	}
	if (m_FrequencyChildRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_FrequencyChildRef);
		m_FrequencyChildRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_FrequencyChildRef) m_FrequencyChildRef->SetParent(m_myself.getPointer());
		if (m_FrequencyChildRef && m_FrequencyChildRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_FrequencyChildRef->UseTypeAttribute = true;
		}
		if(m_FrequencyChildRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_FrequencyChildRef->SetContentName(XMLString::transcode("FrequencyChildRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_FrequencyChild);
	m_FrequencyChild = Mp7JrsSpaceFrequencyGraphPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: SpaceFrequencyGraphType_LocalType0: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSpaceFrequencyGraphType_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSpaceFrequencyGraphType_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpaceFrequencyGraphType_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpaceFrequencyGraphType_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_FrequencyChild != Mp7JrsSpaceFrequencyGraphPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_FrequencyChild->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("FrequencyChild"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_FrequencyChild->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_FrequencyChildRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_FrequencyChildRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("FrequencyChildRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_FrequencyChildRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSpaceFrequencyGraphType_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("FrequencyChild"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("FrequencyChild")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSpaceFrequencyGraphType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFrequencyChild(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("FrequencyChildRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("FrequencyChildRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFrequencyChildRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpaceFrequencyGraphType_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("FrequencyChild")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSpaceFrequencyGraphType;
    }
    this->SetFrequencyChild(child);
  }
  if (XMLString::compareString(elementname, X("FrequencyChildRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetFrequencyChildRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpaceFrequencyGraphType_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetFrequencyChild() != Mp7JrsNodePtr())
		result.Insert(GetFrequencyChild());
	if (GetFrequencyChildRef() != Mp7JrsNodePtr())
		result.Insert(GetFrequencyChildRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtMethodImpl.h


