 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtImplInclude.h



#include "Mp7JrsHeaderType.h"
#include "Mp7Jrsunsigned8.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0.h"
#include "Mp7JrsSpatial2DCoordinateSystemType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsSpatial2DCoordinateSystemType::IMp7JrsSpatial2DCoordinateSystemType()
{

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtPropInit.h

}

IMp7JrsSpatial2DCoordinateSystemType::~IMp7JrsSpatial2DCoordinateSystemType()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtPropCleanup.h

}

Mp7JrsSpatial2DCoordinateSystemType::Mp7JrsSpatial2DCoordinateSystemType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpatial2DCoordinateSystemType::~Mp7JrsSpatial2DCoordinateSystemType()
{
	Cleanup();
}

void Mp7JrsSpatial2DCoordinateSystemType::Init()
{
	// Init base
	m_Base = CreateHeaderType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_xRepr = Createunsigned8; // Create a valid class
	m_xRepr->SetContent(0); // Use Value initialiser (xxx2)
	m_yRepr = Createunsigned8; // Create a valid class
	m_yRepr->SetContent(0); // Use Value initialiser (xxx2)
	m_xSrcSize = 1; // Value
	m_xSrcSize_Exist = false;
	m_ySrcSize = 1; // Value
	m_ySrcSize_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Unit = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::UninitializedEnumeration; // Enumeration
	m_Unit_Exist = false;
	m_LocalCoordinateSystem = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr(); // Class
	m_LocalCoordinateSystem_Exist = false;
	m_IntegratedCoordinateSystem = Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr(); // Class
	m_IntegratedCoordinateSystem_Exist = false;


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtMyPropInit.h

}

void Mp7JrsSpatial2DCoordinateSystemType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_xRepr);
	// Mp7JrsFactory::DeleteObject(m_yRepr);
	// Mp7JrsFactory::DeleteObject(m_LocalCoordinateSystem);
	// Mp7JrsFactory::DeleteObject(m_IntegratedCoordinateSystem);
}

void Mp7JrsSpatial2DCoordinateSystemType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use Spatial2DCoordinateSystemTypePtr, since we
	// might need GetBase(), which isn't defined in ISpatial2DCoordinateSystemType
    const Mp7JrsPtr< Mp7JrsSpatial2DCoordinateSystemType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsHeaderPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSpatial2DCoordinateSystemType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_xRepr);
		this->SetxRepr(Mp7JrsFactory::CloneObject(tmp->GetxRepr()));
	}
	{
	// Mp7JrsFactory::DeleteObject(m_yRepr);
		this->SetyRepr(Mp7JrsFactory::CloneObject(tmp->GetyRepr()));
	}
	{
	if (tmp->ExistxSrcSize())
	{
		this->SetxSrcSize(tmp->GetxSrcSize());
	}
	else
	{
		InvalidatexSrcSize();
	}
	}
	{
	if (tmp->ExistySrcSize())
	{
		this->SetySrcSize(tmp->GetySrcSize());
	}
	else
	{
		InvalidateySrcSize();
	}
	}
	if (tmp->IsValidUnit())
	{
		this->SetUnit(tmp->GetUnit());
	}
	else
	{
		InvalidateUnit();
	}
	if (tmp->IsValidLocalCoordinateSystem())
	{
		// Mp7JrsFactory::DeleteObject(m_LocalCoordinateSystem);
		this->SetLocalCoordinateSystem(Mp7JrsFactory::CloneObject(tmp->GetLocalCoordinateSystem()));
	}
	else
	{
		InvalidateLocalCoordinateSystem();
	}
	if (tmp->IsValidIntegratedCoordinateSystem())
	{
		// Mp7JrsFactory::DeleteObject(m_IntegratedCoordinateSystem);
		this->SetIntegratedCoordinateSystem(Mp7JrsFactory::CloneObject(tmp->GetIntegratedCoordinateSystem()));
	}
	else
	{
		InvalidateIntegratedCoordinateSystem();
	}
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsHeaderType > Mp7JrsSpatial2DCoordinateSystemType::GetBase() const
{
	return m_Base;
}

Mp7Jrsunsigned8Ptr Mp7JrsSpatial2DCoordinateSystemType::GetxRepr() const
{
	return m_xRepr;
}

void Mp7JrsSpatial2DCoordinateSystemType::SetxRepr(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::SetxRepr().");
	}
    m_xRepr = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_xRepr) m_xRepr->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7Jrsunsigned8Ptr Mp7JrsSpatial2DCoordinateSystemType::GetyRepr() const
{
	return m_yRepr;
}

void Mp7JrsSpatial2DCoordinateSystemType::SetyRepr(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::SetyRepr().");
	}
    m_yRepr = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_yRepr) m_yRepr->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsSpatial2DCoordinateSystemType::GetxSrcSize() const
{
	return m_xSrcSize;
}

bool Mp7JrsSpatial2DCoordinateSystemType::ExistxSrcSize() const
{
	return m_xSrcSize_Exist;
}
void Mp7JrsSpatial2DCoordinateSystemType::SetxSrcSize(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::SetxSrcSize().");
	}
    m_xSrcSize = item;
	m_xSrcSize_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType::InvalidatexSrcSize()
{
	m_xSrcSize_Exist = false;
}
unsigned Mp7JrsSpatial2DCoordinateSystemType::GetySrcSize() const
{
	return m_ySrcSize;
}

bool Mp7JrsSpatial2DCoordinateSystemType::ExistySrcSize() const
{
	return m_ySrcSize_Exist;
}
void Mp7JrsSpatial2DCoordinateSystemType::SetySrcSize(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::SetySrcSize().");
	}
    m_ySrcSize = item;
	m_ySrcSize_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType::InvalidateySrcSize()
{
	m_ySrcSize_Exist = false;
}
Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Enumeration Mp7JrsSpatial2DCoordinateSystemType::GetUnit() const
{
	return m_Unit;
}

// Element is optional
bool Mp7JrsSpatial2DCoordinateSystemType::IsValidUnit() const
{
	return m_Unit_Exist;
}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr Mp7JrsSpatial2DCoordinateSystemType::GetLocalCoordinateSystem() const
{
	return m_LocalCoordinateSystem;
}

// Element is optional
bool Mp7JrsSpatial2DCoordinateSystemType::IsValidLocalCoordinateSystem() const
{
	return m_LocalCoordinateSystem_Exist;
}

Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr Mp7JrsSpatial2DCoordinateSystemType::GetIntegratedCoordinateSystem() const
{
	return m_IntegratedCoordinateSystem;
}

// Element is optional
bool Mp7JrsSpatial2DCoordinateSystemType::IsValidIntegratedCoordinateSystem() const
{
	return m_IntegratedCoordinateSystem_Exist;
}

void Mp7JrsSpatial2DCoordinateSystemType::SetUnit(Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::SetUnit().");
	}
	if (m_Unit != item || m_Unit_Exist == false)
	{
		// nothing to free here, hopefully
		m_Unit = item;
		m_Unit_Exist = true;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType::InvalidateUnit()
{
	m_Unit_Exist = false;
}
void Mp7JrsSpatial2DCoordinateSystemType::SetLocalCoordinateSystem(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::SetLocalCoordinateSystem().");
	}
	if (m_LocalCoordinateSystem != item || m_LocalCoordinateSystem_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_LocalCoordinateSystem);
		m_LocalCoordinateSystem = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_LocalCoordinateSystem) m_LocalCoordinateSystem->SetParent(m_myself.getPointer());
		if (m_LocalCoordinateSystem && m_LocalCoordinateSystem->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_LocalCoordinateSystem->UseTypeAttribute = true;
		}
		m_LocalCoordinateSystem_Exist = true;
		if(m_LocalCoordinateSystem != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_LocalCoordinateSystem->SetContentName(XMLString::transcode("LocalCoordinateSystem"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType::InvalidateLocalCoordinateSystem()
{
	m_LocalCoordinateSystem_Exist = false;
}
void Mp7JrsSpatial2DCoordinateSystemType::SetIntegratedCoordinateSystem(const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::SetIntegratedCoordinateSystem().");
	}
	if (m_IntegratedCoordinateSystem != item || m_IntegratedCoordinateSystem_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_IntegratedCoordinateSystem);
		m_IntegratedCoordinateSystem = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_IntegratedCoordinateSystem) m_IntegratedCoordinateSystem->SetParent(m_myself.getPointer());
		if (m_IntegratedCoordinateSystem && m_IntegratedCoordinateSystem->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_IntegratedCoordinateSystem->UseTypeAttribute = true;
		}
		m_IntegratedCoordinateSystem_Exist = true;
		if(m_IntegratedCoordinateSystem != Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_IntegratedCoordinateSystem->SetContentName(XMLString::transcode("IntegratedCoordinateSystem"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType::InvalidateIntegratedCoordinateSystem()
{
	m_IntegratedCoordinateSystem_Exist = false;
}
XMLCh * Mp7JrsSpatial2DCoordinateSystemType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsSpatial2DCoordinateSystemType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsSpatial2DCoordinateSystemType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType::Invalidateid()
{
	GetBase()->Invalidateid();
}

Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("LocalCoordinateSystem")) == 0)
	{
		// LocalCoordinateSystem is simple element Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetLocalCoordinateSystem()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetLocalCoordinateSystem(p, client);
					if((p = GetLocalCoordinateSystem()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("IntegratedCoordinateSystem")) == 0)
	{
		// IntegratedCoordinateSystem is simple element Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetIntegratedCoordinateSystem()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetIntegratedCoordinateSystem(p, client);
					if((p = GetIntegratedCoordinateSystem()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for Spatial2DCoordinateSystemType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "Spatial2DCoordinateSystemType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSpatial2DCoordinateSystemType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpatial2DCoordinateSystemType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpatial2DCoordinateSystemType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("Spatial2DCoordinateSystemType"));
    // Attribute Serialization:
	// Class
	if (m_xRepr != Mp7Jrsunsigned8Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_xRepr->ToText();
		element->setAttributeNS(X(""), X("xRepr"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Class
	if (m_yRepr != Mp7Jrsunsigned8Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_yRepr->ToText();
		element->setAttributeNS(X(""), X("yRepr"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
		

	// Optional attriute
	if(m_xSrcSize_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_xSrcSize);
		element->setAttributeNS(X(""), X("xSrcSize"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_ySrcSize_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_ySrcSize);
		element->setAttributeNS(X(""), X("ySrcSize"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if(m_Unit != Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::ToText(m_Unit);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("Unit"), true);
		XMLString::release(&tmp);
	}
	// Class
	
	if (m_LocalCoordinateSystem != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_LocalCoordinateSystem->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("LocalCoordinateSystem"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_LocalCoordinateSystem->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_IntegratedCoordinateSystem != Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_IntegratedCoordinateSystem->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("IntegratedCoordinateSystem"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_IntegratedCoordinateSystem->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSpatial2DCoordinateSystemType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("xRepr")))
	{
        // Deserialize class type
		Mp7Jrsunsigned8Ptr tmp = Createunsigned8;
		tmp->Parse(parent->getAttributeNS(X(""), X("xRepr")));
        this->SetxRepr(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("xRepr")))
	{
		// Deserialize class type
        Mp7Jrsunsigned8Ptr tmp = Createunsigned8;
        tmp->Parse(parent->getAttribute(X("xRepr")));
        this->SetxRepr(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("yRepr")))
	{
        // Deserialize class type
		Mp7Jrsunsigned8Ptr tmp = Createunsigned8;
		tmp->Parse(parent->getAttributeNS(X(""), X("yRepr")));
        this->SetyRepr(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("yRepr")))
	{
		// Deserialize class type
        Mp7Jrsunsigned8Ptr tmp = Createunsigned8;
        tmp->Parse(parent->getAttribute(X("yRepr")));
        this->SetyRepr(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("xSrcSize")))
	{
        // deserialize value type
        this->SetxSrcSize(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("xSrcSize"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("xSrcSize")))
	{
        // deserialize value type
        this->SetxSrcSize(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("xSrcSize"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("ySrcSize")))
	{
        // deserialize value type
        this->SetySrcSize(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("ySrcSize"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("ySrcSize")))
	{
        // deserialize value type
        this->SetySrcSize(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("ySrcSize"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsHeaderType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("Unit"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Unit")) == 0))
        {
            Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Enumeration tmp = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Parse(Mp7JrsUtil::GetElementText(parent));
            if(tmp == Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::UninitializedEnumeration)
            {
                    return false;
            }
            this->SetUnit(tmp);
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("LocalCoordinateSystem"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("LocalCoordinateSystem")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetLocalCoordinateSystem(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("IntegratedCoordinateSystem"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("IntegratedCoordinateSystem")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetIntegratedCoordinateSystem(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("LocalCoordinateSystem")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1;
    }
    this->SetLocalCoordinateSystem(child);
  }
  if (XMLString::compareString(elementname, X("IntegratedCoordinateSystem")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0;
    }
    this->SetIntegratedCoordinateSystem(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetLocalCoordinateSystem() != Mp7JrsNodePtr())
		result.Insert(GetLocalCoordinateSystem());
	if (GetIntegratedCoordinateSystem() != Mp7JrsNodePtr())
		result.Insert(GetIntegratedCoordinateSystem());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_ExtMethodImpl.h


