 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtImplInclude.h



#include "Mp7JrsMediaIncrDurationType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtPropInit.h

}

IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::~IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtPropCleanup.h

}

Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::~Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType()
{
	Cleanup();
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_TimeIncr = Mp7JrsMediaIncrDurationPtr(); // Class with content 
	m_MotionParams = Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtMyPropInit.h

}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_TimeIncr);
	// Mp7JrsFactory::DeleteObject(m_MotionParams);
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType
    const Mp7JrsPtr< Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_TimeIncr);
		this->SetTimeIncr(Mp7JrsFactory::CloneObject(tmp->GetTimeIncr()));
		// Mp7JrsFactory::DeleteObject(m_MotionParams);
		this->SetMotionParams(Mp7JrsFactory::CloneObject(tmp->GetMotionParams()));
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsMediaIncrDurationPtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::GetTimeIncr() const
{
	return m_TimeIncr;
}

Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::GetMotionParams() const
{
	return m_MotionParams;
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::SetTimeIncr(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::SetTimeIncr().");
	}
	if (m_TimeIncr != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TimeIncr);
		m_TimeIncr = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TimeIncr) m_TimeIncr->SetParent(m_myself.getPointer());
		if (m_TimeIncr && m_TimeIncr->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaIncrDurationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TimeIncr->UseTypeAttribute = true;
		}
		if(m_TimeIncr != Mp7JrsMediaIncrDurationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TimeIncr->SetContentName(XMLString::transcode("TimeIncr"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::SetMotionParams(const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::SetMotionParams().");
	}
	if (m_MotionParams != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MotionParams);
		m_MotionParams = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MotionParams) m_MotionParams->SetParent(m_myself.getPointer());
		if(m_MotionParams != Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MotionParams->SetContentName(XMLString::transcode("MotionParams"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType"));
	// Element serialization:
	// Class with content		
	
	if (m_TimeIncr != Mp7JrsMediaIncrDurationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TimeIncr->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TimeIncr"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TimeIncr->Serialize(doc, element, &elem);
	}
	if (m_MotionParams != Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MotionParams->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TimeIncr"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TimeIncr")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaIncrDurationType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTimeIncr(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("MotionParams"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("MotionParams")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMotionParams(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("TimeIncr")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaIncrDurationType;
    }
    this->SetTimeIncr(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("MotionParams")) == 0))
  {
    Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType;
    this->SetMotionParams(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTimeIncr() != Mp7JrsNodePtr())
		result.Insert(GetTimeIncr());
	if (GetMotionParams() != Mp7JrsNodePtr())
		result.Insert(GetMotionParams());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtMethodImpl.h


