 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtImplInclude.h



#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType.h" // Sequence collection Pixel
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType.h" // Sequence collection element Pixel
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType.h" // Sequence collection element CoordPoint
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0.h" // Sequence collection CurrPixel
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType.h" // Sequence collection element CurrPixel
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType.h" // Sequence collection element SrcPixel

#include <assert.h>
IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1()
{

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtPropInit.h

}

IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::~IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtPropCleanup.h

}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::~Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1()
{
	Cleanup();
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Init()
{

	// Init attributes
	m_name = NULL; // String
	m_dataSet = NULL; // String
	m_dataSet_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr(); // Collection
	m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr(); // Collection
	m_MappingFunct = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMyPropInit.h

}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMyPropCleanup.h


	XMLString::release(&m_name);
	XMLString::release(&m_dataSet);
	// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType);
	// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0);
	// Mp7JrsFactory::DeleteObject(m_MappingFunct);
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1Ptr, since we
	// might need GetBase(), which isn't defined in ISpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1
    const Mp7JrsPtr< Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	XMLString::release(&m_name);
		this->Setname(XMLString::replicate(tmp->Getname()));
	}
	{
	XMLString::release(&m_dataSet);
	if (tmp->ExistdataSet())
	{
		this->SetdataSet(XMLString::replicate(tmp->GetdataSet()));
	}
	else
	{
		InvalidatedataSet();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType);
		this->SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType()));
		// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0);
		this->SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(Mp7JrsFactory::CloneObject(tmp->GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0()));
		// Mp7JrsFactory::DeleteObject(m_MappingFunct);
		this->SetMappingFunct(Mp7JrsFactory::CloneObject(tmp->GetMappingFunct()));
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Getname() const
{
	return m_name;
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Setname(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Setname().");
	}
    m_name = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetdataSet() const
{
	return m_dataSet;
}

bool Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::ExistdataSet() const
{
	return m_dataSet_Exist;
}
void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetdataSet(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetdataSet().");
	}
    m_dataSet = item;
	m_dataSet_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::InvalidatedataSet()
{
	m_dataSet_Exist = false;
}
Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType() const
{
	return m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0() const
{
	return m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetMappingFunct() const
{
	return m_MappingFunct;
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType().");
	}
	if (m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType);
		m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType) m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType->SetParent(m_myself.getPointer());
	// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0);
	m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0().");
	}
	if (m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0);
		m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0) m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0->SetParent(m_myself.getPointer());
	// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType);
	m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetMappingFunct(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::SetMappingFunct().");
	}
	if (m_MappingFunct != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MappingFunct);
		m_MappingFunct = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MappingFunct) m_MappingFunct->SetParent(m_myself.getPointer());
		if(m_MappingFunct != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MappingFunct->SetContentName(XMLString::transcode("MappingFunct"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Pixel")) == 0)
	{
		// Pixel is contained in itemtype Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType
		// in sequence collection Spatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType

		context->Found = true;
		Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr coll = GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
				SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 3))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(i))->GetPixel()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr item = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j))->SetPixel(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j+1))->GetPixel());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j))->SetPixel(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j-1))->GetPixel());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(i))->SetPixel(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(i))->GetPixel()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CoordPoint")) == 0)
	{
		// CoordPoint is contained in itemtype Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType
		// in sequence collection Spatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType

		context->Found = true;
		Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr coll = GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
				SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 3))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(i))->GetCoordPoint()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr item = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j))->SetCoordPoint(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j+1))->GetCoordPoint());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j))->SetCoordPoint(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(j-1))->GetCoordPoint());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(i))->SetCoordPoint(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr)coll->elementAt(i))->GetCoordPoint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CurrPixel")) == 0)
	{
		// CurrPixel is contained in itemtype Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0
		// in sequence collection Spatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0

		context->Found = true;
		Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr coll = GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
				SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 3))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(i))->GetCurrPixel()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr item = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j))->SetCurrPixel(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j+1))->GetCurrPixel());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j))->SetCurrPixel(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j-1))->GetCurrPixel());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(i))->SetCurrPixel(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(i))->GetCurrPixel()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SrcPixel")) == 0)
	{
		// SrcPixel is contained in itemtype Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0
		// in sequence collection Spatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0

		context->Found = true;
		Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr coll = GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
				SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 3))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(i))->GetSrcPixel()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr item = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j))->SetSrcPixel(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j+1))->GetSrcPixel());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j))->SetSrcPixel(
						((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(j-1))->GetSrcPixel());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(i))->SetSrcPixel(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr)coll->elementAt(i))->GetSrcPixel()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MappingFunct")) == 0)
	{
		// Some primitive nodes types cannot be handled
		Mp7JrsXPathParseContext::ErrorUnsupportedType(context, "XMLCh *");
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1");
	}		
	
	return result;
}

XMLCh * Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1"));
    // Attribute Serialization:
	// String
	if(m_name != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("name"), m_name);
	}
    // Attribute Serialization:
		

	// Optional attriute
	if(m_dataSet_Exist)
	{
	// String
	if(m_dataSet != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("dataSet"), m_dataSet);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_MappingFunct != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_MappingFunct->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("name")))
	{
        // Deserialize string type
        this->Setname(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("name"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("name")))
	{
        // Deserialize string type
        this->Setname(Mp7JrsConvert::TextToString(parent->getAttribute(X("name"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("dataSet")))
	{
        // Deserialize string type
        this->SetdataSet(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("dataSet"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("dataSet")))
	{
        // Deserialize string type
        this->SetdataSet(Mp7JrsConvert::TextToString(parent->getAttribute(X("dataSet"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
    {
        // Sequence Collection
        if((parent != NULL) && (
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Pixel")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("Pixel"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:CoordPoint")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("CoordPoint"), X("urn:mpeg:mpeg7:schema:2004")))
                ))
        {
            // Deserialize factory type
            Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Sequence Collection
        if((parent != NULL) && (
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:CurrPixel")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("CurrPixel"), X("urn:mpeg:mpeg7:schema:2004")))
                ||
// Old            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SrcPixel")) == 0)
            (Mp7JrsUtil::HasNodeName(parent, X("SrcPixel"), X("urn:mpeg:mpeg7:schema:2004")))
                ))
        {
            // Deserialize factory type
            Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
            tmp->Deserialize(doc, parent, current);
            this->SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("MappingFunct"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("MappingFunct")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetMappingFunct(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
    this->SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(tmp);
    child = tmp;
  }
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
    this->SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("MappingFunct")) == 0))
  {
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType;
    this->SetMappingFunct(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMappingFunct() != Mp7JrsNodePtr())
		result.Insert(GetMappingFunct());
	if (GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType());
	if (GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0() != Mp7JrsNodePtr())
		result.Insert(GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMethodImpl.h


