 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtImplInclude.h



#include "Mp7JrsTermDefinitionBaseType.h"
#include "Mp7JrsSubjectTermDefinitionType_CollectionType.h"
#include "Mp7JrsTermDefinitionBaseType_Name_CollectionType.h"
#include "Mp7JrsTermDefinitionBaseType_Definition_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsTermDefinitionBaseType_Name_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Definition

#include <assert.h>
IMp7JrsSubjectTermDefinitionType::IMp7JrsSubjectTermDefinitionType()
{

// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtPropInit.h

}

IMp7JrsSubjectTermDefinitionType::~IMp7JrsSubjectTermDefinitionType()
{
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtPropCleanup.h

}

Mp7JrsSubjectTermDefinitionType::Mp7JrsSubjectTermDefinitionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSubjectTermDefinitionType::~Mp7JrsSubjectTermDefinitionType()
{
	Cleanup();
}

void Mp7JrsSubjectTermDefinitionType::Init()
{
	// Init base
	m_Base = CreateTermDefinitionBaseType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_SubjectTermDefinitionType_LocalType = Mp7JrsSubjectTermDefinitionType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtMyPropInit.h

}

void Mp7JrsSubjectTermDefinitionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_SubjectTermDefinitionType_LocalType);
}

void Mp7JrsSubjectTermDefinitionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SubjectTermDefinitionTypePtr, since we
	// might need GetBase(), which isn't defined in ISubjectTermDefinitionType
    const Mp7JrsPtr< Mp7JrsSubjectTermDefinitionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsTermDefinitionBasePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSubjectTermDefinitionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_SubjectTermDefinitionType_LocalType);
		this->SetSubjectTermDefinitionType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSubjectTermDefinitionType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsTermDefinitionBaseType > Mp7JrsSubjectTermDefinitionType::GetBase() const
{
	return m_Base;
}

Mp7JrsSubjectTermDefinitionType_CollectionPtr Mp7JrsSubjectTermDefinitionType::GetSubjectTermDefinitionType_LocalType() const
{
	return m_SubjectTermDefinitionType_LocalType;
}

void Mp7JrsSubjectTermDefinitionType::SetSubjectTermDefinitionType_LocalType(const Mp7JrsSubjectTermDefinitionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SetSubjectTermDefinitionType_LocalType().");
	}
	if (m_SubjectTermDefinitionType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SubjectTermDefinitionType_LocalType);
		m_SubjectTermDefinitionType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SubjectTermDefinitionType_LocalType) m_SubjectTermDefinitionType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSubjectTermDefinitionType::GettermID() const
{
	return GetBase()->GettermID();
}

bool Mp7JrsSubjectTermDefinitionType::ExisttermID() const
{
	return GetBase()->ExisttermID();
}
void Mp7JrsSubjectTermDefinitionType::SettermID(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SettermID().");
	}
	GetBase()->SettermID(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType::InvalidatetermID()
{
	GetBase()->InvalidatetermID();
}
Mp7JrsTermDefinitionBaseType_Name_CollectionPtr Mp7JrsSubjectTermDefinitionType::GetName() const
{
	return GetBase()->GetName();
}

Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr Mp7JrsSubjectTermDefinitionType::GetDefinition() const
{
	return GetBase()->GetDefinition();
}

void Mp7JrsSubjectTermDefinitionType::SetName(const Mp7JrsTermDefinitionBaseType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SetName().");
	}
	GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType::SetDefinition(const Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SetDefinition().");
	}
	GetBase()->SetDefinition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSubjectTermDefinitionType::Getid() const
{
	return GetBase()->GetBase()->Getid();
}

bool Mp7JrsSubjectTermDefinitionType::Existid() const
{
	return GetBase()->GetBase()->Existid();
}
void Mp7JrsSubjectTermDefinitionType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::Setid().");
	}
	GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType::Invalidateid()
{
	GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsSubjectTermDefinitionType::GettimeBase() const
{
	return GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsSubjectTermDefinitionType::ExisttimeBase() const
{
	return GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsSubjectTermDefinitionType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SettimeBase().");
	}
	GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType::InvalidatetimeBase()
{
	GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsSubjectTermDefinitionType::GettimeUnit() const
{
	return GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsSubjectTermDefinitionType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsSubjectTermDefinitionType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SettimeUnit().");
	}
	GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsSubjectTermDefinitionType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsSubjectTermDefinitionType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsSubjectTermDefinitionType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsSubjectTermDefinitionType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsSubjectTermDefinitionType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsSubjectTermDefinitionType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsSubjectTermDefinitionType::GetHeader() const
{
	return GetBase()->GetBase()->GetHeader();
}

void Mp7JrsSubjectTermDefinitionType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType::SetHeader().");
	}
	GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSubjectTermDefinitionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Classification")) == 0)
	{
		// "urn:mpeg:mpeg7:schema:2004:Classification" is itemtype TextualType in element collection SubjectTermDefinitionType_Classification_CollectionType
		// nested in choice collection SubjectTermDefinitionType_CollectionType (itemtype: SubjectTermDefinitionType_LocalType)
		context->Found = true;
		// FTT This will be handled properly in V3!
		Mp7JrsXPathParseContext::ErrorNotImplemented(context->XPath, "SubjectTermDefinitionType (nested collection element urn:mpeg:mpeg7:schema:2004:Classification)");

		return result;
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Subdivision")) == 0)
	{
		// "urn:mpeg:mpeg7:schema:2004:Subdivision" is itemtype TextualType in element collection SubjectTermDefinitionType_Subdivision_CollectionType
		// nested in choice collection SubjectTermDefinitionType_CollectionType (itemtype: SubjectTermDefinitionType_LocalType)
		context->Found = true;
		// FTT This will be handled properly in V3!
		Mp7JrsXPathParseContext::ErrorNotImplemented(context->XPath, "SubjectTermDefinitionType (nested collection element urn:mpeg:mpeg7:schema:2004:Subdivision)");

		return result;
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Note")) == 0)
	{
		// "urn:mpeg:mpeg7:schema:2004:Note" is itemtype SubjectTermDefinitionType_Note_LocalType in element collection SubjectTermDefinitionType_Note_CollectionType
		// nested in choice collection SubjectTermDefinitionType_CollectionType (itemtype: SubjectTermDefinitionType_LocalType)
		context->Found = true;
		// FTT This will be handled properly in V3!
		Mp7JrsXPathParseContext::ErrorNotImplemented(context->XPath, "SubjectTermDefinitionType (nested collection element urn:mpeg:mpeg7:schema:2004:Note)");

		return result;
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Term")) == 0)
	{
		// "urn:mpeg:mpeg7:schema:2004:Term" is itemtype SubjectTermDefinitionType_Term_LocalType in element collection SubjectTermDefinitionType_Term_CollectionType
		// nested in choice collection SubjectTermDefinitionType_CollectionType (itemtype: SubjectTermDefinitionType_LocalType)
		context->Found = true;
		// FTT This will be handled properly in V3!
		Mp7JrsXPathParseContext::ErrorNotImplemented(context->XPath, "SubjectTermDefinitionType (nested collection element urn:mpeg:mpeg7:schema:2004:Term)");

		return result;
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SubjectTermDefinitionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SubjectTermDefinitionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSubjectTermDefinitionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsSubjectTermDefinitionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsSubjectTermDefinitionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SubjectTermDefinitionType"));
	// Element serialization:
	if (m_SubjectTermDefinitionType_LocalType != Mp7JrsSubjectTermDefinitionType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SubjectTermDefinitionType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSubjectTermDefinitionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsTermDefinitionBaseType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:Classification
            Mp7JrsUtil::HasNodeName(parent, X("Classification"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Classification")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:Subdivision
            Mp7JrsUtil::HasNodeName(parent, X("Subdivision"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Subdivision")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:Note
            Mp7JrsUtil::HasNodeName(parent, X("Note"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Note")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:Term
            Mp7JrsUtil::HasNodeName(parent, X("Term"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Term")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsSubjectTermDefinitionType_CollectionPtr tmp = CreateSubjectTermDefinitionType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSubjectTermDefinitionType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Classification"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Classification")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Subdivision"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Subdivision")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Note"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Note")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Term"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Term")) == 0)
    )
  {
    Mp7JrsSubjectTermDefinitionType_CollectionPtr tmp = CreateSubjectTermDefinitionType_CollectionType;
    this->SetSubjectTermDefinitionType_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSubjectTermDefinitionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSubjectTermDefinitionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSubjectTermDefinitionType_LocalType());
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetDefinition() != Mp7JrsNodePtr())
		result.Insert(GetDefinition());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_ExtMethodImpl.h


