 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtImplInclude.h



#include "Mp7JrsTextualType.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsTextualBaseType_phoneticTranscription_CollectionType.h"
#include "Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsSummaryPreferencesType_SummaryTheme_LocalType::IMp7JrsSummaryPreferencesType_SummaryTheme_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtPropInit.h

}

IMp7JrsSummaryPreferencesType_SummaryTheme_LocalType::~IMp7JrsSummaryPreferencesType_SummaryTheme_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtPropCleanup.h

}

Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::~Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType()
{
	Cleanup();
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Init()
{
	// Init base
	m_Base = CreateTextualType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;



// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtMyPropInit.h

}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SummaryPreferencesType_SummaryTheme_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISummaryPreferencesType_SummaryTheme_LocalType
    const Mp7JrsPtr< Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsTextualPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
}

Mp7JrsNodePtr Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsTextualType > Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetBase() const
{
	return m_Base;
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetContent(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetContent().");
	}
	GetBase()->GetBase()->SetContent(item);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetContent() const
{
	return GetBase()->GetBase()->GetContent();
}
Mp7JrspreferenceValuePtr Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetpreferenceValue().");
	}
    m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
XMLCh * Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Getlang() const
{
	return GetBase()->GetBase()->Getlang();
}

bool Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Existlang() const
{
	return GetBase()->GetBase()->Existlang();
}
void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Setlang(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Setlang().");
	}
	GetBase()->GetBase()->Setlang(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Invalidatelang()
{
	GetBase()->GetBase()->Invalidatelang();
}
Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetphoneticTranscription() const
{
	return GetBase()->GetBase()->GetphoneticTranscription();
}

bool Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::ExistphoneticTranscription() const
{
	return GetBase()->GetBase()->ExistphoneticTranscription();
}
void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetphoneticTranscription(const Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetphoneticTranscription().");
	}
	GetBase()->GetBase()->SetphoneticTranscription(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::InvalidatephoneticTranscription()
{
	GetBase()->GetBase()->InvalidatephoneticTranscription();
}
Mp7JrsphoneticAlphabetType::Enumeration Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetphoneticAlphabet() const
{
	return GetBase()->GetBase()->GetphoneticAlphabet();
}

bool Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::ExistphoneticAlphabet() const
{
	return GetBase()->GetBase()->ExistphoneticAlphabet();
}
void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::SetphoneticAlphabet().");
	}
	GetBase()->GetBase()->SetphoneticAlphabet(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::InvalidatephoneticAlphabet()
{
	GetBase()->GetBase()->InvalidatephoneticAlphabet();
}

Mp7JrsNodeEnum Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for SummaryPreferencesType_SummaryTheme_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "SummaryPreferencesType_SummaryTheme_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SummaryPreferencesType_SummaryTheme_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("preferenceValue")))
	{
        // Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttributeNS(X(""), X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
        Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
        tmp->Parse(parent->getAttribute(X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsTextualType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType_ExtMethodImpl.h


