 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType_ExtImplInclude.h



#include "Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::IMp7JrsTemporalSegmentLocatorType_BytePosition_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType_ExtPropInit.h

}

IMp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::~IMp7JrsTemporalSegmentLocatorType_BytePosition_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType_ExtPropCleanup.h

}

Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::~Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType()
{
	Cleanup();
}

void Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Init()
{

	// Init attributes
	m_offset = 0; // Value
	m_length = 1; // Value
	m_length_Exist = false;



// no includefile for extension defined 
// file Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType_ExtMyPropInit.h

}

void Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType_ExtMyPropCleanup.h


}

void Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use TemporalSegmentLocatorType_BytePosition_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ITemporalSegmentLocatorType_BytePosition_LocalType
    const Mp7JrsPtr< Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
		this->Setoffset(tmp->Getoffset());
	}
	{
	if (tmp->Existlength())
	{
		this->Setlength(tmp->Getlength());
	}
	else
	{
		Invalidatelength();
	}
	}
}

Mp7JrsNodePtr Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


unsigned Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Getoffset() const
{
	return m_offset;
}

void Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Setoffset(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Setoffset().");
	}
    m_offset = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

unsigned Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Getlength() const
{
	return m_length;
}

bool Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Existlength() const
{
	return m_length_Exist;
}
void Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Setlength(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Setlength().");
	}
    m_length = item;
	m_length_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Invalidatelength()
{
	m_length_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("TemporalSegmentLocatorType_BytePosition_LocalType"));
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_offset);
		element->setAttributeNS(X(""), X("offset"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
		

	// Optional attriute
	if(m_length_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_length);
		element->setAttributeNS(X(""), X("length"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("offset")))
	{
        // deserialize value type
        this->Setoffset(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("offset"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("offset")))
	{
        // deserialize value type
        this->Setoffset(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("offset"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("length")))
	{
        // deserialize value type
        this->Setlength(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("length"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("length")))
	{
        // deserialize value type
        this->Setlength(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("length"))));
        * current = parent;
    }

// no includefile for extension defined 
// file Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType_ExtMethodImpl.h


