 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtImplInclude.h



#include "Mp7JrsTextureBrowsingType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsTextureBrowsingType_LocalType::IMp7JrsTextureBrowsingType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtPropInit.h

}

IMp7JrsTextureBrowsingType_LocalType::~IMp7JrsTextureBrowsingType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtPropCleanup.h

}

Mp7JrsTextureBrowsingType_LocalType::Mp7JrsTextureBrowsingType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsTextureBrowsingType_LocalType::~Mp7JrsTextureBrowsingType_LocalType()
{
	Cleanup();
}

void Mp7JrsTextureBrowsingType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Direction = Mp7JrsTextureBrowsingType_Direction_LocalType::UninitializedEnumeration; // Enumeration
	m_Scale = Mp7JrsTextureBrowsingType_Scale_LocalType::UninitializedEnumeration; // Enumeration


// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtMyPropInit.h

}

void Mp7JrsTextureBrowsingType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtMyPropCleanup.h


}

void Mp7JrsTextureBrowsingType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use TextureBrowsingType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ITextureBrowsingType_LocalType
    const Mp7JrsPtr< Mp7JrsTextureBrowsingType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		this->SetDirection(tmp->GetDirection());
		this->SetScale(tmp->GetScale());
}

Mp7JrsNodePtr Mp7JrsTextureBrowsingType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsTextureBrowsingType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration Mp7JrsTextureBrowsingType_LocalType::GetDirection() const
{
	return m_Direction;
}

Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration Mp7JrsTextureBrowsingType_LocalType::GetScale() const
{
	return m_Scale;
}

void Mp7JrsTextureBrowsingType_LocalType::SetDirection(Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTextureBrowsingType_LocalType::SetDirection().");
	}
	if (m_Direction != item)
	{
		// nothing to free here, hopefully
		m_Direction = item;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsTextureBrowsingType_LocalType::SetScale(Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTextureBrowsingType_LocalType::SetScale().");
	}
	if (m_Scale != item)
	{
		// nothing to free here, hopefully
		m_Scale = item;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: TextureBrowsingType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsTextureBrowsingType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsTextureBrowsingType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsTextureBrowsingType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsTextureBrowsingType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("TextureBrowsingType_LocalType"));
	// Element serialization:
	if(m_Direction != Mp7JrsTextureBrowsingType_Direction_LocalType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsTextureBrowsingType_Direction_LocalType::ToText(m_Direction);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("Direction"), false);
		XMLString::release(&tmp);
	}
	if(m_Scale != Mp7JrsTextureBrowsingType_Scale_LocalType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsTextureBrowsingType_Scale_LocalType::ToText(m_Scale);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("Scale"), false);
		XMLString::release(&tmp);
	}

}

bool Mp7JrsTextureBrowsingType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

        // Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("Direction"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Direction")) == 0))
        {
            Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration tmp = Mp7JrsTextureBrowsingType_Direction_LocalType::Parse(Mp7JrsUtil::GetElementText(parent));
            if(tmp == Mp7JrsTextureBrowsingType_Direction_LocalType::UninitializedEnumeration)
            {
                    return false;
            }
            this->SetDirection(tmp);
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("Scale"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Scale")) == 0))
        {
            Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration tmp = Mp7JrsTextureBrowsingType_Scale_LocalType::Parse(Mp7JrsUtil::GetElementText(parent));
            if(tmp == Mp7JrsTextureBrowsingType_Scale_LocalType::UninitializedEnumeration)
            {
                    return false;
            }
            this->SetScale(tmp);
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsTextureBrowsingType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsTextureBrowsingType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtMethodImpl.h


