 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType2_ExtImplInclude.h



#include "Mp7JrsTitleType_type_LocalType0.h"
#include "Mp7JrsTitleType_type_LocalType1.h"
#include "Mp7JrsTitleType_type_LocalType2.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsTitleType_type_LocalType2::IMp7JrsTitleType_type_LocalType2()
{

// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType2_ExtPropInit.h

}

IMp7JrsTitleType_type_LocalType2::~IMp7JrsTitleType_type_LocalType2()
{
// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType2_ExtPropCleanup.h

}

Mp7JrsTitleType_type_LocalType2::Mp7JrsTitleType_type_LocalType2()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsTitleType_type_LocalType2::~Mp7JrsTitleType_type_LocalType2()
{
	Cleanup();
}

void Mp7JrsTitleType_type_LocalType2::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_TitleType_type_LocalType = Mp7JrsTitleType_type_LocalType::UninitializedEnumeration; // Enumeration
	m_TitleType_type_LocalType0 = Mp7JrsTitleType_type_Local0Ptr(); // Pattern
	m_TitleType_type_LocalType1 = Mp7JrsTitleType_type_Local1Ptr(); // Class


// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType2_ExtMyPropInit.h

}

void Mp7JrsTitleType_type_LocalType2::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType2_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType0);
	// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType1);
}

void Mp7JrsTitleType_type_LocalType2::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use TitleType_type_LocalType2Ptr, since we
	// might need GetBase(), which isn't defined in ITitleType_type_LocalType2
    const Mp7JrsPtr< Mp7JrsTitleType_type_LocalType2 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if(tmp->GetTitleType_type_LocalType() != Mp7JrsTitleType_type_LocalType::UninitializedEnumeration)
	{
		this->SetTitleType_type_LocalType(tmp->GetTitleType_type_LocalType());
		return;
	}
	if(tmp->GetTitleType_type_LocalType0() != Mp7JrsTitleType_type_Local0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		this->SetTitleType_type_LocalType0(Mp7JrsFactory::CloneObject(tmp->GetTitleType_type_LocalType0()));
		return;
	}
	if(tmp->GetTitleType_type_LocalType1() != Mp7JrsTitleType_type_Local1Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		this->SetTitleType_type_LocalType1(Mp7JrsFactory::CloneObject(tmp->GetTitleType_type_LocalType1()));
		return; 
	}
	}
}

Mp7JrsNodePtr Mp7JrsTitleType_type_LocalType2::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsTitleType_type_LocalType2::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsTitleType_type_LocalType::Enumeration Mp7JrsTitleType_type_LocalType2::GetTitleType_type_LocalType() const
{
	return m_TitleType_type_LocalType;
}

Mp7JrsTitleType_type_Local0Ptr Mp7JrsTitleType_type_LocalType2::GetTitleType_type_LocalType0() const
{
	return m_TitleType_type_LocalType0;
}

Mp7JrsTitleType_type_Local1Ptr Mp7JrsTitleType_type_LocalType2::GetTitleType_type_LocalType1() const
{
	return m_TitleType_type_LocalType1;
}

void Mp7JrsTitleType_type_LocalType2::SetTitleType_type_LocalType(Mp7JrsTitleType_type_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTitleType_type_LocalType2::SetTitleType_type_LocalType().");
	}
	if (m_TitleType_type_LocalType != item)
	{
		// nothing to free here, hopefully
		m_TitleType_type_LocalType = item;
	// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType0);
	m_TitleType_type_LocalType0 = Mp7JrsTitleType_type_Local0Ptr();
	// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType1);
	m_TitleType_type_LocalType1 = Mp7JrsTitleType_type_Local1Ptr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsTitleType_type_LocalType2::SetTitleType_type_LocalType0(const Mp7JrsTitleType_type_Local0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTitleType_type_LocalType2::SetTitleType_type_LocalType0().");
	}
	if (m_TitleType_type_LocalType0 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType0);
		m_TitleType_type_LocalType0 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TitleType_type_LocalType0) m_TitleType_type_LocalType0->SetParent(m_myself.getPointer());
		if (m_TitleType_type_LocalType0 && m_TitleType_type_LocalType0->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TitleType_type_LocalType0"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TitleType_type_LocalType0->UseTypeAttribute = true;
		}
		if(m_TitleType_type_LocalType0 != Mp7JrsTitleType_type_Local0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TitleType_type_LocalType0->SetContentName(XMLString::transcode("TitleType_type_LocalType0"));
		}
	
	m_TitleType_type_LocalType = Mp7JrsTitleType_type_LocalType::UninitializedEnumeration;
	// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType1);
	m_TitleType_type_LocalType1 = Mp7JrsTitleType_type_Local1Ptr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsTitleType_type_LocalType2::SetTitleType_type_LocalType1(const Mp7JrsTitleType_type_Local1Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTitleType_type_LocalType2::SetTitleType_type_LocalType1().");
	}
	if (m_TitleType_type_LocalType1 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType1);
		m_TitleType_type_LocalType1 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TitleType_type_LocalType1) m_TitleType_type_LocalType1->SetParent(m_myself.getPointer());
		if (m_TitleType_type_LocalType1 && m_TitleType_type_LocalType1->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TitleType_type_LocalType1"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TitleType_type_LocalType1->UseTypeAttribute = true;
		}
		if(m_TitleType_type_LocalType1 != Mp7JrsTitleType_type_Local1Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TitleType_type_LocalType1->SetContentName(XMLString::transcode("TitleType_type_LocalType1"));
		}
	
	m_TitleType_type_LocalType = Mp7JrsTitleType_type_LocalType::UninitializedEnumeration;
	// Mp7JrsFactory::DeleteObject(m_TitleType_type_LocalType0);
	m_TitleType_type_LocalType0 = Mp7JrsTitleType_type_Local0Ptr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsTitleType_type_LocalType2::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("TitleType_type_LocalType0")) == 0)
	{
		// TitleType_type_LocalType0 is simple element TitleType_type_LocalType0
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTitleType_type_LocalType0()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TitleType_type_LocalType0")))) != empty)
			{
				// Is type allowed
				Mp7JrsTitleType_type_Local0Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTitleType_type_LocalType0(p, client);
					if((p = GetTitleType_type_LocalType0()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TitleType_type_LocalType1")) == 0)
	{
		// TitleType_type_LocalType1 is simple element TitleType_type_LocalType1
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTitleType_type_LocalType1()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TitleType_type_LocalType1")))) != empty)
			{
				// Is type allowed
				Mp7JrsTitleType_type_Local1Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTitleType_type_LocalType1(p, client);
					if((p = GetTitleType_type_LocalType1()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for TitleType_type_LocalType2
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "TitleType_type_LocalType2");
	}		
	
	return result;
}

XMLCh * Mp7JrsTitleType_type_LocalType2::ToText() const
{
	if(m_TitleType_type_LocalType != Mp7JrsTitleType_type_LocalType::UninitializedEnumeration)
	{
		return Mp7JrsTitleType_type_LocalType::ToText(m_TitleType_type_LocalType);
	}
	if(m_TitleType_type_LocalType0 != Mp7JrsTitleType_type_Local0Ptr())
	{
		return m_TitleType_type_LocalType0->ToText();
	}
	if(m_TitleType_type_LocalType1 != Mp7JrsTitleType_type_Local1Ptr())
	{
		return m_TitleType_type_LocalType1->ToText();
	}
	return XMLString::transcode("");
}


bool Mp7JrsTitleType_type_LocalType2::Parse(const XMLCh * const txt)
{
	// Parse stu enumeration
	{
		Mp7JrsTitleType_type_LocalType::Enumeration tmp = Mp7JrsTitleType_type_LocalType::Parse(txt);
		if(tmp != Mp7JrsTitleType_type_LocalType::UninitializedEnumeration)
		{
			this->SetTitleType_type_LocalType(tmp);
			return true;
		}
	}
	// Parse stu pattern type
	{
		Mp7JrsTitleType_type_Local0Ptr tmp = CreateTitleType_type_LocalType0;
		if(tmp->Parse(txt))
		{
			this->SetTitleType_type_LocalType0(tmp);
			return true;
		}
		Mp7JrsFactory::DeleteObject(tmp);
	}
	// Parse stu factory type
	{
		Mp7JrsTitleType_type_Local1Ptr tmp = CreateTitleType_type_LocalType1;
		if(tmp->Parse(txt))
		{
			this->SetTitleType_type_LocalType1(tmp);
			return true;
		}
		Mp7JrsFactory::DeleteObject(tmp);
	}
	return false;
}

bool Mp7JrsTitleType_type_LocalType2::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsTitleType_type_LocalType2 has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsTitleType_type_LocalType2::ContentToString() const
{
	// Mp7JrsTitleType_type_LocalType2 has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsTitleType_type_LocalType2::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("TitleType_type_LocalType2"));
	// Element serialization:
	if(m_TitleType_type_LocalType != Mp7JrsTitleType_type_LocalType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsTitleType_type_LocalType::ToText(m_TitleType_type_LocalType);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("TitleType_type_LocalType"), false);
		XMLString::release(&tmp);
	}
	if(m_TitleType_type_LocalType0 != Mp7JrsTitleType_type_Local0Ptr()) // Pattern FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Pattern
		// CON contentname already set in element setter -- not needed here
//		XMLCh * contentname = XMLString::transcode("TitleType_type_LocalType0");
//		m_TitleType_type_LocalType0->SetContentName(contentname);
		m_TitleType_type_LocalType0->UseTypeAttribute = this->UseTypeAttribute;
		m_TitleType_type_LocalType0->Serialize(doc, element);
	}
	// Class
	
	if (m_TitleType_type_LocalType1 != Mp7JrsTitleType_type_Local1Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TitleType_type_LocalType1->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TitleType_type_LocalType1"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TitleType_type_LocalType1->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsTitleType_type_LocalType2::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("TitleType_type_LocalType"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TitleType_type_LocalType")) == 0))
        {
            Mp7JrsTitleType_type_LocalType::Enumeration tmp = Mp7JrsTitleType_type_LocalType::Parse(Mp7JrsUtil::GetElementText(parent));
            if(tmp == Mp7JrsTitleType_type_LocalType::UninitializedEnumeration)
            {
                    return false;
            }
            this->SetTitleType_type_LocalType(tmp);
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize pattern element
	if(Mp7JrsUtil::HasNodeName(parent, X("TitleType_type_LocalType0"), X("urn:mpeg:mpeg7:schema:2004")))
//	        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TitleType_type_LocalType0")) == 0))
        {
            Mp7JrsTitleType_type_Local0Ptr tmp = CreateTitleType_type_LocalType0;
            tmp->Deserialize(doc, parent, current);
            this->SetTitleType_type_LocalType0(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TitleType_type_LocalType1"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TitleType_type_LocalType1")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTitleType_type_LocalType1;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTitleType_type_LocalType1(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType2_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsTitleType_type_LocalType2::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("TitleType_type_LocalType0")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTitleType_type_LocalType0;
    }
    this->SetTitleType_type_LocalType0(child);
  }
  if (XMLString::compareString(elementname, X("TitleType_type_LocalType1")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTitleType_type_LocalType1;
    }
    this->SetTitleType_type_LocalType1(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsTitleType_type_LocalType2::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTitleType_type_LocalType0() != Mp7JrsNodePtr())
		result.Insert(GetTitleType_type_LocalType0());
	if (GetTitleType_type_LocalType1() != Mp7JrsNodePtr())
		result.Insert(GetTitleType_type_LocalType1());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsTitleType_type_LocalType2_ExtMethodImpl.h


