
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType_ExtImplInclude.h


#include "Mp7JrsWordFormType_type_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsWordFormType_type_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsWordFormType_type_LocalType::ToText(Mp7JrsWordFormType_type_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/noun:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("noun");
			break;
		case /*Enumeration::*/pronoun:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("pronoun");
			break;
		case /*Enumeration::*/adjective:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("adjective");
			break;
		case /*Enumeration::*/verb:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("verb");
			break;
		case /*Enumeration::*/adverb:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("adverb");
			break;
		case /*Enumeration::*/conjunction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("conjunction");
			break;
		case /*Enumeration::*/preposition:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("preposition");
			break;
		case /*Enumeration::*/postposition:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("postposition");
			break;
		case /*Enumeration::*/article:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("article");
			break;
		case /*Enumeration::*/interjection:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("interjection");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsWordFormType_type_LocalType::Enumeration Mp7JrsWordFormType_type_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsWordFormType_type_LocalType::Enumeration result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "noun") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/noun;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "pronoun") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/pronoun;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "adjective") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/adjective;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "verb") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/verb;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "adverb") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/adverb;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "conjunction") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/conjunction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "preposition") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/preposition;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "postposition") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/postposition;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "article") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/article;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "interjection") == 0)
	{
		result = Mp7JrsWordFormType_type_LocalType::/*Enumeration::*/interjection;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
