
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrssynthesisType_ExtImplInclude.h


#include "Mp7JrssynthesisType.h"

// no includefile for extension defined 
// file Mp7JrssynthesisType_ExtMethodImpl.h


const XMLCh * Mp7JrssynthesisType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrssynthesisType::ToText(Mp7JrssynthesisType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/none:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("none");
			break;
		case /*Enumeration::*/dependency:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("dependency");
			break;
		case /*Enumeration::*/forward:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("forward");
			break;
		case /*Enumeration::*/backward:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("backward");
			break;
		case /*Enumeration::*/coordination:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("coordination");
			break;
		case /*Enumeration::*/apposition:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("apposition");
			break;
		case /*Enumeration::*/repair:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("repair");
			break;
		case /*Enumeration::*/error:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("error");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrssynthesisType::Enumeration Mp7JrssynthesisType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrssynthesisType::Enumeration result = Mp7JrssynthesisType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "none") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/none;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "dependency") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/dependency;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "forward") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/forward;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "backward") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/backward;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "coordination") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/coordination;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "apposition") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/apposition;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "repair") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/repair;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "error") == 0)
	{
		result = Mp7JrssynthesisType::/*Enumeration::*/error;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
